#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
static int read_parameter(int argcount, char **argvec);
static void help (void);
char seedlink[100];
char stasjon[100];
char record[100];
char nw[10];
char stat[10];
char loc[10];
char cmp[10];
char comp[10];
float fl = 2.0;
float fh = 8.0;
int   minutter = 5;
int   xlenght = 1200;
int   yheight = 300;

main(int argc, char **argv)
{
  char *topdir_rt = 0;                   // top directory RTQUAKE  
  char syscmd[200];
  char com1[200];
  char com2[200];
  char strpath[200];
  int  ret;
  int  br;
  int  ne=0;
  FILE *in;
  FILE *out;
  int len;
//------------------------------------------------------------------------
// set path to RTQUAKE_TOP as default
//------------------------------------------------------------------------
  topdir_rt = (char*)getenv("RTQUAKE_TOP");
  if (topdir_rt)
  {
    printf("RTCHK: RTQUAKE_TOP:		%s\n", topdir_rt);
  }else{
    printf("RTCHK: RTQUAKE_TOP not defined\n");
    printf("Include setup_rt.bash or setup_rt.csh in your .bashrc or .csh\n");
    exit(0);      
  }
  sprintf(strpath,"%s/par/CHK/rtsl_config",topdir_rt);
//-------------------------------------------------------------------------
// Process command line parameters
//-------------------------------------------------------------------------
  if (read_parameter(argc, argv) < 0)
  {
    printf("RTCHK: Parameter processing failed\n\n");
    printf("       Try '-h' for help\n");
    exit(0);
  } 
  sprintf(syscmd,"rm rt_parfile_99");
  ret = system(syscmd);
  sprintf(syscmd,"slinktool -Q %s | grep %c%s%c | cut -c 1-15 | grep %c%s%c > rt_parfile_99",seedlink,0x22,stasjon,0x22,0x22,comp,0x22);
  printf("%s\n",syscmd);
  ret = system(syscmd);
  in = fopen("rt_parfile_99","r");
  if(in == NULL)
  {
    printf("No data from specified station or seedlink server\n");
    exit(0);
  }
  out = fopen(strpath,"w");
  fprintf(out,"SERVERS\n");
  fprintf(out,"S01 %s\n",seedlink);
  fprintf(out,"-------------------------------\n");
  fprintf(out,"NW STAT  LOC CMP SERVER\n");
  for(;;)
  {
    br = les_linje(in,record);
    if(br==1)
      break;
    printf("%s\n",record);
    ne++;
    if(record[9] == ' ' && record[10] == ' ')
    {
      sscanf(record,"%s %s %s",nw,stat,cmp);
      sprintf(loc,"..");
    }else{
      sscanf(record,"%s %s %s %s",nw,stat,loc,cmp); 
    }
    len=strlen(stat);
    switch(len)
    {
      case 2:
      fprintf(out,"%s %s    %s  %s S01\n",nw,stat,loc,cmp);
      break;
      case 3:
      fprintf(out,"%s %s   %s  %s S01\n",nw,stat,loc,cmp);
      break;
      case 4:
      fprintf(out,"%s %s  %s  %s S01\n",nw,stat,loc,cmp);
      break;
      case 5:
      fprintf(out,"%s %s %s  %s S01\n",nw,stat,loc,cmp);
      break;      
    }

  }

//  printf("ne: %d\n",ne);
  fprintf(out,"--------------------------------\n");
  fclose(in);
//  printf("br: %d\n",br);
  fclose(out);
  if(ne == 0)
  {
    printf("Station %s not found on server or Seedlink address wrong.\n",stat);
    exit(0);
  }else{
    if(ne <= 6)
    {
      sprintf(com1,"rtchk1 -d -x %d -y %d -col 2 -m %d -cfg CHK &",xlenght,yheight,minutter);
      
      sprintf(com2,"rtchk1 -yo %d -x %d -y %d -fl %7.3f -fh %7.3f -m %d -cfg CHK &",yheight+53,xlenght,yheight,fl,fh,minutter);
      ret = system(com1);
      sleep(1);
      ret = system(com2);
    }else{
      printf("More than 6 availlable components, use -cm to specify\n");
      exit(0);
    }
  }
}
/***************************************************************************
 * read_parameter:
 *
 * Process the command line parameters.
 *
 * Returns 0 on success, and -1 on failure
 ***************************************************************************/
static int
read_parameter(int argcount, char **argvec)
{
  int optind;
  int error = 0;

  if (argcount <= 1)
  {
//    help();
    return(-1);
  }
//printf("argcount: %d error: %d\n",argcount,error);
  /* Process all command line arguments */
  for (optind = 1; optind < argcount; optind++)
  {
    if (strcmp (argvec[optind], "-h") == 0)
    {
      help();
      exit (0);
    }
    else if (strcmp (argvec[optind], "-sl") == 0)         // input config file
    {
      strcpy(seedlink, argvec[++optind]);

        printf("SeedLink: %s\n",seedlink);
    }          
    else if (strcmp (argvec[optind], "-st") == 0)         // input config file
    {
      strcpy(stasjon, argvec[++optind]);

        printf("Station: %s\n",stasjon);
    }  
    else if (strcmp (argvec[optind], "-cm") == 0)         // input config file
    {
      strcpy(comp, argvec[++optind]);

        printf("Component: %s\n",comp);
    }
    else if (strcmp (argvec[optind], "-fl") == 0)         // input config file
    {
      fl = atof (argvec[++optind]);      
      printf("FL: %7.3f\n",fl);
    } 
    else if (strcmp (argvec[optind], "-fh") == 0)         // input config file
    {
      fh = atof (argvec[++optind]);
      printf("FH: %7.3f\n",fh);
    }
    else if (strcmp (argvec[optind], "-m") == 0)
    {
	minutter = atoi (argvec[++optind]);
    }
      else if (strcmp (argvec[optind], "-x") == 0)
      {
	  xlenght = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-y") == 0)
      {
	  yheight = atoi(argvec[++optind]);
      }    
      else if (strncmp (argvec[optind], "-", 1 ) == 0)
      {
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
      }

      else
      {
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
      }
  }


  
  return 0;
}				/* End of parameter_proc() */
//------------------------------------------------------------------------
// help
//------------------------------------------------------------------------
static void
help (void)
{
  fprintf(stderr,
    "Valid program options:\n"
    "-h               show this help info\n"
    "-sl text         Seedlink address\n"
    "-st text         Station name to check, f.ex. BER\n"
    "-cm text         Component(s), f.ex. BH or HH or HHZ\n"
    "-fl real         Lowpass filter (default: 2.0)\n"
    "-fh real         Highpass filter (default: 8.0)\n"
    "-m  minutes      Minutes to plot,1,2,3,4,5,10,15,30,60 (default: 5)\n"
    "-x  pixels       Width of window in pixels (default: 1200)\n"
    "-y  pixels       Height of window in pixels (default: 300)\n"
    "\n");
}
//------------------------------------------------------------------------
// les_linje(
//
// read s-file lines
//------------------------------------------------------------------------
les_linje(FILE *streamfp,char linje[])
{
  int l;
  int br;
  br=0;
  for(l=0;l<85;l++)
  {
    linje[l]=fgetc(streamfp);
    if(linje[l] == 0xa && l == 0)
    {
      br=2;
      break;
    }
    if(linje[l] == 0xa && l > 0)
    {
      linje[l]='\0';
      break;        
    }
    if(linje[l] == EOF)
    {
//      printf("End of file. File contains: %2d items\n",i);

      br=1;
      return(br);
    }
  }
  return(br);
}                        // les_linje