#pragma ident "$Id: threshold.c,v 1.2 2003/11/19 23:42:42 dechavez Exp $"
/*======================================================================
 *
 * Manipulate logging threshold
 *
 *====================================================================*/
#include "logio.h"

int logioThreshold(LOGIO *lp)
{
int retval;

    if (lp == NULL) {
        errno = EINVAL;
        return -1;
    }

    MUTEX_LOCK(&lp->mutex);
        retval = lp->threshold;
    MUTEX_UNLOCK(&lp->mutex);

    return retval;
}

int logioSetThreshold(LOGIO *lp, int value)
{

    if (lp == NULL) {
        errno = EINVAL;
        return -1;
    }

    if (logioIntToSeverityString(value) == NULL) return -1;
    MUTEX_LOCK(&lp->mutex);
        lp->threshold = value;
    MUTEX_UNLOCK(&lp->mutex);

    return value;
}

VOID logioSetPrefix(LOGIO *lp, CHAR *prefix)
{
    if (lp == NULL) return;

    MUTEX_LOCK(&lp->mutex);
        memcpy(lp->prefix, prefix, LOGIO_MAX_PREFIX_LEN);
        lp->prefix[LOGIO_MAX_PREFIX_LEN] = 0;
    MUTEX_UNLOCK(&lp->mutex);
}

BOOL logioIsAbsolutePath(CHAR *path)
{
    if (path == NULL) return FALSE;
    if (path[0] == '/') return TRUE;
    if (strcasecmp(path, "-") == 0) return TRUE;
    if (strcasecmp(path, "stdout") == 0) return TRUE;
    if (strcasecmp(path, "stderr") == 0) return TRUE;
    return FALSE;
}

/* Revision History
 *
 * $Log: threshold.c,v $
 * Revision 1.2  2003/11/19 23:42:42  dechavez
 * better argument checking
 *
 * Revision 1.1  2003/06/09 23:48:00  dechavez
 * initial release
 *
 */
