#pragma ident "$Id: timer.c,v 1.1 2003/10/16 16:07:54 dechavez Exp $"
/*======================================================================
 *
 *  timers
 *
 *====================================================================*/
#include "util.h"

VOID utilDelayMsec(UINT32 interval)
{
#ifdef unix
int status;
struct timespec rqtp, rmtp;

    rqtp.tv_sec = (time_t) interval / 1000;
    rqtp.tv_nsec = (long) (1000000 * (interval % 1000));

    do {
        status = nanosleep(&rqtp, &rmtp);
        if (status != 0) {
            if (errno != EINTR) return;
            rqtp = rmtp;
        }
    } while (status != 0);
#else
    Sleep(interval);
#endif
    return;
}

/* Revision History
 *
 * $Log: timer.c,v $
 * Revision 1.1  2003/10/16 16:07:54  dechavez
 * initial release
 *
 */
