#!/usr/bin/perl

print"make_cfg_shm.pl version 159.2004\n";
if($#ARGV < 0)
{
   print"Usage: make_cfg_shm.pl <netfile>\n";
   exit;
}

$net_file = @ARGV[0];

$shroot = "$ENV{SEISCOMP_ROOT}/analysis/sh";
$instdb = "$ENV{SEISCOMP_ROOT}/config/inst.db";
$statlist = "$shroot/globals/STATLIST";
$statlist_stx = "$statlist\_DEFAULT.STX";
$filter_lkp = "$shroot/inputs/filter_lookup.txt";
$statinf_dat = "$shroot/inputs/STATINF.DAT";
$refstat_lst = "$shroot/globals/refstation_list.txt";
$calib_dir = "$shroot/source/seed_io/inputs";

print"Content of network table: \n\n";
open (FILE_IN, "$net_file") || die "File problem: $!\n";

$nostat = -1;
$nonet = -1;
$stop = 0;
while ($stop == 0)
{
   if($line = <FILE_IN>) {$stop = 0;}else{$stop = 2;}
   #print"line: $stop|$line|";
   if($stop == 0)
   {
      if(substr($line,0,1) eq "#")
      {
         $str_typ = "com";
      }else{
         $line =~ s/^[ \t]+//;
         $line =~ s/[ \t]+/ /g;
         @list = split(" ",$line);
         #print"@list\n";
         if($#list < 6)
         {
            $str_typ = "net";
         }else{
            $str_typ = "stat";
         }
      }
      if($str_typ eq "net")
      {
	 $nonet++;
         @full_project[$nonet] = @list[0];
         @project[$nonet] = @list[1];
         @net[$nonet] = @list[2];
         @dc_name[$nonet] = @list[3];
         #@dcc[$nonet] = @list[4];
         @form_net[$nonet] = @list[4];
         if(@form_net[$nonet] eq "") {@form_net[$nonet] = 0;}
	 @nst_net[$nonet] = -1;
      }
      if($str_typ eq "stat")
      {
         $nostat++;
	 @netstat[$nostat] = @net[$nonet];
         @stat[$nostat] = @list[0];
	 if(@stat[$nostat] ne $lstat) {@nst_net[$nonet]++;}
	 $lstat = @stat[$nostat];
         @statnam[$nostat] = @list[1];
         $dlg_str = @list[2];
         @dlg[$nostat] = (split("%",$dlg_str))[0];
         @dlgsn[$nostat] = (split("%",$dlg_str))[1];
         #print"dlg:|$dlg_str|@dlg[$nostat]|@dlgsn[$nostat]|\n";
         $st = grep(/@dlg[$nostat]/,$dlg_list);
         if($st == 0)
         {
	    if($nostat == 0)
	    {
	       $dlg_list = "@dlg[$nostat]";
	    }else{
	       $dlg_list = "$dlg_list @dlg[$nostat]";
	    }
         }
         $seis_str = @list[3];
         @seis[$nostat] = (split("%",$seis_str))[0];
         @seisn[$nostat] = (split("%",$seis_str))[1];
         @gain_mpl[$nostat] = @list[4];
         $st = grep(/@seis[$nostat]/,$seis_list);
         if($st == 0)
         {
	    if($nostat == 0)
	    {
	       $seis_list = "@seis[$nostat]";
	    }else{
	       $seis_list = "$seis_list @seis[$nostat]";
	    }
         }

         $inst_str = "@dlg[$nostat]%@seis[$nostat]";
         $st = grep(/$inst_str/,$inst_list);
         if($st == 0)
         {
	    if($nostat == 0)
	    {
	       $inst_list = $inst_str;
	    }else{
	       $inst_list = "$inst_list $inst_str";
	    }
         }

         $xxx = @list[5];
	 if(grep(/_/,$xxx) > 0)
	 {
	    @rate[$nostat] = (split("_",$xxx))[1];
	    $yyy = (split("_",$xxx))[0];
	    if(grep(/F/,$yyy) > 0)
	    {
	       $ind = index($yyy,"F");
	       @form[$nostat] = substr($yyy,$ind+1,1);
	    }else{
	       @form[$nostat] = 0;
	    }
	    if(grep(/L/,$yyy) > 0)
	    {
	       $ind = index($yyy,"L");
	       @loca[$nostat] = substr($yyy,$ind+1,2);
	    }else{
	       @loca[$nostat] = "";
	    }
	    if(grep(/T/,$yyy) > 0)
	    {
	       $ind = index($yyy,"T");
	       @type[$nostat] = substr($yyy,$ind+1,1);
	    }else{
	       @type[$nostat] = "H";
	    }
         }else{
            @rate[$nostat] = $xxx;
            @loca[$nostat] = "";
            @type[$nostat] = "H";
            @form[$nostat] = 0;
         }
         $st = grep(/@form[$nostat]/,$form_list);
         if($st == 0)
         {
	    if($nostat == 0)
	    {
	       $form_list = "@form[$nostat]";
	    }else{
	       $form_list = "$form_list @form[$nostat]";
	    }
         }
 
	 @lat[$nostat] = @list[6];
         @lon[$nostat] = @list[7];
         @alt[$nostat] = @list[8];
         @depth[$nostat] = @list[9];
         @startdate[$nostat] = @list[10];
         @enddate[$nostat] = @list[11];
         if(@enddate[$nostat] eq "") {@enddate[$nostat] = "2038/001";}
         @firfl[$nostat] = "0/0";
         print"@stat[$nostat] @statnam[$nostat] @dlg[$nostat] @dlgsn[$nostat] @seis[$nostat] @seisn[$nostat] @lat[$nostat] @lon[$nostat] @alt[$nostat] @startdate[$nostat]\n";
      }
   }
}
close FILE_IN;

print"\nTry to create network buttons in \$SH_GLOBALS/STATLIST_DEFAULT.STX\n";

#$st = qx(ls $statlist_stx 2>&1);
$ans = "y";
#if(grep(/No such/,$st) == 1)
#{
#   print"File $statlist_stx exists - overwrite ([y]/n)? ";
#   $ans =  <STDIN>;
#   if($ans eq "\n") {$ans = "y";}
#   if($ans ne "y") {exit;}
#}

if($ans eq "y")
{
 $nt = -1;
 $nt1 = 0;
 $nn = -1;
 $ie = -1;
 $nset = 0;
 open (FILE_OUT, ">$statlist_stx") || die "File problem: $!\n";
 print FILE_OUT "!
!  STATLIST_DEFAULT.STX file for network @project[0]
!  - automatically generated by make_cfg_shm -
!\n";
foreach $stat (@stat)
{
   $nn++;
   if($nt == -1 || $nn > @nst_net[$nt])
   {
      $nt++;
      $nt1++;
      $net = @net[$nt];
      $net_nam = "$net-Net";
      if($nt1 > 2)
      {
         close FILE_OUT;
         $nset++;
	 $ie = -1;
	 $nt1 = 1;
	 $statlist_stx = "$statlist\_0$nset\.STX";
	 open (FILE_OUT, ">$statlist_stx") || die "File problem: $!\n";
	 print FILE_OUT "!
!  STATLIST_DEFAULT.STX file for network $net-Net
!  - automatically generated by make_cfg_shm -
!\n";
      }
      $ia = $ie + 1;
      $ie = $ia + $nst_net[$nt];
      print FILE_OUT "\nset$nt1: $ia $ie $net_nam
\n";
      $nn = 0;
  }
   if($stat ne $lstat) {print FILE_OUT "* $stat\n";}
   $lstat = $stat;
 }
 close FILE_OUT;
}

print"\nTry to create filter relations in \$SH_INPUTS/filter_lookup.txt\n";

#$st = qx(ls $filter_lkp 2>&1);
$ans = "y";
#if(grep(/No such/,$st) == 1)
#{
#   print"File $filter_lkp exists - overwrite ([y]/n)? ";
#   $ans =  <STDIN>;
#   if($ans eq "\n") {$ans = "y";}
#   if($ans ne "y") {exit;}
#}

if($ans eq "y")
{
   open (FILE_OUT, ">$filter_lkp") || die "File problem: $!\n";
   print FILE_OUT "!
!  filter_lookup.txt file for network @project[0]
!  - automatically generated by make_cfg_shm -
!
\n";

   $nn=-1;
   foreach $stat (@stat)
   {
      $nn++;
      $seis = @seis[$nn];
      if(index($seis,"STS-2") >= 0) {$seis="STS2";}
      if(index($seis,"STS-1") >= 0) {$seis="STS1";}
      if(index($seis,"LE-3D/20") >= 0) {$seis="LE20";}
      $st = qx((ls $shroot/filter | grep $seis) 2>&1);
      if($st eq "") {print "No filter files found for $seis - please create them!\n";}
      @ratex = split("/",@rate[$nn]);
      $type = @type[$nn];
      foreach $rate (@ratex)
      {  
         if(grep(/[A-Z]/,$rate) > 0)
         {
            $chan = substr($rate,0,1);
            $rate = substr($rate,1,);
         }else{
            if($rate >= 80) {$chan = "H";}
            if($rate >= 40 && $rate < 80) {$chan = "S";}
            if($rate > 1 && $rate <= 20) {$chan = "B";}
            if($rate == 1) {$chan = "L";}
            if($rate == 0.1) {$chan = "V";}
         }
         print "Create filter_lookup for station $stat and seismometer $seis\n";
         print FILE_OUT "$stat-$chan$type-Z $seis
$stat-$chan$type-N $seis
$stat-$chan$type-E $seis
\n";
      }
   }
   close FILE_OUT;
}

print"\nTry to create station info file in \$SH_INPUTS/STATINF.DAT\n";

#$st = qx(ls $statinf_dat 2>&1);
$ans = "y";
#if(grep(/No such/,$st) == 1)
#{
#   print"File $statinf_dat exists - overwrite ([y]/n)? ";
#   $ans =  <STDIN>;
#   if($ans eq "\n") {$ans = "y";}
#   if($ans ne "y") {exit;}
#}

if($ans eq "y")
{
   open (FILE_OUT, ">$statinf_dat") || die "File problem: $!\n";
   print FILE_OUT "!
!  STATINF.DAT file for network @project[0]
!  - automatically generated by make_cfg_shm -
!
\n";

   $nn=-1;
   foreach $stat (@stat)
   {
      $nn++;
      print FILE_OUT "$stat lat: @lat[$nn] lon: @lon[$nn] elevation: @alt[$nn] name: @statnam[$nn]\n";
   }
   close FILE_OUT;
}

print"\nTry to create seed_calibration files in \$SEED_INPUTS\n";

#print"Ok to overwrite existing calibration files ([y]/n)? ";
$ans = "y";
#$ans =  <STDIN>;
#if($ans eq "\n") {$ans = "y";}
if($ans eq "y")
{
   $nn = -1;
   foreach $stat (@stat)
   {
      $statl = lc($stat);
      $nn++;

      $start_date = @startdate[$nn];
      $syear = (split("/",$start_date))[0];
      $sdoy = (split("/",$start_date))[1];
      ($sday, $smon) = split_doy_lm($syear, $sdoy);
      $start_date = "$sday-$smon-$syear";
      $end_date = @enddate[$nn];
      $eyear = (split("/",$end_date))[0];
      $edoy = (split("/",$end_date))[1];
      ($eday, $emon) = split_doy_lm($eyear, $edoy);
      $end_date = "$eday-$emon-$eyear";

      $seis = @seis[$nn];
      $sgain = get_inst_param($seis, "seis_gain");
      $dlog = @dlg[$nn];
      $dgain = get_inst_param($dlog,"dlg_gain");
      $dlgain = $dgain * @gain_mpl[$nn];
      $firfl = get_inst_param($dlog,"dlg_fir");
      $firnam = get_inst_param($dlog, "dlg_fir_name");
      if($firnam ne "") {@fir = qx(grep $firnam $instdb | grep 'FIR_' | cut -d '>' -f 1);}
      #print"$seis $dlog $firfl @fir\n";

      @ratex = split("/",@rate[$nn]);
      $type = lc(@type[$nn]);
      foreach $rate (@ratex)
      {  
         if(grep(/[A-Z]/,$rate) > 0)
         {
            $chan = substr($rate,0,1);
            $rate = substr($rate,1,);
         }else{
            if($rate >= 80) {$chan = "H";}
            if($rate >= 40 && $rate < 80) {$chan = "S";}
            if($rate > 1 && $rate <= 20) {$chan = "B";}
            if($rate == 1) {$chan = "L";}
            if($rate == 0.1) {$chan = "V";}
         }

	 $fgain = 1.0;
         if($firfl ne "")
         {
            @firx = split(",",$firfl);
            foreach $firx (@firx)
            {
	       $frat = (split("_",$firx))[0];
	       #print"fir0: $firx $rate $chan $frat\n";
	       if($frat eq $rate)
	       {
                  $firs = (split("_",$firx))[1];
	          @firz = split("/",$firs);
	          #print"fir1: $loch $firfl $firx $firs @firz\n";
	          $n = -1;
                  foreach $nfir (@firz)
                  {
	             $n++;
	             $fir = @fir[$nfir - 1];
		     chomp $fir;
	             $fgain = $fgain * get_inst_param("$fir", "fir_gain");
                  }
	       }
            }
         }
         $gain = 1.e9 / ($dlgain * $fgain * $sgain);
	 printf "$statl\-$chanl$type gain: 1.e9 / ($dlgain * $fgain * $sgain) = %6.3f\n", $gain;

	 $chanl = lc($chan);
         $calib_file = "$calib_dir/seedcalib\_$statl\-$chanl$type";
         open (FILE_OUT1, ">$calib_file\-z") || die "File problem: $!\n";
         open (FILE_OUT2, ">$calib_file\-n") || die "File problem: $!\n";
         open (FILE_OUT3, ">$calib_file\-e") || die "File problem: $!\n";
         printf FILE_OUT1 "%s %s %6.3f\n", $start_date, $end_date, $gain;
         printf FILE_OUT2 "%s %s %6.3f\n", $start_date, $end_date, $gain;
         printf FILE_OUT3 "%s %s %6.3f\n", $start_date, $end_date, $gain;
	 close FILE_OUT1;
	 close FILE_OUT2;
	 close FILE_OUT3;
      }
   }
}

exit;
sub split_doy_lm {

local (@Mon = (0,31,28,31,30,31,30,31,31,30,31,30,31));
local (@lmon = (Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec));
local ($year = $_[0]);
local ($idoy = $_[1]);
local ($mon = 0);
local ($day = 0);
local ($doy = 0);
local $i;

#print "split_doy: $year $idoy\n";

$leap = int($year) - int(int(int($year) /4) *4);
if ($leap == 0) {$Mon[2] = 29};
#print"get_doy: $year $leap $Mon[2]\n";

$i = 0;
while ($doy < $idoy) {
        $i++;
        $doy = $doy + $Mon[$i];
        #print "$i $Mon[$i] $doy\n";
        }
$mon = $i;
$lmon = $lmon[$i-1];
$day = $idoy - $doy + $Mon[$i];
#print "$day $mon $lmon\n";

return ($day, $lmon);
}

sub get_inst_param
{
   local $inst = $_[0];
   local $name = $_[1];
   local $param, $string, @strng_list, @xxx, $xxx, $nxx, $yyy, $nzr, $zrs, $npl, $pls, $n, $nn, $nnn;

   #$string = qx(grep $inst $instdb | grep ">" 2>&1);
   $string = qx(grep "$inst>" $instdb 2>&1);
   $string =~ s/^[ \t]+//;
   $string =~ s/[ \t]+/ /g;
   @strng_list = split(" ",$string);
   #print"$inst $name $#strng_list @strng_list\n";

   if(index($string,"No such") < 0)
   {
      if(index($inst,"Sngl-gain") >= 0)
      {
         $param = (split(" ",$string))[$name];
      }

      if($name eq "dlg_name")
      {
         $param = @strng_list[0];
	 $param = (split(">",$param))[0];
      }
      if($name eq "dlg_key")
      {
	 @dlg_list = split(" ",$dlg_list);
	 $n = 0;
	 foreach $xxx (@dlg_list)
	 {
	    $n++;
	    if(grep(/$inst/,$xxx) == 1) {$param = $n;}
	 }
      }
      if($name eq "dlg_gain") {$param = @strng_list[1];}
      if($name eq "dlg_max_frq") {$param = @strng_list[2];}
      if($name eq "dlg_clock_drift") {$param = @strng_list[3];}
      if($name eq "dlg_fir_name") {$param = @strng_list[4];}
      if($name eq "dlg_fir")
      {
         if($#strng_list > 3)
         {
	    $param = @strng_list[5];
         }else{
	    $param = "";
         }
      }

      if($string ne "" && $name eq "digi_name")
      {        
         $xxx = (split(" ",$string))[0];
	 $xxx = (split(">",$xxx))[0];
	 $param = (split("\_digipaz",$xxx))[0];
	 $xxx = (split("digipaz\_",$xxx))[1];
	 $param = "$param\_$xxx";
      }
      if($name eq "digi_key" || $name eq "digi_paz")
      {
	 @digi_list = split(" ",$dlg_list);
	 $n = 0;
	 foreach $xxx (@digi_list)
	 {
	    $n++;
	    if(grep(/$inst/,"$xxx\_digipaz\_$rate") == 1) {$param = $n;}
	 }
      }
      if($name eq "digi_norm") {$param = (split(" ",$string))[1];}
      if($name eq "digi_nozr"){$param = (split(" ",$string))[2];}
      if($name eq "digi_nopl"){$param = (split(" ",$string))[3];}
      if($name eq "digi_zeros" || $name eq "digi_poles") 
      {
         @xxx = split(" ",$string);
         $nzr = @xxx[2];
	 $npl = @xxx[3];
	 $nxx = $#xxx - 3;
	 #print"nzr $nzr npl $npl nxx $nxx\n";
	 $n = 0;
	 $nn = 0;
	 $xxx = "";
	 while($n < $nxx)
	 {
	     $n++;
	     if(index(@xxx[$n+3],"\(")> 0)
	     {
	       $nm = (split("\\(",@xxx[$n+3]))[0];
	       $yyy = (split("\\(",@xxx[$n+3]))[1];
	       $yyy = "\($yyy";
	       $nnn = 0;
	       while($nnn < $nm){$nnn++; $nn++; $xxx = "$xxx $yyy";}
	    }else{
	       $nn++;
	       $xxx = "$xxx @xxx[$n+3]";
	    }	     
	    if($nn == $nzr) {$xxx =~ s/^[ \t]+//; $zrs = $xxx; $xxx = "";}
	 }
	 $xxx =~ s/^[ \t]+//;
	 $pls = $xxx;
	 #print"zeros |$zrs|\npoles |$pls|\n";
         if($name eq "digi_zeros"){$param = $zrs;}
         if($name eq "digi_poles"){$param = $pls;}
      }

      if($name eq "seis_name")
      {
         $param = (split(" ",$string))[0];
	 $param = (split(">",$param))[0];
      }
      if($name eq "seis_key" || $name eq "seis_paz")
      {
	 @seis_list = split(" ",$seis_list);
	 $n = 0;
	 foreach $xxx (@seis_list)
	 {
	    $n++;
	    if(grep(/$inst/,$xxx) == 1) {$param = $n;}
	 }
      }
      if($name eq "seis_gain") {$param = (split(" ",$string))[1];}
      if($name eq "seis_gain_frq") {$param = (split(" ",$string))[2];}
      if($name eq "seis_norm") {$param = (split(" ",$string))[3];}
      if($name eq "seis_norm_frq") {$param = (split(" ",$string))[4];}
      if($name eq "seis_nozr"){$param = (split(" ",$string))[5];}
      if($name eq "seis_nopl"){$param = (split(" ",$string))[6];}
      if($name eq "seis_zeros" || $name eq "seis_poles") 
      {
         @xxx = split(" ",$string);
         $nzr = @xxx[5];
	 $npl = @xxx[6];
	 $nxx = $#xxx - 6;
	 #print"nzr $nzr npl $npl nxx $nxx\n";
	 $n = 0;
	 $nn = 0;
	 $xxx = "";
	 while($n < $nxx)
	 {
	     $n++;
	     if(index(@xxx[$n+6],"\(")> 0)
	     {
	       $nm = (split("\\(",@xxx[$n+6]))[0];
	       $yyy = (split("\\(",@xxx[$n+6]))[1];
	       $yyy = "\($yyy";
	       $nnn = 0;
	       while($nnn < $nm){$nnn++; $nn++; $xxx = "$xxx $yyy";}
	    }else{
	       $nn++;
	       $xxx = "$xxx @xxx[$n+6]";
	    }	     
	    if($nn == $nzr) {$xxx =~ s/^[ \t]+//; $zrs = $xxx; $xxx = "";}
	 }
	 $xxx =~ s/^[ \t]+//;
	 $pls = $xxx;
	 #print"zeros |$zrs|\npoles |$pls|\n";
         if($name eq "seis_zeros"){$param = $zrs;}
         if($name eq "seis_poles"){$param = $pls;}
      }

      if($name eq "fir_name") {$param = (split(" ",$string))[1]};
      if($name eq "fir_symcode") {$param = (split(" ",$string))[2]};
      if($name eq "fir_nonm") {$param = (split(" ",$string))[3]};
      if($name eq "fir_nodn") {$param = (split(" ",$string))[4]};
      if($name eq "fir_irate") {$param = (split(" ",$string))[5]};
      if($name eq "fir_defac") {$param = (split(" ",$string))[6]};
      if($name eq "fir_offset") {$param = (split(" ",$string))[7]};
      if($name eq "fir_delay") {$param = (split(" ",$string))[8]};
      if($name eq "fir_gain") {$param = (split(" ",$string))[9]};
      if($name eq "fir_gain_frq") {$param = (split(" ",$string))[10]};

   }else{
      $param=-1;
   }

#print"$inst|$name|$param|\n";

   return $param;
}
