
/* file CAUSRDEF.H
 *      ==========
 *
 * version 2, 6-JUL-91
 *
 * prototypes of module CMDARGS.C
 * K. Stammler, 22-MAY-91
 */


#ifndef __CAUSRDEF
#define __CAUSRDEF

/*------------------------------------------------------------------------*/


void ca_prepare( int argnum, char *arg[] );

/* prepares arguments for processing
 *
 * parameters of routine
 * int      argnum;         input; number of arguments
 * char     *arg[];         modify; arguments
 */


/*------------------------------------------------------------------------*/


void ca_qint( int argnum, char *arg[], char name[], int cnt,
	int *ires, int *cntread );

/* get "cnt" integers or less from parameter
 *
 * parameters of routine
 * int      argnum;         input; number of arguments
 * char     *arg[];         input; arguments passed to program
 * char     name[];         input; name of integer field
 * int      cnt;            input; number of integers to read
 * int      *ires;          output; integers read from parameter
 * int      *cntread;       output; return status
 */


/*------------------------------------------------------------------------*/


void ca_qreal( int argnum, char *arg[], char name[], int cnt,
	float *rres, int *cntread );

/* get "cnt" reals or less from parameter
 *
 * parameters of routine
 * int      argnum;         input; number of arguments
 * char     *arg[];         input; arguments passed to program
 * char     name[];         input; name of integer field
 * int      cnt;            input; number of integers to read
 * float    *rres;          output; reals read from parameter
 * int      *cntread;       output; return status
 */


/*------------------------------------------------------------------------*/


void ca_qstr( int argnum, char *arg[], char name[], char str[] );

/* get string from parameter
 *
 * parameters of routine
 * int      argnum;        input; number of arguments
 * char     *arg[];        input; arguments passed to program
 * char     name[];        input; name of integer field
 * char     str[];         output; string read from parameter
 */


/*------------------------------------------------------------------------*/

#endif /* __CAUSRDEF */
