
/* file event_id.h
 *      ==========
 *
 * version 2, 10-Jan-94
 *
 * header file of module event_id.c
 * K. Stammler, 12-Sep-93
 */



/* error codes */
#define EieOFFSET         4700
#define EieSTROVFL        (EieOFFSET+1)     /* string overflow */
#define EieILL_LINE       (EieOFFSET+2)     /* illegal line in data file */
#define EieTABLE_OVFL     (EieOFFSET+3)     /* too many entries */
#define EieOPEN_OUTPUT    (EieOFFSET+4)     /* error opening output file */
#define EieEVID_OVFL      (EieOFFSET+5)     /* daily count overflow */



/* constants */
#define EiEV_FILE_PREFIX "evid"
	/* name prefix to event-id data files */
#define EiPAR_FILE_PREFIX "par"
	/* name prefix to parameter-id data files */
#define EiFILE_EXT ".txt"
	/* data file extension */
#define EiEV_FILE_LTH 12
	/* length of filenames (prefix + 4[year] + extension) */
#define EiPAR_FILE_LTH 11
	/* length of filenames (prefix + 4[year] + extension) */
#define EiCOMMENT_CHAR '!'
	/* comment character at beginning of line */



/*------------------------------------------------------------------*/


void EiSetPath( char path[], STATUS *status );

/* Sets path for event ID files
 *
 * parameters of routine
 * char       path[];       input; path name
 * STATUS     *status;      output; return status
 */


/*------------------------------------------------------------------*/


long EiGetEventID( char onset[], STATUS *status );

/* Returns unique event ID for event
 *
 * parameters of routine
 * char       onset[];       input; onset time of event
 * STATUS     *status;       output; return status
 *                           returns event ID
 */


/*------------------------------------------------------------------*/


long EiGetParameterID( char onset[], STATUS *status );

/* Returns unique parameter ID.
 *
 * parameters of routine
 * char       onset[];       input; onset time of event
 * STATUS     *status;       output; return status
 *                           returns event ID
 */


/*------------------------------------------------------------------*/
