
/* file partmotion.h
 *      ============
 *
 * version 1, 16-Nov-98
 *
 * Header file for module partmotion.c
 * K. Stammler, 16-Nov-98
 */



/* constants */
#define cPmmModeUndefined    0
#define cPmmModeLineColored  1
#define cPmmModeLineMono     2
#define cPmmModePlot1        3
#define cPmmModePlot3        4
#define cPmmModeZoomOn       5
#define cPmmModeZoomOff      6




/*----------------------------------------------------------------------------*/


void pmm_initialize( Widget parent, Widget pmwdw, TSyStatus *status );

/* initializes particle motion window
 *
 * parameters of routine
 * Widget     parent;      input; widget ID of root window
 * Widget     pmwdw;       input; Widget ID of particle motion window
 * TSyStatus  *status;     output; return status
 */


/*----------------------------------------------------------------------------*/


void pmm_close_window( void );

/* Closes particle motion window
 *
 * parameters of routine
 * none
 */


/*----------------------------------------------------------------------------*/


void pmm_draw_pmotion( float defzoom );

/* Draws particle motion diagram(s) into separate window
 *
 * parameters of routine
 * float      defzoom;        input; default zoom value for display
 */


/*----------------------------------------------------------------------------*/


void pmm_set_mode( int mode );

/* Configuring some parameters
 *
 * parameters of routine
 * int        mode;         input; mode to set
 */


/*----------------------------------------------------------------------------*/
