
/* file spectrum.h
 *      ==========
 *
 * version 6, 31-Oct-2004
 *
 * Header file for spectrum module
 * K. Stammler, 1-Sep-98
 */


/* constants */
#define cSpcUnchanged 0
#define cSpcAutoscale 1
#define cSpcFrqLoUp 2
#define cSpcFrqLoDown 3
#define cSpcFrqHiUp 4
#define cSpcFrqHiDown 5
#define cSpcAmpLoUp 6
#define cSpcAmpLoDown 7
#define cSpcAmpHiUp 8
#define cSpcAmpHiDown 9
#define cSpcResized 10

#define cSpcModePowSpc 1
#define cSpcModeFft 2
#define cSpcModeFft2 3



/*----------------------------------------------------------------------------*/


void spc_initialize( Widget parent, Widget spcwdw, STATUS *status );

/* initializes spectrum window
 *
 * parameters of routine
 * Widget     parent;      input; widget ID of root window
 * Widget     spcwdw;      input; Widget ID of spectrum window
 * STATUS     *status;     output; return status
 */


/*----------------------------------------------------------------------------*/


void spc_close_window( void );

/* Closes spectrum window
 *
 * parameters of routine
 * none
 */


/*----------------------------------------------------------------------------*/


void spc_insert_spectrum( Widget spcwdw, TSyStatus *status );

/* Plots new spectrum to window
 *
 * parameters of routine
 * Widget     spcwdw;        input; widget ID of spectrum drawing area
 * TSyStatus; *status;       output; return status
 */


/*----------------------------------------------------------------------------*/


void spc_change_display( int mode, TSyStatus *status );

/* Changes display
 *
 * parameters of routine
 * int        mode;        input; which change
 * TSyStatus  *status;     output; return status
 */


/*----------------------------------------------------------------------------*/


void spc_recompute_spectra( int mode, TSyStatus *status );

/* Recomputes spectra of all traces with new mode.
 *
 * parameters of routine
 * int        mode;        input; computation method
 * TSyStatus  *status;     output; return status
 */


/*----------------------------------------------------------------------------*/


void spc_get_dialog_values( Widget w[], TSyStatus *status );

/* Gets parameters from dialog box
 *
 * parameters of routine
 * Widget        w[];       input; widget array
 * TSyStatus     *status;   output; return status
 */


/*----------------------------------------------------------------------------*/


void spc_set_dialog_values( Widget w[] );

/* Gets parameters from dialog box
 *
 * parameters of routine
 * Widget        w[];       input; widget array
 */


/*----------------------------------------------------------------------------*/


void spc_handle_xevent( Widget w, XEvent *ev, TSyStatus *status );

/* Handles X events in spectrum window
 *
 * parameters of routine
 * Widget     w;       input; widget
 * XEvent     *ev;     input; event reported
 * TSyStatus  *status; output; return status
 */


/*----------------------------------------------------------------------------*/


void spc_start_fitline( void );

/* Next two mouse clicks are left and right window border for line fitting
 *
 * no parameters
 */


/*----------------------------------------------------------------------------*/
