#!/bin/sh

seiscomp_root="${SEISCOMP_ROOT-:/home/sysop/seiscomp}"

what='autopick'

msg () {
	echo "`LC_ALL=C date +'%Y/%m/%d %H:%M:%S'` $0: $1"
}

running () {
	# we are now in the application directory

	test -s .pgid || return 1	    # no .pgid file found
	pgid=`cat .pgid`

	if      ps --no-header -o pgid,pid,command x |
		grep "^ *$pgid.*$what"_main > /dev/null 2>&1
        then
		return 0
        else
		# this message is issued here because it's an
		# unexpected situation to have a .pgid file and no
		# program running
		msg "$what not running"
		msg "removing stale .pgid file"
		rm -f .pgid
		return 1
        fi
}


d=$seiscomp_root/$what
cd $d || exit 1

if	running
then
	msg "$what is already running"
	exit 0
fi

msg "starting $what"

echo '#####'"`date`"'################' >> $d/log/$what.err

nohup 2>> $d/log/$what.err bin/${what}_wrapper.sh &
# save the process group ID
ps --no-header -o pgid p $! | awk '{print $1}' > .pgid
