#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#define OK       0
#define NO_INPUT 1
#define TOO_LONG 2

char *topdir        = 0;               // top directory SEISAN
char *topdir_rt     = 0;               // top directory RTQUAKE

static void Check_Config();




static int getLine (char *prmpt, char *buff, size_t sz) {
    int ch, extra;

    // Get line with buffer overrun protection.
    if (prmpt != NULL) {
        printf ("%s", prmpt);
        fflush (stdout);
    }
    if (fgets (buff, sz, stdin) == NULL)
        return NO_INPUT;

    // If it was too long, there'll be no newline. In that case, we flush
    // to end of line so that excess doesn't affect the next call.
    if (buff[strlen(buff)-1] != '\n') {
        extra = 0;
        while (((ch = getchar()) != '\n') && (ch != EOF))
            extra = 1;
        return (extra == 1) ? TOO_LONG : OK;
    }

    // Otherwise remove newline and give string back to caller.
    buff[strlen(buff)-1] = '\0';
    return OK;
}
int main()
{
  char cfgfile[200];
  char path[200];
  char start_time[20];
  char stopp_time[20];
  char dbase[20];
  char syscmd[200];
  int  rc;
  int  i;
  int  len;
  char yymm[20];
  char dd[20];
  char hh[20];
  char yr[20];
  char mo[20];
  char mi[20];
  char se[20];  
//------------------------------------------------------------------------
// set path to SEISAN_TOP as default
//------------------------------------------------------------------------
  topdir = (char*)getenv("SEISAN_TOP");
  if(topdir)
  {
    printf("RTPICK: SEISAN_TOP.......................: %s\n", topdir);    
  }else{
    printf("RTPICK: SEISAN_TOP not defined.\n");
    printf("Install SEISAN !\n");
    exit(0);    
  }
//------------------------------------------------------------------------
// set path to RTQUAKE_TOP as default
//------------------------------------------------------------------------
  topdir_rt = (char*)getenv("RTQUAKE_TOP");
  if (topdir_rt)
  {
    printf("RTPICK: RTQUAKE_TOP......................: %s\n", topdir_rt);
  }else{
    printf("RTPICK: RTQUAKE_TOP not defined\n");
    printf("Include setup_rt.bash or setup_rt.csh in your .bashrc or .csh\n");
    exit(0);      
  } 
  printf("Start time:yyyymmddhhmmss\n");

    rc = getLine ("Enter time:", start_time, sizeof(start_time));
    if (rc == NO_INPUT) {
        // Extra NL since my system doesn't output that on EOF.
        printf ("\nNo input\n");
        return 1;
    }

    if (rc == TOO_LONG) {
        printf ("Input too long [%s]\n", start_time);
        return 1;
    }

    printf ("OK [%s]\n", start_time);  

    rc = getLine ("Enter database:", dbase, sizeof(dbase));
    if (rc == NO_INPUT) {
        // Extra NL since my system doesn't output that on EOF.
        printf ("\nNo input\n");
        return 1;
    }

    if (rc == TOO_LONG) {
        printf ("Input too long [%s]\n", dbase);
        return 1;
    }
   printf ("OK [%s]\n", dbase);
   len=strlen(start_time);
   printf("number of char: %d\n",len);
   
   switch(len)
   {
     case 6:                   // 201312
     yymm[0]=start_time[0];
     yymm[1]=start_time[1];
     yymm[2]=start_time[2];
     yymm[3]=start_time[3];
     yymm[4]=start_time[4];
     yymm[5]=start_time[5];  
     yymm[6]='\0';
     yr[0]=start_time[0];    // year
     yr[1]=start_time[1];
     yr[2]=start_time[2];
     yr[3]=start_time[3];
     yr[4]='\0';
     mo[0]=yymm[4];          // month
     mo[1]=yymm[5];
     mo[2]='\0';
     sprintf(path,"%s/REA/%s/%s/%s/*.* > sfiles.out",topdir,dbase,yr,mo);  
     printf("path: %s\n",path);
     sprintf(syscmd,"ls %s",path);
     rc=system(syscmd);     
     break;
     case 8:               //20131201
     yymm[0]=start_time[0];
     yymm[1]=start_time[1];
     yymm[2]=start_time[2];
     yymm[3]=start_time[3];
     yymm[4]=start_time[4];
     yymm[5]=start_time[5];  
     yymm[6]='\0';
     yr[0]=start_time[0];    // year
     yr[1]=start_time[1];
     yr[2]=start_time[2];
     yr[3]=start_time[3];
     yr[4]='\0';
     mo[0]=yymm[4];          // month
     mo[1]=yymm[5];
     mo[2]='\0';
     dd[0]=start_time[6];    // day
     dd[1]=start_time[7];
     dd[2]='\0';     
     sprintf(path,"%s/REA/%s/%s/%s/%s*.* > sfiles.out",topdir,dbase,yr,mo,dd);  
     printf("path: %s\n",path);
     sprintf(syscmd,"ls %s",path);
     rc=system(syscmd);
     break;
     case 10:               //20131201
     yymm[0]=start_time[0];
     yymm[1]=start_time[1];
     yymm[2]=start_time[2];
     yymm[3]=start_time[3];
     yymm[4]=start_time[4];
     yymm[5]=start_time[5];  
     yymm[6]='\0';
     yr[0]=start_time[0];    // year
     yr[1]=start_time[1];
     yr[2]=start_time[2];
     yr[3]=start_time[3];
     yr[4]='\0';
     mo[0]=yymm[4];          // month
     mo[1]=yymm[5];
     mo[2]='\0';
     dd[0]=start_time[6];    // day
     dd[1]=start_time[7];
     dd[2]='\0'; 
     hh[0]=start_time[8];
     hh[1]=start_time[9];
     hh[2]='\0';     
     sprintf(path,"%s/REA/%s/%s/%s/%s-%s*.* > sfiles.out",topdir,dbase,yr,mo,dd,hh);  
     printf("path: %s\n",path);
     sprintf(syscmd,"ls %s",path);
     rc=system(syscmd);          
     break;
     case 12:               //20131201
     yymm[0]=start_time[0];
     yymm[1]=start_time[1];
     yymm[2]=start_time[2];
     yymm[3]=start_time[3];
     yymm[4]=start_time[4];
     yymm[5]=start_time[5];  
     yymm[6]='\0';
     yr[0]=start_time[0];    // year
     yr[1]=start_time[1];
     yr[2]=start_time[2];
     yr[3]=start_time[3];
     yr[4]='\0';
     mo[0]=yymm[4];          // month
     mo[1]=yymm[5];
     mo[2]='\0';
     dd[0]=start_time[6];    // day
     dd[1]=start_time[7];
     dd[2]='\0'; 
     hh[0]=start_time[8];
     hh[1]=start_time[9];
     hh[2]='\0';
     mi[0]=start_time[10];
     mi[1]=start_time[11];
     mi[2]='\0';       
     sprintf(path,"%s/REA/%s/%s/%s/%s-%s%s*.* > sfiles.out",topdir,dbase,yr,mo,dd,hh,mi);  
     printf("path: %s\n",path);
     sprintf(syscmd,"ls %s",path);
     rc=system(syscmd);          
     break;
     case 14:               //20131201
     yymm[0]=start_time[0];
     yymm[1]=start_time[1];
     yymm[2]=start_time[2];
     yymm[3]=start_time[3];
     yymm[4]=start_time[4];
     yymm[5]=start_time[5];  
     yymm[6]='\0';
     yr[0]=start_time[0];    // year
     yr[1]=start_time[1];
     yr[2]=start_time[2];
     yr[3]=start_time[3];
     yr[4]='\0';
     mo[0]=yymm[4];          // month
     mo[1]=yymm[5];
     mo[2]='\0';
     dd[0]=start_time[6];    // day
     dd[1]=start_time[7];
     dd[2]='\0'; 
     hh[0]=start_time[8];
     hh[1]=start_time[9];
     hh[2]='\0';
     mi[0]=start_time[10];
     mi[1]=start_time[11];
     mi[2]='\0';
     se[0]=start_time[12];
     se[1]=start_time[13];
     se[2]='\0';      
     sprintf(path,"%s/REA/%s/%s/%s/%s-%s%s-%s*.* > sfiles.out",topdir,dbase,yr,mo,dd,hh,mi,se);  
     printf("path: %s\n",path);
     sprintf(syscmd,"ls %s",path);
     rc=system(syscmd);          
     break;          
   }

    


  sprintf(cfgfile,"sfiles.out");
  Check_Config(cfgfile,dbase,yr,mo);
}
void Check_Config(char config[],char dbase[],char yr[],char mo[])
{
  FILE *par;
  FILE *sfl;
  char  filepath[256];
  char  path[256];
  char  rtpick[500];
  char  wave[256];
  char  linjer[500];
  char  sline[500];
  char  du[10];
  char  ord[100];
  char  keyword[100];
  char  chkpar[500][256];
  int   tel,i,found;
  int   ret;
  int   length;

  par = fopen(config,"r");
  if(par == NULL)
  {
    printf("************RTDET-Read_Config_to_MEM**********************\n");
    printf("* %s does not exist.\n",filepath);
    printf("* Check your configuration file.                         *\n");
    printf("**********************************************************\n");
    exit(0);
  }
  tel=0;
  while ( fgets ( linjer, sizeof linjer, par ) != NULL ) /* read a line from file */
  {
    
//    printf("%3d %s %2d",tel,linjer,strlen(linjer));
    if(linjer[0] == ' ' || linjer[0] == 0xa)
    {
        printf("******************RTDET Check_Config*****************************\n");
        printf("* Blank line or line beginning with space in configuration file.*\n");
        printf("*****************************************************************\n");
        exit(0);
    }    
    tel++; 

    for(i=0;i<200;i++)
    {
      if(linjer[i] == 0xa)
	linjer[i] = '\0';
    }
    printf("open linjer: %s\n",linjer);
    sfl = fopen(linjer,"r");
    if(sfl == NULL)
    {
      printf("cant open %s\n",linjer);
      exit(0); 
    }
    tel=0;
    while ( fgets ( sline, sizeof sline, sfl ) != NULL ) /* read a line from file */
    {
//      printf("%s",sline);
      if(sline[79] == '6')
      {
//	printf("found\n");
	sscanf(sline,"%s",wave);
//	printf("%s\n",wave);
	sprintf(filepath,"%s/WAV/%s/%s/%s/%s",topdir,dbase,yr,mo,wave);
	printf("filepath: %s\n",filepath);
	sprintf(rtpick,"rtpick -sfile %s -wavefile %s",linjer,filepath);
	printf("%s\n",rtpick);
	ret=system(rtpick);
	break;
      }
     
    }
//    exit(0);
  }
}