/***************************************************************************
 *   Copyright (C) 2008 by seismo   *
 *   seismo@localhost   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/shm.h>
#include <sh_mem_rt.h>
#include <GL/glut.h>                   // LINUX
#define PACKAGE "rtdly"
#define nch 600


float   BGND_R         = 0.0;          // Background default BLACK
float   BGND_G         = 0.0;
float   BGND_B         = 0.0;

float   LINE_R         = 0.3;          // Lines horizontal default GRAY
float   LINE_G         = 0.3;
float   LINE_B         = 0.3;

float   SNET_R         = 0.4;          // Lines horizontal subnet default LIGHT-GRAY
float   SNET_G         = 0.4;
float   SNET_B         = 0.4;

float   TEXT_R         = 0.498;        // Text default BLACK
float   TEXT_G         = 1.0;
float   TEXT_B         = 0.0;

float   MINU_R         = 0.3;          // Minute lines default GRAY
float   MINU_G         = 0.3;
float   MINU_B         = 0.3;

float   TRIG_R         = 1.0;          // Trigger onset default RED
float   TRIG_G         = 0.0;
float   TRIG_B         = 0.0;

float   DURA_R         = 1.0;          // Duration default YELLOW
float   DURA_G         = 1.0;
float   DURA_B         = 0.0;


int     WINH      = 400;               // DEFAULT WINDOW HEIGHT IN PIXELS
int     WINL      = 1200;              // DEFAULT WINDOW LENGTH IN PIXELS
int     xo        = 0;                 // coordinates for position on screen
int     yo        = 0;                 // coordinates for position on screen
int     delay     = 2;                 // seconds between update of screen
int     factor    = 10;                // factor to scale plot
int     klon      = 0;                 // instance of program
char    *topdir_rt= 0;                 // top directory RTQUAKE
char    parname[80];
char    fullna[MAXCHA][80];

int     getout=0;
int     no_to_plot;
int     ystart;
int     xstart;
int     yst;
int     xst;
int     ixx;
int     xtime_old;
char    box1[50];
int     start_stop = 0;
int     no_stations = 0;
char    toplot[nch][80];

char    station_name[nch][80];
char    time_string[nch][80];

float   xincr;
int     height;
float   xval;
int     printarg=0;

int     teller;
int     xold;
int     xnew;
int     yold;
int     ynew;
int     step;
int     yyy[200][2000];
float   R=0.0;
float   G=0.0;
float   B=0.0;
int     RunMode = 1;		// Used as a boolean (1 or 0) for "on" and "off"
rtmod *spt;                        // pointer shared memory 


static int parameter_proc (int argcount, char **argvec);
static char *getoptval (int argcount, char **argvec, int argopt);
static void usage (void);
static void DTE();
static void SECTIM();
static void TIMSEC();
static void Read_Parameters();
static void strip();
static void Set_Color_1();
static void Set_color_2();
static void Set_Color_3();
static void draw_square();

void Set_Color_2()
{
  BGND_R         = 1.0;            // Background WHITE
  BGND_G         = 1.0;
  BGND_B         = 1.0;

  LINE_R         = 240.0/255.0;    // Lines horizontal  GRAY
  LINE_G         = 240.0/255.0;
  LINE_B         = 240.0/255.0;

  TEXT_R         = 0.0;            // Text BLACK
  TEXT_G         = 0.0;
  TEXT_B         = 0.0;

  MINU_R         = 240.0/255.0;   // Minute lines GRAY
  MINU_G         = 240.0/255.0;
  MINU_B         = 240.0/255.0;

  TRIG_R         = 0.0;           // Trigger onset BLUE
  TRIG_G         = 127.0/255.0;
  TRIG_B         = 255.0/255.0;

  DURA_R         = 1.0;           // Duration RED
  DURA_G         = 0.0;
  DURA_B         = 0.0;
  
}


void 
my_reshape(int w, int h)
{
   GLdouble size;
   GLdouble aspect;

   /* Use the whole window. */
   glViewport(0, 0, w, h);

   /* We are going to do some 2-D orthographic drawing. */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   size = (GLdouble)((w >= h) ? w : h) / 2.0;
   if (w <= h) {
      aspect = (GLdouble)h/(GLdouble)w;
      glOrtho(-size, size, -size*aspect, size*aspect, -100000.0, 100000.0);
   }
   else {
      aspect = (GLdouble)w/(GLdouble)h;
      glOrtho(-size*aspect, size*aspect, -size, size, -100000.0, 100000.0);
   }

   /* Make the world and window coordinates coincide so that 1.0 in */
   /* model space equals one pixel in window space.                 */
   glScaled(aspect, aspect, 1.0);

   /* Now determine where to draw things. */
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

}
void bitmap_output(int x, int y, char *string, void *font)
{
  int len, i;

  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) {
    glutBitmapCharacter(font, string[i]);
  }
}
void drawScene(void)
{
// Flush the pipeline, swap the buffers
  glFlush();
  glutSwapBuffers();
  if ( RunMode==1 ) 
  {
    glutPostRedisplay();	// Trigger an automatic redraw for animation
  }
  strip();
  if(getout==1)
    exit(0);
  sleep(delay);
}
void 
my_handle_key(unsigned char key, int x, int y)
{
  int l;
  printf("%d\n",key);
   switch (key) {
     case 49:
     printf("Default\n");
     Set_Color_1();
     break;
     case 50:
     Set_Color_2();
     break;
     case 51:
     Set_Color_3();
     break;
   case 27:        // ESC exit
   getout=1;
   exit(EXIT_SUCCESS);
   printf("getout\n");
   break;
   case 9:        // TAB flip to barchart
//   flipp = 1;
   break;
   case 13:       // ENTER flip to trend diagram
//   flipp=0;
   break;
   case 62:
   factor=factor+1;
   break;
   case 60:
   factor=factor-1;
   break;
   case 83:        // S Hold
   start_stop=1;
   break;
   case 115:       // s Resume
   start_stop=0;
   break;



   case 104:       // help
   printf("**************************************************************\n");
   printf("* List of key-press functions:                               *\n");
   printf("* ----------------------------                               *\n");
   printf("* h  : list this on screen                                   *\n");
   printf("* esc: exit                                                  *\n");
   printf("* u  : increase amplitude on all channels                    *\n");
   printf("* d  : decrease amplitude on all channels                    *\n");
   printf("* S  : freeze graphics                                       *\n");
   printf("* s  : resume graphics                                       *\n");
   printf("* n  : next channel                                          *\n");
   printf("* +  : increase amplitude on current channel                 *\n");
   printf("* -  : decrease amplitude on current channel                 *\n");
   printf("* F  : turn on pre-set filter                                *\n");
   printf("* f  : turn off filtering                                    *\n");
   printf("* 1  : Set color scheme to default                           *\n");
   printf("* 2  : Color scheme 2                                        *\n");
   printf("* 3  : Color scheme 3                                        *\n");
   printf("* 4  : Color scheme 4                                        *\n");
   printf("**************************************************************\n"); 
   break;

   default:
      break;
   }
  printf("%4.1f %4.1f %4.1f\n",R,G,B);
}
void draw_square(int x1,int y1,int x2,int y2)
{
  glBegin(GL_LINES);        // draw box # 1
  glVertex2f(x1-(WINL/2), y1-(WINH/2));
  glVertex2f(x2-(WINL/2), y1-(WINH/2));

  glVertex2f(x2-(WINL/2), y1-(WINH/2));
  glVertex2f(x2-(WINL/2), y2-(WINH/2));

  glVertex2f(x2-(WINL/2), y2-(WINH/2));
  glVertex2f(x1-(WINL/2), y2-(WINH/2));

  glVertex2f(x1-(WINL/2), y2-(WINH/2));
  glVertex2f(x1-(WINL/2), y1-(WINH/2));
  glEnd();
}
void Set_Color_1()
{
  BGND_R         = 0.0;          // Background default BLACK
  BGND_G         = 0.0;
  BGND_B         = 0.0;

  LINE_R         = 0.3;          // Lines horizontal default GRAY
  LINE_G         = 0.3;
  LINE_B         = 0.3;

  TEXT_R         = 0.498;        // Text default BLACK
  TEXT_G         = 1.0;
  TEXT_B         = 0.0;

  MINU_R         = 0.3;          // Minute lines default GRAY
  MINU_G         = 0.3;
  MINU_B         = 0.3;

  TRIG_R         = 1.0;          // Trigger onset default RED
  TRIG_G         = 0.0;
  TRIG_B         = 0.0;

  DURA_R         = 1.0;          // Duration default YELLOW
  DURA_G         = 1.0;
  DURA_B         = 0.0;
}

void Set_Color_3()
{
  BGND_R         = 252.0/255.0;    // Background PINAPPLE
  BGND_G         = 220.0/255.0;
  BGND_B         = 59.0/255.0;

  LINE_R         = 251.0/255.0;    // Lines horizontal  BREAD
  LINE_G         = 161.0/255.0;
  LINE_B         = 108.0/255.0;

  TEXT_R         = 0.0;            // Text BLACK
  TEXT_G         = 0.0;
  TEXT_B         = 0.0;

  MINU_R         = 251.0/255.0;   // Minute lines BREAD
  MINU_G         = 161.0/255.0;
  MINU_B         = 108.0/255.0;

  TRIG_R         = 0.0;           // Trigger onset BLUE
  TRIG_G         = 127.0/255.0;
  TRIG_B         = 255.0/255.0;

  DURA_R         = 0.0;           // Duration BLACK
  DURA_G         = 0.0;
  DURA_B         = 0.0;
  
}
void strip()
{

  int     yrn;                   // Date and time for time-stamp and time corr.
  int     mon;                   // -----------------"-------------------------
  int     day;                   // -----------------"-------------------------
  int     hrn;                   // -----------------"-------------------------
  int     min;                   // -----------------"-------------------------
  int     doy;                   // -----------------"-------------------------
  float    sek;                   // -----------------"-------------------------
  double   MSEC;
  int   p;
  int   g;
  int   l;
  int   j;
  int   k1,l1,m1;
  float scale;
  float R;
  float G;
  float B;
  int i;
  int iss;
  int   last;
  int   sek_int;
  int   last_min;
  int   mod_sek;
  int   mod_min;
  int   xval;
  int   xstartold;
  float xlast;
  float fseks;
  float fstep;
  float seks5;
  float fval;
  int teller;
  int teltilto;
  int   min15;
  float step_min;
  char tekst1[80];
  char tekst2[80];
  char tekst3[80];
  char seks[10];
  char dum[20];
  int  primer;
  int  next;
  char tmp[80];
  char sta[10];
  
  char tid[80];

  int timer,minu,mmin,mstart,tstart,mmm;  
  
  
  
  time_t now = time(NULL);
  struct tm *now_s = localtime(&now);


  
  
  sprintf(tid,"%02d:%02d", now_s->tm_hour, now_s->tm_min);
  sscanf(tid,"%2d",&timer);
  sscanf(tid,"%3c%2d",dum,&minu);  
  mmin = timer * 60 + minu;
  mstart = mmin - MINUT_NOW;
  tstart = mstart/60;
  mmm= mstart-tstart*60;

  
  glColor3f(BGND_R, BGND_G, BGND_B);             // set window background color
  glRecti(-WINL/2,-WINH/2,WINL/2,WINH/2);
//-------------------------------------------------------------
// draw gray lines to distinguish between stations
//-------------------------------------------------------------
///  ystart = -WINH/2+12;
  ystart = WINH/2+12;
  glColor3f(LINE_R,LINE_G,LINE_B);              // set color to gray
  
  sscanf(spt->trig_stations[klon][0],"%d",&primer);
  for(p=0;p<no_stations;p++)
  {
    sscanf(spt->trig_stations[klon][p],"%d",&next);        
    glBegin( GL_LINES );               // Plot lines
    glVertex2f( -WINL/2, ystart );
    glVertex2f(  WINL/2, ystart );
    glEnd();
    ystart=ystart-height;
    if(next > primer)                 // check if new subnet (new color LIGHT GRAY)
    {
      primer = next;
      glColor3f(SNET_R,SNET_G,SNET_B);              // set color to light-gray      
    }else{
      glColor3f(LINE_R,LINE_G,LINE_B);              // set color to gray      
    }    
  }
//  ystart = ystart - height;
  glBegin( GL_LINES );               // Plot lines
  glVertex2f( -WINL/2, ystart );
  glVertex2f(  WINL/2, ystart );
  glEnd();
  ystart = ystart - height;
  glBegin( GL_LINES );               // Plot lines
  glVertex2f( -WINL/2, ystart );
  glVertex2f(  WINL/2, ystart );
  glEnd();    
//--------------------------------------------------------------
// draw onset trigger followed by duration
//--------------------------------------------------------------
  xval=-(float)WINL/2.0;
  fval=-(float)WINL/2.0;
  xstart = (int)fval;
  xstartold = xstart;

  for(j=0;j<(DELAY_BUFFER*60);j++)
  {
    ystart = WINH/2;
    ynew   = ystart-height;
    for(i=0;i<no_stations;i++)
    {
      if(spt->ttdly[klon][i][j] > 0) // trigger ?
      {
        if(spt->ttdly[klon][i][j] == 122) // trigger onset?
        {
          glColor3f(TRIG_R,TRIG_G,TRIG_B);
          glBegin( GL_LINES);
          glVertex2f(xstart,ystart-2);
          glVertex2f(xstart,ynew+2);
          glEnd();  
	}else{                          // trigger duration

          glColor3f(DURA_R,DURA_G,DURA_B);
          glBegin( GL_LINES);
          glVertex2f(xstart,ystart-2);
          glVertex2f(xstart,ynew+2);
          glEnd();

	}
      }else{                           // no trigger
	glColor3f(BGND_R,BGND_G,BGND_B);
        glBegin( GL_LINES);
        glVertex2f(xstart,ystart-2);
        glVertex2f(xstart,ynew+2);
        glEnd();  
      }
      ystart = ynew;
      ynew=ynew-height;
    }

    fval = fval + xincr;
    xstart = (int)fval;
    
    
    
  }

//------------------------------------------------------------------------
// draw minute marks gray lines
//------------------------------------------------------------------------
  glColor3f(MINU_R,MINU_G,MINU_B);              // set color to gray
  teller =0;
  min15 = 0; 
  teltilto=0;
  fval=-(float)WINL/2.0;
  for(p=0;p<(DELAY_BUFFER*60);p++)
  {
    xstart = (int)fval;
    glColor3f(MINU_R,MINU_G,MINU_B);              // set color to gray
    ystart = WINH/2;
    ynew   = -WINH/2+12;
    if(teller == 60)
    {
      teltilto++;
      min15++;
      glBegin( GL_LINES );               // Plot scale-lines
      glVertex2f( xstart, ystart );
      if(min15==MINUT_NOW)
      {
        glVertex2f(xstart,-WINH/2);
      }else{
        glVertex2f( xstart, ynew );
      }
      glEnd();
      
      glColor3f(TEXT_R,TEXT_G,TEXT_B);              // set color to green  
      
      mmm++;
      if(mmm==60)
      {
	mmm=0;
	tstart++;
	if(tstart==24)
	  tstart=0;
      } 
      if(teltilto==2)
      {
        sprintf(tekst1,"%02d:%02d",tstart,mmm);   // print timeline
        bitmap_output(xstart-24, ynew-12, tekst1,GLUT_BITMAP_9_BY_15 );
        teltilto=0;
      }
      teller = 0;
    }
    teller++;
    fval=fval+xincr;

  }
//------------------------------------------------------------------------
// draw minute marks
//------------------------------------------------------------------------
  glColor3f(TEXT_R,TEXT_G,TEXT_B);              // set color to gray
  teller =0;
  min15 = 0;   
  fval=-(float)WINL/2.0;
  
  for(p=0;p<(DELAY_BUFFER*60);p++)
  {
    xstart = (int)fval;  

    ystart = WINH/2;
    ynew   = WINH/2 - 10;
    if(teller == 60)
    {
      min15++;
      glBegin( GL_LINES );               // Plot scale-lines
      glVertex2f( xstart, ystart );
      if(min15==MINUT_NOW)
      {
        glVertex2f(xstart,-WINH/2);
      }else{
        glVertex2f( xstart, ynew );
      }
      glEnd();
      

      
      teller = 0;
    }
    teller++;
    fval=fval+xincr;   
  }
//----------------------------------------------------------------------
// draw array propagation window
//----------------------------------------------------------------------
  iss = (MINUT_NOW - DET_DELAY) * 60;
  glColor3f(1.0,0.0,0.0);              // set color to gray
  glBegin( GL_LINES );
  glVertex2f( -WINL/2+(int)((float)iss*xincr), WINH/2 );
  glVertex2f( -WINL/2+(int)((float)iss*xincr), -WINH/2 );

  glVertex2f( -WINL/2+(int)((float)(iss+APW)*xincr), WINH/2 );
  glVertex2f( -WINL/2+(int)((float)(iss+APW)*xincr), -WINH/2 );
  glEnd();
//----------------------------------------------------------------------
// draw station names
//----------------------------------------------------------------------
  ystart = WINH/2-12;
  glColor3f(TEXT_R,TEXT_G,TEXT_B);              // set color to gray
  for(p=0;p<no_stations;p++)
  {
    if(spt->receiving[klon][p] == -111)
    {
      glColor3f(1.0,0.0,0.0);
    }else{
   glColor3f(0.0,1.0,0.0);     
    }
    
    
//    sprintf(tekst1,"%s",spt->stasjon[klon][p]);
     sprintf(tekst1,"%s",spt->trig_stations[klon][p]);
//     printf("%s\n",tekst1);
     if(tekst1[4] == ' ')
     {
       tekst1[16]=tekst1[15];
       tekst1[15]=tekst1[14];
       tekst1[14]=tekst1[13];
       tekst1[13]=tekst1[12];
       tekst1[12]=tekst1[11];
       tekst1[11]=tekst1[10];
       tekst1[10]=tekst1[9];
       tekst1[9]=tekst1[8];
       tekst1[8]=tekst1[7];
       tekst1[7]=tekst1[6];
       tekst1[6]=tekst1[5];
       tekst1[5]=' ';
     }
    bitmap_output(WINL/2-144, ystart, tekst1,GLUT_BITMAP_9_BY_15 ); 
    ystart=ystart-height;
  }    
  glFlush();
  

  
}

void Read_Parameters()
{
  FILE *par;
  char  dummy[256];
  char  linjer[256];
  char  keyword[256];
  float val;
  int   br = 0;
  
  par = fopen("rtquake.par","r");
  if(par == NULL)
  {
    printf("rtquake.par does not exist in current directory.\n");
    sprintf(dummy,"%s/com/rtquake.par",topdir_rt);
    par = fopen(dummy,"r");
    if(par == NULL)
    {
      printf("rtquake.par does not exist in %s. Use defaults.\n",dummy);
      br=1;
    }
  }
  if(br == 0)
  {
    printf("read rtquake.par\n");
    sprintf(keyword,"DELAY_BUFFER");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) /* read a line from file */
    {
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//	printf("val: %5.1f\n",val);
	DELAY_BUFFER = (int)val;
        break;
      }
    }
    rewind(par);    
    sprintf(keyword,"SECONDS2SHUFLE");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) /* read a line from file */
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	SECONDS2SHUFLE = (int)val;
        break;
      }
    }   
    rewind(par);    
    sprintf(keyword,"MINUT_NOW");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) /* read a line from file */
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	MINUT_NOW = (int)val;
        break;
      }
    }
    
    rewind(par);    
    sprintf(keyword,"PRINTING");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
//	prt = (int)val;	
        break;
      }
    }   
    rewind(par);    
    sprintf(keyword,"DET_DELAY");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	DET_DELAY = val;
        break;
      }
    }
    rewind(par);    
    sprintf(keyword,"APW");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%40c%f",dummy,&val);
//        printf("val: %5.1f\n",val);
	APW = val;
        break;
      }
    }
/*    
    rewind(par);    
    sprintf(keyword,"MAIL1");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%19c%s",dummy,mailaddress1);
	sscanf(linjer,"%40c%f",dummy,&val);	
//        printf("val: %5.1f  %s\n",val,mailaddress1);
	mail1 = (int)val;	
        break;
      }
    }
    
    rewind(par);    
    sprintf(keyword,"MAIL2");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%19c%s",dummy,mailaddress2);
	sscanf(linjer,"%40c%f",dummy,&val);	
//        printf("val: %5.1f  %s\n",val,mailaddress1);
	mail2 = (int)val;	
        break;
      }
    }      
    rewind(par);    
    sprintf(keyword,"MAIL3");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%19c%s",dummy,mailaddress3);
	sscanf(linjer,"%40c%f",dummy,&val);	
//        printf("val: %5.1f  %s\n",val,mailaddress1);
	mail3 = (int)val;	
        break;
      }
    }      
    
    rewind(par);    
    sprintf(keyword,"MAIL4");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%19c%s",dummy,mailaddress4);
	sscanf(linjer,"%40c%f",dummy,&val);	
//        printf("val: %5.1f  %s\n",val,mailaddress1);
	mail4 = (int)val;	
        break;
      }
    }        
    
    rewind(par);    
    sprintf(keyword,"MAIL5");
    while ( fgets ( linjer, sizeof linjer, par ) != NULL ) // read a line from file 
    {
  
      if (strstr(linjer, keyword) )
      {
	printf("%s", linjer);
	sscanf(linjer,"%19c%s",dummy,mailaddress5);
	sscanf(linjer,"%40c%f",dummy,&val);	
//        printf("val: %5.1f  %s\n",val,mailaddress1);
	mail5 = (int)val;	
        break;
      }
    }      
    
*/    
    
    
    
    
    
    
    
    
    
    
    
    
  fclose(par);    
    
  }
}
void tu_read_stationlist ( const char * streamfile)
{
  FILE *streamfp;
  char linje[80];                      // line read from file
  char station[80];
  char navn[80];
  char tempo[80];
  char filnam1[80];
  char tmp[80];
  char felles[20][200][80];
  int i,l,k,no;
  int br=0;
/* Open the station list file */
  sprintf(filnam1,"%s/par/%s",topdir_rt,streamfile);
  printf("Stationfile: %s\n",streamfile);
  sprintf(parname,"%s",streamfile);
  if ((streamfp = fopen (filnam1, "rb")) == NULL)
  {
    printf("Can't open: %s\n",filnam1);
    exit(0);
  }
  no = 200;
  i=0;
  l=0;
  for(i=0;i<no;i++)
  {
    if((fgets(linje, 70, streamfp)) != NULL)
    {
      printf("%2d %s",i,linje);
      sprintf(tempo,"%s",linje);
      for(l=0;l<80;l++)
      {
        station[l]='\0';
	navn[l]='\0';
      }
      for(k=0;k<20;k++)
        tmp[k]='\0';
      strncpy(tmp,linje,5);
//      printf("klon:%2d stas: %2d %s\n",klon,i,tmp);
      sprintf(spt->stasjon[klon][i],"%s",tmp);
      strncpy(station,linje,10);
      sprintf(toplot[i], "%s",station);
//      printf("%s\n",toplot[i]);
      for(l=0;l<40;l++)
        navn[l]=linje[l+11];
      sprintf(fullna[i],"%s",navn);
      for(l=0;l<40;l++)
        if(fullna[i][l] == '\n') fullna[i][l] = '\0';
//	  printf("%s\n",fullna[i]);
    }else{
      break;
    }
  }
  printf("End of file. File contains: %2d items\n",i);
  no_to_plot = i;
}




int main(int argc, char **argv)
{
  void          *shared_memory_rt = (void *)0;
  int           shmid_rt;
  int p;
  char par[10];
  char title[80];
  char syscmd[100];
  int ret1;
  ixx=0;
  step=1;
//------------------------------------------------------------------------
// set path to RTQUAKE_TOP as default
//------------------------------------------------------------------------
  topdir_rt = (char*)getenv("RTQUAKE_TOP");
  if (topdir_rt)
  {
    printf("RTDLY: RTQUAKE_TOP: %s\n", topdir_rt);
  }else{
    printf("RTDLY: RTQUAKE_TOP not defined\n");
    printf("Include setup_rt.bash or setup_rt.csh in your .bashrc or .csh\n");
    exit(0);      
  }
//-------------------------------------------------------------------------
// open shared memory region                                                
//--------------------------------------------------------------------------
//  printf("Size shared module %d\n",(int)sizeof(rtmod));
  shmid_rt = shmget((key_t)5678, sizeof(rtmod), 0666 | IPC_CREAT);
  if(shmid_rt == -1)
  {
    printf("*****************************************************************************\n");
    printf("* RTDET: Can't allocate shared memory !                                     *\n");
    printf("* RTDET: If a new version of RTQUAKE has been installed,                    *\n");
    printf("* RTDET: follow the instructions below and restart.                         *\n");
    printf("* RTDET: Use command ipcs -m to see a list of Shared Memory Segments.       *\n");
    printf("* RTDET: Use command ipcrm -M key to remove old shared memory, where key    *\n");
    printf("* RTDET: is the number in first column in the list where status is blank.   *\n");
    printf("*****************************************************************************\n");
    sprintf(syscmd,"killall rtdet");
    ret1=system(syscmd);
    sprintf(syscmd,"killall rtnet");
    ret1=system(syscmd); 
    
    fprintf(stderr, "shmget failed  2\n");
    exit(EXIT_FAILURE);
  }
  shared_memory_rt = shmat(shmid_rt, (void *)0, 0);
  if(shared_memory_rt == (void *)-1)
  {
    fprintf(stderr, "shmat failed\n");
    exit(EXIT_FAILURE);
  }
//-------------------------------------------------------------------------
// Compute pointer to shared memory region                                 
//-------------------------------------------------------------------------
  spt=(rtmod *)shared_memory_rt;

//-------------------------------------------------------------------------
// Process command line parameters
//-------------------------------------------------------------------------
  if (parameter_proc (argc, argv) < 0)
  {
    fprintf(stderr, "Parameter processing failed\n\n");
    fprintf(stderr, "Try '-h' for detailed help\n");
    return -1;
  }

  Read_Parameters();  
  Set_Color_1();
  
  WINL = 1200;
//  WINL = (DELAY_BUFFER*60);
  no_stations = spt->val20[klon];
  if(no_stations >= 100)
    no_stations = 100;
  WINH = 12*no_stations+12;
//  WINH = 13*no_stations+13;  
  printf("Stations: %d WINL: %d WINH: %d\n",no_stations,WINL,WINH);
  xstart = -WINL/2;
  ystart = -WINH/2;

  xincr= (float)WINL/(DELAY_BUFFER*60);
  height = WINH/no_stations;
  printf("xincr: %10.3f height: %d\n",xincr,height);
//*******************************************************************
// Set up for OpenGL graphics
//*******************************************************************
  glutInit(&argc,argv);

// We're going to animate it, so double buffer 
//  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
// Window position (from top corner), and size (width% and hieght)
  glutInitWindowPosition( xo, yo );

// Set window size in pixels
  glutInitWindowSize( WINL, WINH+10 );

// Create window with title given in parameters
  sprintf(title,"Monitoring delayed triggering    Parameter-set: %d",klon+1);
  glutCreateWindow( title );

  glColor3f(0.0, 0.0, 0.0);
  glRecti(-WINL/2,-WINH/2,WINL/2,WINH/2);




// call this whenever window needs redrawing
  glutDisplayFunc( drawScene );

// Detects a key-press. ESC exits program
   glutKeyboardFunc(my_handle_key);  


   
   
   
  glutReshapeFunc(my_reshape);


// Start the main loop.  glutMainLoop never returns.
  glutMainLoop(  );

  return 0;

}
void TIMSEC (YR,MTH,DAY,HR,MIN,SECS,MSECS)                         
int YR;
int MTH;
int DAY;
int HR;
int MIN;
float SECS;
double *MSECS;                         /* total seconds to be returned      */
{
int DYR;                               /* flag for leap year                */
int IYR;                               /* number of leap-years since 1900   */
int YDY;                               /* number of days in current year    */

if(YR <= 50) YR=YR+100;                /* check for 2000 or more in 2 digits*/

if(YR >= 1900) YR=YR - 1900;
DYR = 0;
if((YR % 4) == 0) DYR = 1;
IYR = YR/4 - DYR;
//                -- Seconds to beginning of     
*MSECS = (float)(IYR*366) + (float)((YR-IYR)*365);
//                -- current year                
*MSECS = *MSECS*86400.0;
//                -- January                     
if (MTH == 1) YDY = DAY;
//                -- February                    
if (MTH == 2) YDY = DAY + 31;
//                -- ....                        
if (MTH == 3) YDY = DAY + DYR + 59;       
if (MTH == 4) YDY = DAY + DYR + 90;                                     
if (MTH == 5) YDY = DAY + DYR + 120;                                    
if (MTH == 6) YDY = DAY + DYR + 151;                                    
if (MTH == 7) YDY = DAY + DYR + 181;                                    
if (MTH == 8) YDY = DAY + DYR + 212;                                    
if (MTH == 9) YDY = DAY + DYR + 243;                                    
if (MTH ==10) YDY = DAY + DYR + 273;                                    
if (MTH ==11) YDY = DAY + DYR + 304;                                    
if (MTH ==12) YDY = DAY + DYR + 334;                                    
*MSECS = *MSECS + (float)(YDY*86400 + HR*3600 + MIN*60) + SECS;
}

void SECTIM (MSECS,YR,DOY,MTH,DAY,HR,MIN,SEC)                      
double MSECS;
int *YR;
int *DOY;
int *MTH;
int *DAY;
int *HR;
int *MIN;
float *SEC;
{
int DDAY,MMTH;
//             -- Temporary seconds         
double SSEC;
//             -- Seconds per day           
double SECDAY;
//             -- Seconds per year          
double SECYR;
//              -- Leap-year indicators      
float  IND, SIN;
//              -- Counter                   
int    I;
SECDAY=86400.0;
SECYR =31536000.0;
//*-------------------------------------------------------------------------      
//*  Find year:                                                                   
//*                                                                               
SSEC = 0.0;
for(I=1;I<201;I++)
{
    IND = 0.0;
//               -- Leap year                 
    if ((I%4) == 0) IND = 1.0;
//               -- Add years                 
    SSEC = SSEC + SECYR + IND*SECDAY;
//               -- Year found                
    if (SSEC > MSECS) goto found;              
        SIN = IND;
}
found:                                                              
*YR = I - 1;
//*                                                                               
//*  Find day-of-year and date:                                                   
//*                                                                               
//c-- Reset remaining seconds   
SSEC = MSECS - (SSEC - SECYR - IND*SECDAY);

for(I=1;I<367;I++)
{
    SSEC = SSEC - SECDAY;
    if (SSEC < 0) goto incr;                                              
}
incr:

I = I - 1;
//           -- 366 days of year          
if (SIN > 0.0) I = I + 1;
//           --                           
if (I == 0)
{                           
//           -- Justifying if change      
    *YR = *YR - 1;
//           -- of year                   
    I  = 365;                                  
    if ((*YR%4) == 0) I = 366;
}


*DOY = I;
//-- convert from doy to date  
DTE (I,&DDAY,&MMTH,*YR);
*DAY=DDAY;
*MTH=MMTH;


if(*YR >= 100) *YR=*YR-100;            /* test for year 2000 or more        */





//*                                                                               
//*  Find hour:                                                                   
//*                                                                               
SSEC = SSEC + SECDAY;

for(I=1;I<25;I++)
{
    SSEC = SSEC - 60.0*60.0;
    if (SSEC < 0) goto seks;                                              
}
seks:
*HR = I - 1;
//*                                                                               
//*  Find minutes and remaining seconds:                                          
//*                                                                               
SSEC = SSEC + 60.0*60.0;
for(I=1;I<61;I++)
{
    SSEC = SSEC - 60.0;
    if (SSEC < 0) goto otte;
}
otte:                                              
   *MIN = I - 1;
   *SEC = SSEC + 60.0;
if(*YR < 50)
{
    *YR=*YR+2000;
}else{
    *YR=*YR+1900;
}
}
//*=========================================================================      
//*                                                                               
//* Routine to convert from day-of-year to date                                   
//*                                                         Leif Kvamme 12-1-85   
void DTE (DOY,DAY,MON,YR)                                          
int DOY;
int *DAY;
int *MON;
int YR;
{
int MTH[14],J,M,N;
for(J=1;J<8;J=J+2)
    MTH[J] = 31;
for(J=8;J<13;J=J+2)
    MTH[J] = 31;
MTH[2] = 28;
MTH[4] = 30;
MTH[6] = 30;
MTH[9] = 30;
MTH[11]= 30;
if ((YR%4) == 0) MTH[2] = 29;
M = 0;                                                                    
for(J=1;J<13;J++)
{
    M = M + MTH[J];
    N = DOY - M;                                                              
    if (N <= 0)
    {                                                       
        *MON = J;
        *DAY = N + MTH[J];                                                     
        goto four;                                                               
    }
}
four:                                                                   
J=0;
}
/***************************************************************************
 * parameter_proc:
 *
 * Process the command line parameters.
 *
 * Returns 0 on success, and -1 on failure
 ***************************************************************************/
static int
parameter_proc (int argcount, char **argvec)
{
  int optind;
  int error = 0;
//  int i;
  char tm[80];  
  
 char *streamfile   = 0;	    /* stream list file for configuring streams */
 char *stationfile  = 0;      /* station list file for reading streams */
 char *recordfile   = 0;        // station list for recording

  char *multiselect = 0;
  char *selectors   = 0;

//  if (argcount <= 1)
//    error++;

  printf("argcount: %d\n",argcount);
  
  /* Process all command line arguments */
  for (optind = 1; optind < argcount; optind++)
    {

      if (strcmp (argvec[optind], "-h") == 0)
	{
	  usage();
	  exit (0);
	}
      else if (strcmp (argvec[optind], "-par") == 0)
	{
	  klon = atoi (argvec[++optind]);
          printf("klon= %d\n",klon);
	}
      else if (strcmp (argvec[optind], "-x") == 0)
	{
	  WINL = atoi (argvec[++optind]);
          printf("WINL= %d\n",WINL);
	}
      else if (strcmp (argvec[optind], "-y") == 0)
	{
	  WINH = atoi (argvec[++optind]);
          printf("WINH= %d\n",WINH);
	}
      else if (strcmp (argvec[optind], "-xo") == 0)
      {
        xo = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-yo") == 0)
      {
        yo = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-f") == 0)
	{
	  stationfile = argvec[++optind];
	}
      else if (strcmp (argvec[optind], "-dly") == 0)
	{
	  delay = atoi (argvec[++optind]);
          printf("delay= %d\n",delay);
	}

      else if (strcmp (argvec[optind], "-fac") == 0)
	{
	  factor = atoi(argvec[++optind]);
          printf("factor: %d\n",factor);
	}

      else if (strncmp (argvec[optind], "-", 1 ) == 0)
	{
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
	}
      else
	{
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
	}
    }






  /* If errors then report the usage message and quit */
  if (error)
    {
      usage ();
      exit (1);
    }
  /* Load the station list from a file if specified */
  if ( stationfile )
  {
    tu_read_stationlist (stationfile);
  }else{
    printf("detection file for specified parameter set must be specified\n");
//    exit(0);
//    stationfile = "stations.conf";
//    tu_read_stationlist (stationfile);
  }

  return 0;
}				/* End of parameter_proc() */

/***************************************************************************
 * getoptval:
 * Return the value to a command line option; checking that the value is 
 * itself not an option (starting with '-') and is not past the end of
 * the argument list.
 *
 * argcount: total arguments in argvec
 * argvec: argument list
 * argopt: index of option to process, value is expected to be at argopt+1
 *
 * Returns value on success and exits with error message on failure
 ***************************************************************************/
static char *
getoptval (int argcount, char **argvec, int argopt)
{
  if ( argvec == NULL || argvec[argopt] == NULL ) {
    fprintf (stderr, "getoptval(): NULL option requested\n");
    exit (1);
  }
  
  /* Special case of '-o -' usage */
  if ( (argopt+1) < argcount && strcmp (argvec[argopt], "-o") == 0 )
    if ( strcmp (argvec[argopt+1], "-") == 0 )
      return argvec[argopt+1];
  
  if ( (argopt+1) < argcount && *argvec[argopt+1] != '-' )
    return argvec[argopt+1];

  fprintf (stderr, "Option %s requires a value\n", argvec[argopt]);
  exit (1);
}  /* End of getoptval() */

/***************************************************************************
 * usage:
 * Print the usage message and exit.
 ***************************************************************************/
static void
usage (void)
{


  fprintf (stderr, "\nCommand: %s [options]\n\n", PACKAGE);
  fprintf (stderr,
           "Options:\n"
	   " -h             show this usage message\n"
           "\n"
           " -f   text      detection file (detect.TST)\n"
           " -par n         instance  parameter set. (default: 0)\n"
//           " -x   n         window size in pixels horizontal (default: 1000)\n"
//           " -y   n         window size in pixels vertical (default: 300)\n"
           " -xo  pixels    position of window x-direction (default: 0)\n"
           " -yo  pixels    position of window y-direction (default: 0)\n"
//           " -dly n         seconds delays between update of screen (default: 3)\n"
//           " -fac n         scale factor vertical (default: 10)\n"
           "\n");


}				/* End of usage() */


