/***************************************************************************
 *   Copyright (C) 2007 by seismo   *
 *   seismo@pclaptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif




/***************************************************************************
 * rtnet.c
 * SeedLink client using libslink (Chad Trabant).
 *
 ***************************************************************************/
#include <math.h>		                 // For math routines (such as sqrt & trig).
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <sys/shm.h>

#include <sh_mem_rt.h>
#include <libslink.h>

#include <GL/glut.h>                           // LINUX

#define PACKAGE "rtmon"
#define VERSION LIBSLINK_VERSION
 
static short int verbose  = 0;
static short int ppackets = 0;
static char * statefile   = 0;	    /* state file for saving/restoring state */
static char *dumpfile     = 0;	    /* output file for data dump */

static char *location     = "1";    // switch to read data for plotting
static FILE *outfile      = 0;      /* the descriptor for the dumpfile */
static int yheight        = 0;      /* max height in pixels */
static int xlenght        = 0;      /* max length in pixels */

//#define nch 50                                   // MAX NUMBER OF CHANNELS


int     WINH      = 800;               // DEFAULT WINDOW HEIGHT IN PIXELS
int     WINL      = 1000;              // DEFAULT WINDOW LENGTH IN PIXELS
int     xo        = 0;                 // coordinates for position on screen
int     yo        = 0;                 // coordinates for position on screen
int     klon      = 0;                 // instance of program
char    *topdir_rt= 0;                 // top directory RTQUAKE
char  window_title[80];
int k;
int i;
int m;
int j;
int stopwatch = 0;
int stno = 0;

int xstart;
int ystart;

int    ns[MAXCHA];
int    printarg;

long   ryrn[MAXCHA];
long   rmon[MAXCHA];
long   rday[MAXCHA];
long   rhrn[MAXCHA];
long   rmin[MAXCHA];
int    risec[MAXCHA];
float  rsek[MAXCHA];
int    rsecs[MAXCHA];
float  ftime[MAXCHA];
float  stpix[MAXCHA];
int    sr[MAXCHA];


float  v[MAXCHA];

char   rtid[MAXCHA][80];
char   lat[MAXCHA][80];
char   snr[MAXCHA][80];
char   tid[MAXCHA][80];
char   parname[80];
int    ix[MAXCHA];
int    time_quality[MAXCHA];



float R=0.0;
float G=0.0;
float B=0.0;

  double TIMESTART;
  double TIMESTOPP;
  double TIMEDIFF;

int    start_stop = 0;
char str[80];
char last[80];
int  seismo[1000];
float fseismo[1000];
int RunMode = 1;		// Used as a boolean (1 or 0) for "on" and "off"

char toplot[MAXCHA][20];
char fullna[MAXCHA][80];
int no_to_plot;

char tags[20][50];
float tags_ix[50];
int tag_index=0;

rtmod *spt;                        // pointer shared memory 

static int packet_handler (char *msrecord, int packet_type,
			    int seqnum, int packet_size);
static int parameter_proc (int argcount, char **argvec);
static char *getoptval (int argcount, char **argvec, int argopt);
static void usage (void);
static void FilterRescale(void);
static void Rescale(void);
static void appl(int fnd);
static int  DET_MEM(int kan);
static void DTE();
static void TIMSEC();
static void strip(int line);
static void bitmap_output(int x, int y, char *string,void *font);
static void STA_LTA();
static int  unpack_samples();
static void design();
static int  buroots();
//static void main(int argc,char **argv);


void drawScene(void)
{
  int ch;
  strip(ch);                           // PLOT THIS CHANNEL IN CORRESPONDING VIEWPORT
  glFlush();
  glutSwapBuffers();
  if ( RunMode==1 ) 
  {
    glutPostRedisplay();	       // Trigger an automatic redraw for animation
  }
  sleep(1);
}


void strip(int line)
{
  int   p;
  int   g;
  int   l;
  double k;
  char  tekst[400];
  char  header[400];
  int mm[MAXCHA];
  k=3380000000.0;
  sprintf(header,"   STATION        COUNTERS             STA        LTA   SNR DUR   LAT         DC DIFFS         TIME");
  glColor3f(0.0, 0.0, 0.0);
  glRecti(-WINL/2,-WINH/2,WINL/2,WINH/2);
  glColor3f(0.6,1.0,1.0);
  bitmap_output(xstart, ystart, header,GLUT_BITMAP_9_BY_15 );
  ystart = ystart - 20;


  for(p=0;p<no_to_plot;p++)
  {
    for(g=0;g<5;g++)
    {
      if(spt->age[klon][p][g] != 0)
      {
        glColor3f(1.0, 0.0, 0.0);
        break; 
      }else{
        glColor3f(0.0, 1.0, 0.0);
      } 
    }
    for(g=0;g<no_to_plot;g++)
    {

        if(spt->tt[klon][g] == -1)
        {
          mm[g] = 0;
        }else{
          mm[g] = 1;
        }
      
    }
    sprintf(tekst,"%s %4d%4d%4d%4d%4d %10.1f %10.1f  %4.1f %3d %5.1f %10.0f %1d%1d%1d%1d%1d %s",
toplot[p],spt->age[klon][p][0],spt->age[klon][p][1],spt->age[klon][p][2],spt->age[klon][p][3],spt->age[klon][p][4],spt->csta[klon][p],spt->clta[klon][p],
spt->csta[klon][p]/spt->clta[klon][p],spt->dur[klon][p],spt->latency[klon][p],spt->cdcavg[klon][p],
mm[p],mm[p],mm[p],mm[p],mm[p],spt->rtid[klon][p]);

//  bitmap_output(x_txt, y_txt, tekst,GLUT_BITMAP_HELVETICA_18);
    bitmap_output(xstart, ystart, tekst,GLUT_BITMAP_9_BY_15 );
    ystart = ystart - 20;
    glFlush();
  }
  ystart = WINH/2-20;
}


void tu_read_stationlist ( const char * streamfile)
{
  FILE *streamfp;
  char linje[80];                      // line read from file
  char station[80];
  char navn[80];
  char tempo[80];
  char filnam1[80];
  char tmp[80];
  char felles[20][200][80];
  int i,l,k,no;
  int br=0;
/* Open the station list file */
  sprintf(filnam1,"%s/par/%s",topdir_rt,streamfile);
  printf("Stationfile: %s\n",streamfile);
  sprintf(parname,"%s",streamfile);
  if ((streamfp = fopen (filnam1, "rb")) == NULL)
  {
    printf("Can't open: %s\n",filnam1);
    exit(0);
  }
  no = 200;
  i=0;
  l=0;
  for(i=0;i<no;i++)
  {
    if((fgets(linje, 70, streamfp)) != NULL)
    {
      printf("%2d %s",i,linje);
      sprintf(tempo,"%s",linje);
      for(l=0;l<80;l++)
      {
        station[l]='\0';
	navn[l]='\0';
      }
      for(k=0;k<20;k++)
        tmp[k]='\0';
      strncpy(tmp,linje,5);
//      printf("klon:%2d stas: %2d %s\n",klon,i,tmp);
      sprintf(spt->stasjon[klon][i],"%s",tmp);
      strncpy(station,linje,10);
      sprintf(toplot[i], "%s",station);
//      printf("%s\n",toplot[i]);
      for(l=0;l<40;l++)
        navn[l]=linje[l+11];
      sprintf(fullna[i],"%s",navn);
      for(l=0;l<40;l++)
        if(fullna[i][l] == '\n') fullna[i][l] = '\0';
//	  printf("%s\n",fullna[i]);
    }else{
      break;
    }
  }
  printf("End of file. File contains: %2d items\n",i);
  no_to_plot = i;
}




stroke_output(GLfloat x, GLfloat y, char *format,...)
{
  va_list args;
  char buffer[200], *p;

  va_start(args, format);
  vsprintf(buffer, format, args);
  va_end(args);
  glPushMatrix();
  glTranslatef(x, y, 0);
  glScalef(0.005, 0.005, 0.005);
  for (p = buffer; *p; p++)
    glutStrokeCharacter(GLUT_STROKE_ROMAN, *p);
  glPopMatrix();
}
void bitmap_output(int x, int y, char *string, void *font)
{
  int len, i;

  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) {
    glutBitmapCharacter(font, string[i]);
  }
}
void 
my_reshape(int w, int h)
{
   GLdouble size;
   GLdouble aspect;

   /* Use the whole window. */
   glViewport(0, 0, w, h);

   /* We are going to do some 2-D orthographic drawing. */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   size = (GLdouble)((w >= h) ? w : h) / 2.0;
   if (w <= h) {
      aspect = (GLdouble)h/(GLdouble)w;
      glOrtho(-size, size, -size*aspect, size*aspect, -100000.0, 100000.0);
   }
   else {
      aspect = (GLdouble)w/(GLdouble)h;
      glOrtho(-size*aspect, size*aspect, -size, size, -100000.0, 100000.0);
   }

   /* Make the world and window coordinates coincide so that 1.0 in */
   /* model space equals one pixel in window space.                 */
   glScaled(aspect, aspect, 1.0);

   /* Now determine where to draw things. */
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

}



void 
my_handle_key(unsigned char key, int x, int y)
{
  int l;
printf("%d\n",key);
   switch (key) {

   case 27:        // ESC exit
   exit(1);
   break;

   case 83:        // S Hold
   start_stop=1;
   break;
   case 115:       // s Resume
   start_stop=0;
   break;



   case 104:       // help
   printf("**************************************************************\n");
   printf("* List of key-press functions:                               *\n");
   printf("* ----------------------------                               *\n");
   printf("* h  : list this on screen                                   *\n");
   printf("* esc: exit                                                  *\n");
   printf("* u  : increase amplitude on all channels                    *\n");
   printf("* d  : decrease amplitude on all channels                    *\n");
   printf("* S  : freeze graphics                                       *\n");
   printf("* s  : resume graphics                                       *\n");
   printf("* n  : next channel                                          *\n");
   printf("* +  : increase amplitude on current channel                 *\n");
   printf("* -  : decrease amplitude on current channel                 *\n");
   printf("* F  : turn on pre-set filter                                *\n");
   printf("* f  : turn off filtering                                    *\n");
   printf("* 1  : Set color scheme to default                           *\n");
   printf("* 2  : Color scheme 2                                        *\n");
   printf("* 3  : Color scheme 3                                        *\n");
   printf("* 4  : Color scheme 4                                        *\n");
   printf("**************************************************************\n"); 
   break;

   default:
      break;
   }
  printf("%4.1f %4.1f %4.1f\n",R,G,B);
}





int main(int argc, char **argv)
{
  void          *shared_memory_rt = (void *)0;
  int           shmid_rt;
  char   title[80];
  char   tmp[80];
  char dum[10];
  int p;
  int j;
  int s;
  printarg = 0;
//------------------------------------------------------------------------
// set path to RTQUAKE_TOP as default
//------------------------------------------------------------------------
  topdir_rt = (char*)getenv("RTQUAKE_TOP");
  if (topdir_rt)
  {
    printf("RTMON: RTQUAKE_TOP: %s\n", topdir_rt);
  }else{
    printf("RTMON: RTQUAKE_TOP not defined\n");
    printf("Include setup_rt.bash or setup_rt.csh in your .bashrc or .csh\n");
    exit(0);      
  } 
//-------------------------------------------------------------------------
// open shared memory region                                                
//--------------------------------------------------------------------------
  if(printarg == 1)
    printf("Size shared module %d\n",(int)sizeof(rtmod));
  shmid_rt = shmget((key_t)5678, sizeof(rtmod), 0666 | IPC_CREAT);
  if(shmid_rt == -1)
  {
    fprintf(stderr, "shmget failed  2\n");
    exit(EXIT_FAILURE);
  }
  shared_memory_rt = shmat(shmid_rt, (void *)0, 0);
  if(shared_memory_rt == (void *)-1)
  {
    fprintf(stderr, "shmat failed\n");
    exit(EXIT_FAILURE);
  }
//-------------------------------------------------------------------------
// Compute pointer to shared memory region                                 
//-------------------------------------------------------------------------
  spt=(rtmod *)shared_memory_rt;  
// Process command line parameters
  if (parameter_proc (argc, argv) < 0)
  {
    fprintf(stderr, "Parameter processing failed\n\n");
    fprintf(stderr, "Try '-h' for detailed help\n");
    return -1;
  }
  if(no_to_plot > 40)  
    no_to_plot=30;
  
  
  for(p=0;p<80;p++)
    tmp[p] = '\0';
  for(p=0;p<80;p++)
  {
    if(parname[p] == '.')
      break;
  }
  s = 0;
  for(j=(p+1);j<(p+1+5);j++)
  {
    tmp[s] = parname[j];
    s++;
  }

  printf("TMP: %s\n",tmp);
  sprintf(title,"DETECTION MONITOR - Parameter set %d   ID: %s",klon+1,tmp);

  xstart = -WINL/2+5;
  WINH = (no_to_plot+1) * 25;
  ystart = WINH/2-20;
  printf("ystart: %d\n",ystart);
//*******************************************************************
// Set up for OpenGL graphics
//*******************************************************************
  glutInit(&argc,argv);

// We're going to animate it, so double buffer 
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );

// Window position (from top corner), and size (width% and hieght)
  glutInitWindowPosition( xo, yo );

// Set window size in pixels
  glutInitWindowSize( WINL, WINH );

// Create window with title given in parameters
  glutCreateWindow( title );

  glColor3f(0.0, 0.0, 0.0);
  glRecti(-WINL/2,-WINH/2,WINL/2,WINH/2);

// Detects a key-press. ESC exits program
   glutKeyboardFunc(my_handle_key);


// call this whenever window needs redrawing
  glutDisplayFunc( drawScene );

  glutReshapeFunc(my_reshape);


// Start the main loop.  glutMainLoop never returns.
  glutMainLoop(  );

  return 0;
}				/* End of main() */





/***************************************************************************
 * parameter_proc:
 *
 * Process the command line parameters.
 *
 * Returns 0 on success, and -1 on failure
 ***************************************************************************/
static int
parameter_proc (int argcount, char **argvec)
{
  int optind;
  int error = 0;

  char tm[80];  
  
 char *streamfile   = 0;	    /* stream list file for configuring streams */
 char *stationfile  = 0;      /* station list file for reading streams */

  char *multiselect = 0;
  char *selectors   = 0;

  if (argcount <= 0)
    error++;

  /* Process all command line arguments */
  for (optind = 1; optind < argcount; optind++)
    {
      if (strcmp (argvec[optind], "-V") == 0)
	{
	  fprintf(stderr, "%s version: %s\n", PACKAGE, VERSION);
	  exit (0);
	}
      else if (strcmp (argvec[optind], "-h") == 0)
	{
	  usage();
	  exit (0);
	}
      else if (strcmp (argvec[optind], "-c") == 0)
	{
          stationfile ="stations.conf";
	  tu_read_stationlist (stationfile) ;
	  exit (0);
	}
      else if (strncmp (argvec[optind], "-v", 2) == 0)
	{
	  verbose += strspn (&argvec[optind][1], "v");
	}
      else if (strcmp (argvec[optind], "-p") == 0)
	{
	  ppackets = 1;
	}



      else if (strcmp (argvec[optind], "-xo") == 0)
      {
        xo = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-yo") == 0)
      {
        yo = atoi(argvec[++optind]);
      }


      else if (strcmp (argvec[optind], "-o") == 0)
	{
	  dumpfile = getoptval(argcount, argvec, optind++);
	}
      else if (strcmp (argvec[optind], "-g") == 0)
	{
	  location = getoptval(argcount, argvec, optind++);
	}
      else if (strcmp (argvec[optind], "-x") == 0)
	{
	  xlenght = atoi(argvec[++optind]);
          WINL=xlenght;
	}
      else if (strcmp (argvec[optind], "-y") == 0)
	{
	  yheight = atoi(argvec[++optind]);
          WINH=yheight;
	}
      else if (strcmp (argvec[optind], "-par") == 0)
	{
	  klon = atoi(argvec[++optind]);
	}
      else if (strcmp (argvec[optind], "-l") == 0)
	{
	  streamfile = argvec[++optind];
	}
      else if (strcmp (argvec[optind], "-top") == 0)
      {
	  topdir_rt = argvec[++optind];
          printf("top directory: %s\n",topdir_rt);
      }
      else if (strcmp (argvec[optind], "-f") == 0)
	{
	  stationfile = argvec[++optind];
	}
      else if (strcmp (argvec[optind], "-s") == 0)
	{
	  selectors = argvec[++optind];
	}
      else if (strcmp (argvec[optind], "-S") == 0)
	{
	  multiselect = argvec[++optind];
sprintf(window_title,"%s",multiselect);
	}
//      else if (strcmp (argvec[optind], "-x") == 0)
//	{
//	  statefile = argvec[++optind];
//	}
      else if (strncmp (argvec[optind], "-", 1 ) == 0)
	{
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
	}


      else
	{
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
	}
    }




  /* Open dumpfile if requested */
  if (dumpfile)
    {
      if (!strcmp (dumpfile, "-"))
	{
	  /* Re-direct all messages to standard error */
//	  sl_loginit (verbose, &print_stderr, NULL, &print_stderr, NULL);

	  outfile = stdout;
	  setvbuf (stdout, NULL, _IONBF, 0);
	}
      else if ((outfile = fopen (dumpfile, "a+")) != NULL)
	{
	  setvbuf (outfile, NULL, _IONBF, 0);
	}
      else
	{
	  sl_log (2, 0, "cannot open dumpfile: %s\n", dumpfile);
	  exit (1);
	}
    }


  
  /* Report the program version */
  sl_log (0, 1, "%s version: %s\n", PACKAGE, VERSION);
  
  /* If errors then report the usage message and quit */
  if (error)
    {
      usage ();
      exit (1);
    }

  /* If verbosity is 2 or greater print detailed packet infor */
  if ( verbose >= 2 )
    ppackets = 1;
  

  /* Load the station list from a file if specified */
  if ( stationfile )
  {
    tu_read_stationlist (stationfile);
  }else{
    printf("detection file for specified parameter set must be specified\n");
    exit(0);
//    stationfile = "stations.conf";
//    tu_read_stationlist (stationfile);
  }

  

  

  
  return 0;
}				/* End of parameter_proc() */

/***************************************************************************
 * getoptval:
 * Return the value to a command line option; checking that the value is 
 * itself not an option (starting with '-') and is not past the end of
 * the argument list.
 *
 * argcount: total arguments in argvec
 * argvec: argument list
 * argopt: index of option to process, value is expected to be at argopt+1
 *
 * Returns value on success and exits with error message on failure
 ***************************************************************************/
static char *
getoptval (int argcount, char **argvec, int argopt)
{
  if ( argvec == NULL || argvec[argopt] == NULL ) {
    fprintf (stderr, "getoptval(): NULL option requested\n");
    exit (1);
  }
  
  /* Special case of '-o -' usage */
  if ( (argopt+1) < argcount && strcmp (argvec[argopt], "-o") == 0 )
    if ( strcmp (argvec[argopt+1], "-") == 0 )
      return argvec[argopt+1];
  
  if ( (argopt+1) < argcount && *argvec[argopt+1] != '-' )
    return argvec[argopt+1];

  fprintf (stderr, "Option %s requires a value\n", argvec[argopt]);
  exit (1);
}  /* End of getoptval() */

/***************************************************************************
 * usage:
 * Print the usage message and exit.
 ***************************************************************************/
static void
usage (void)
{


  fprintf (stderr, "\nCommand: %s [options] \n\n", PACKAGE);
  fprintf (stderr,
	   " Options:\n"
//	   " -V             report program version\n"
	   " -h             show this usage message\n"
           " -par n         instance  parameter set. (default: 0)\n"
//           " -top text      top directory (default: /home/seimo)\n"
//           " -x   pixels    width window in pixels (default: 1000)\n"
//           " -y   pixels    height window in pixels (default: 600)\n"
           " -xo  pixels    position of window x-direction (default: 0)\n"
           " -yo  pixels    position of window y-direction (default: 0)\n"
           "\n"
	   " -f   file      name detection file used by specified parameter set\n\n");
}				/* End of usage() */


//*=========================================================================      
//*                                                                               
//* Routine to convert from day-of-year to date                                   
//*                                                         Leif Kvamme 12-1-85   
void DTE (DOY,DAY,MON,YR)                                          
int DOY;
int *DAY;
int *MON;
int YR;
{
int MTH[14],J,M,N;
for(J=1;J<8;J=J+2)
    MTH[J] = 31;
for(J=8;J<13;J=J+2)
    MTH[J] = 31;
MTH[2] = 28;
MTH[4] = 30;
MTH[6] = 30;
MTH[9] = 30;
MTH[11]= 30;
if ((YR%4) == 0) MTH[2] = 29;
M = 0;                                                                    
for(J=1;J<13;J++)
{
    M = M + MTH[J];
    N = DOY - M;                                                              
    if (N <= 0)
    {                                                       
        *MON = J;
        *DAY = N + MTH[J];                                                     
        goto four;                                                               
    }
}
four:                                                                   
J=0;
}
void TIMSEC (YR,MTH,DAY,HR,MIN,SECS,MSECS)                         
int YR;
int MTH;
int DAY;
int HR;
int MIN;
float SECS;
double *MSECS;                         /* total seconds to be returned      */
{
int DYR;                               /* flag for leap year                */
int IYR;                               /* number of leap-years since 1900   */
int YDY;                               /* number of days in current year    */

if(YR <= 50) YR=YR+100;                /* check for 2000 or more in 2 digits*/

if(YR >= 1900) YR=YR - 1900;
DYR = 0;
if((YR % 4) == 0) DYR = 1;
IYR = YR/4 - DYR;
//                -- Seconds to beginning of     
*MSECS = (float)(IYR*366) + (float)((YR-IYR)*365);
//                -- current year                
*MSECS = *MSECS*86400.0;
//                -- January                     
if (MTH == 1) YDY = DAY;
//                -- February                    
if (MTH == 2) YDY = DAY + 31;
//                -- ....                        
if (MTH == 3) YDY = DAY + DYR + 59;       
if (MTH == 4) YDY = DAY + DYR + 90;                                     
if (MTH == 5) YDY = DAY + DYR + 120;                                    
if (MTH == 6) YDY = DAY + DYR + 151;                                    
if (MTH == 7) YDY = DAY + DYR + 181;                                    
if (MTH == 8) YDY = DAY + DYR + 212;                                    
if (MTH == 9) YDY = DAY + DYR + 243;                                    
if (MTH ==10) YDY = DAY + DYR + 273;                                    
if (MTH ==11) YDY = DAY + DYR + 304;                                    
if (MTH ==12) YDY = DAY + DYR + 334;                                    
*MSECS = *MSECS + (float)(YDY*86400 + HR*3600 + MIN*60) + SECS;
}




