//rtslpl -sc -fl 2.0 -y 750 -fh 8.0 -m 5 -cfg DEMO2
// rtslpl -sc -y 750 -fl 2.0 -fh 8.0 -cfg DEMO1
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <stdbool.h>
#include <libslink.h>
#include <signal.h>
#include <pthread.h>
#include <GL/glut.h>
#define nch 35                                   // MAX NUMBER OF CHANNELS
#define MAXCHA 200
#define NBSCALE 8                                // NUMBER OF BUFFERS SCALING

static int parameter_proc (int argcount, char **argvec);
static char *getoptval (int argcount, char **argvec, int argopt);
static void help(void);
static void C_TIME();
static int packet_handler (char *msrecord, int packet_type,
			    int seqnum, int packet_size,SLCD * slconn,int lno_str,int ns[],int sr[]);
static int  unpack_samples();
void READ_PACKETS ( void *ptr );
static void bitmap_output(int x, int y, char *string,void *font);
static void appl(int fnd,float fseismo[],int antsmp);
static int design();
static int  buroots();
static void DTE();
static int read_inputstreams();
static void read_servers();
static void Check_Config();
static int Find_SL_Servers();
static int Read_Config_to_MEM();
static void Set_Color_2();
static void Set_Color_3();
static void Set_Color_4();
static void Set_Def_Color();


static void TIMSEC();
static void strip(int line);
//****************  FILTER  **********************************
/* Type-independant absolute value for C standard types */
#ifndef abs
#define ABS(x) ((x)<0?-(x):(x))
#endif
#define TRUE 1


float   snc[nch][16];                            // filter coefficients
float   sdc[nch][16];                            // filter coefficients
int     cset[nch];

static  float save_y2[nch][16];                  // overlap between 2 filter buffers
static  float save_y1[nch][16];
static  float save_x2[nch][16];
static  float save_x1[nch][16];
typedef struct {float r, i;} complex;

/* Table of constant values */
static  float c_b12 = 2.;
static  complex c_b43 = {1.,0.};


/* Local function prototypes */
static  double warp();
static  int lptbp(), bilin2();


static  complex cmul(), cpowi(), csqrt1(), conjg(), cdiv();
char  cfgfile[80]   = "";              // configuration file 
char *topdir_rt = 0;                   // top directory RTQUAKE
int  farge=1;
static short int verbose  = 0;
static short int ppackets = 0;
int     xo=0;                          // coordinates for position on screen
int     yo=0;                          // coordinates for position on screen
int     sindob    = 0;                 // single or double buffering
//--------------------------------------------------------------
// DEFAULTS
//--------------------------------------------------------------
int minutter = 5;                                // MINUTES PER SCREEN
float   fl=-1.0;                                 // No filter, read by command line
float   fh=-1.0;                                 // No filter, read by command line
int     WINH      = 600;                         // DEFAULT WINDOW HEIGHT IN PIXELS
int     WINL      = 1000;                        // DEFAULT WINDOW LENGTH IN PIXELS

//float   eqavst;
//int     orden;
int    ns[nch];
static char *dumpfile     = 0;	    /* output file for data dump */
static char *location     = "1";    // switch to read data for plotting
static int yheight        = 0;      /* max height in pixels */
static int xlenght        = 0;      /* max length in pixels */

int no_to_plot;
int antall = 0;
int only_one = 0;
int stno = 0;
int demo_version = 0;
int stopwatch[nch]; 
//int auto_scaling = 0;
char  window_title[80];
static FILE *outfile      = 0;      /* the descriptor for the dumpfile */
char STREAMS_SERVER[200];
char STATIONS_SERVER[200];
char toplot[nch][20];
char streams[MAXCHA][100];
char stations[MAXCHA][100];
char slserv[MAXCHA][100];
char   allstreams[MAXCHA][200];
int     sseismo[MAXCHA][3000];
int    stream_count = 0;
int    kanaler_hver_stream[200];
char   tid[MAXCHA][100];

long   ryrn[MAXCHA];
long   rmon[MAXCHA];
long   rday[MAXCHA];
long   rhrn[MAXCHA];
long   rmin[MAXCHA];
int    risec[MAXCHA];
float  rsek[MAXCHA];
int    time_quality[MAXCHA];
int    rsecs[MAXCHA];
char   rtid[MAXCHA][200];
char   current_station[50];
char tabell[MAXCHA][MAXCHA];

int    firstbuf[MAXCHA];

float xold=-500.0;
float xnew=-500.0;
float yold=0.0;
float ynew=0.0;

int   TOTSMP    = 0;
float MINUTES   = 0.0;
int     TOTALSAMP = 90000;                       // DEFAULT TOTAL SAMPLES PER SCREEN
float   TOTALMINU = 15.0;                        // DEFAULT TOTAL MINUTES PER SCREEN
float amp=1.0;
float   AMP_STEP  = 4.0;                         // DEFAULT AMPLIFICATION STEP
int    start_stop = 0;
int    current_channel = 0;
float  amp_single[nch];
float   FL_PRESET = 2.0;                         // DEFAULT LOW-PASS FREQUENCY
float   FH_PRESET = 8.0;                         // DEFAULT HIGH-PASS FREQUENCY
int    sw2[nch];
float  v[nch];
int    sum[nch];
float values[nch][1000000];
int   trgflg[nch][1000000];
int   trgmrk[nch][1000000];
float R=0.0;
float G=0.0;
float B=0.0;

  double TIMESTART[nch];
  double TIMESTOPP[nch];
  double TIMEDIFF[nch];  
double CCC_TIME; 
double TNOW;
int    teller[nch];
int    ix[nch];
char ADDR_SERVER[200];
int NO_SERVERS;
int RunMode = 1;		// Used as a boolean (1 or 0) for "on" and "off"
int    init_sw=0;
char fullna[nch][80];
int    trigger[nch];
float  incr[nch];
  int     sr[MAXCHA];
char   lat[nch][80];
char   snr[nch][80];
float  stpix[nch]; 
int    counter[nch];
int no_to_plot;
int KAN = -1;
int    packs_flag[nch];
int    strip_flag[nch];
int    avg[nch];
int    sum[nch];
float  promedio[nch];
float  factor[nch];
float  scale_factor[nch];


float   YSCALE    = 400.0;                       // DEFAULT FACTOR FOR SCALING
/*****************/
/* COLOR SCHEMES */
/*****************/
float BGND_R;
float BGND_G;
float BGND_B;

float DRAW_R;
float DRAW_G;
float DRAW_B;

float NAME_R;
float NAME_G;
float NAME_B;

float DATE_R;
float DATE_G;
float DATE_B;

float LATE_R;
float LATE_G;
float LATE_B;

float DETE_R;
float DETE_G;
float DETE_B;

float RATI_R;
float RATI_G;
float RATI_B;

float PICK_R;
float PICK_G;
float PICK_B;

float CURN_R;
float CURN_G;
float CURN_B;

float AXIS_R;
float AXIS_G;
float AXIS_B;

/*****************/
/* COLOR SCHEMES */
/*****************/
float BGND_D_R = 0.0;                            // DEFAULT BACKGROUND  : BLACK
float BGND_D_G = 0.0;
float BGND_D_B = 0.0;

float DRAW_D_R = 1.0;                            // DEFAULT DRAW        : OKER
float DRAW_D_G = 0.6;
float DRAW_D_B = 0.0;

float NAME_D_R = 0.5;                            // DEFAULT STATION-NAME: YELLOW
float NAME_D_G = 0.7;
float NAME_D_B = 0.7;

float DATE_D_R = 0.0;                            // DEFAULT DATE        : GREEN
float DATE_D_G = 1.0;
float DATE_D_B = 0.0;

float LATE_D_R = 0.0;                            // DEFAULT LATENCY     : GREEN
float LATE_D_G = 1.0;
float LATE_D_B = 0.0;

float DETE_D_R = 1.0;                            // DEFAULT DETECTION   : RED
float DETE_D_G = 0.0;
float DETE_D_B = 0.0;

float RATI_D_R = 0.0;                            // DEFAULT RATIO       : GREEN
float RATI_D_G = 1.0;
float RATI_D_B = 0.0;

float PICK_D_R = 1.0;                            // DEFAULT PICKS       : RED
float PICK_D_G = 0.0;
float PICK_D_B = 0.0;

float CURN_D_R = 1.0;                            // DEFAULT CURRENT NAME: WHITE
float CURN_D_G = 1.0;
float CURN_D_B = 1.0;

float AXIS_D_R = 0.3;                            // DEFAULT AXIS        : GRAY
float AXIS_D_G = 0.3;
float AXIS_D_B = 0.3;

//------------------------------------------------------------------
// Mutex & Condition synchronizing of READ_PACKETS and BUFFER_SHUFLE
//------------------------------------------------------------------
pthread_mutex_t shufle_mutex;
pthread_cond_t signal_shufle; 
//------------------------------------------------------------------
// Mutex & Condition synchronizing of READ_PACKETS and BUFFER_SHUFLE
//------------------------------------------------------------------
pthread_mutex_t shift_mutex;
pthread_cond_t signal_shift; 

typedef struct str_thdata
{
    int thread_no;
    char ipaddr[100];
    char streams[100];
    char stations[100];
    int no_comp;
    int no_str;

} thdata;





/* process menu option 'op' */
void menu(int op) {
 
  switch(op) {
  case 'Q':
  case 'q':
    exit(0);
  }
}
 
/* executed when a regular key is pressed */
void keyboardDown(unsigned char key, int x, int y) {
 
  switch(key) {
  case 'Q':
  case 'q':
  case  27:   // ESC
    exit(0);
  }
}
 
/* executed when a regular key is released */
void keyboardUp(unsigned char key, int x, int y) {
 
}
 
/* executed when a special key is pressed */
void keyboardSpecialDown(int k, int x, int y) {
 
}
 
/* executed when a special key is released */
void keyboardSpecialUp(int k, int x, int y) {
 
}
 

/* executed when button 'button' is put into state 'state' at screen position ('x', 'y') */
void mouseClick(int button, int state, int x, int y) {
 
}
 
/* executed when the mouse moves to position ('x', 'y') */
void mouseMotion(int x, int y) {
 
}
/* executed when program is idle */
void idle() { 
 
}














//*=========================================================================      
//*                                                                               
//* Routine to convert from day-of-year to date                                   
//*                                                         Leif Kvamme 12-1-85   
void DTE (DOY,DAY,MON,YR)                                          
int DOY;
int *DAY;
int *MON;
int YR;
{
int MTH[14],J,M,N;
for(J=1;J<8;J=J+2)
    MTH[J] = 31;
for(J=8;J<13;J=J+2)
    MTH[J] = 31;
MTH[2] = 28;
MTH[4] = 30;
MTH[6] = 30;
MTH[9] = 30;
MTH[11]= 30;
if ((YR%4) == 0) MTH[2] = 29;
M = 0;                                                                    
for(J=1;J<13;J++)
{
    M = M + MTH[J];
    N = DOY - M;                                                              
    if (N <= 0)
    {                                                       
        *MON = J;
        *DAY = N + MTH[J];                                                     
        goto four;                                                               
    }
}
four:                                                                   
J=0;
}

void bitmap_output(int x, int y, char *string, void *font)
{
  int len, i;

  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) {
    glutBitmapCharacter(font, string[i]);
  }
}

void 
my_reshape(int w, int h)
{
   GLdouble size;
   GLdouble aspect;

   /* Use the whole window. */
   glViewport(0, 0, w, h);

   /* We are going to do some 2-D orthographic drawing. */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   size = (GLdouble)((w >= h) ? w : h) / 2.0;
   if (w <= h) {
      aspect = (GLdouble)h/(GLdouble)w;
      glOrtho(-size, size, -size*aspect, size*aspect, -100000.0, 100000.0);
   }
   else {
      aspect = (GLdouble)w/(GLdouble)h;
      glOrtho(-size*aspect, size*aspect, -size, size, -100000.0, 100000.0);
   }

   /* Make the world and window coordinates coincide so that 1.0 in */
   /* model space equals one pixel in window space.                 */
   glScaled(aspect, aspect, 1.0);

   /* Now determine where to draw things. */
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

}
void processMousePassiveMotion(int x, int y) {
  printf("pass: %4d,%4d\n",x,y);

}
void 
my_menu(int key)
{
  int l;
printf("%d\n",key);
   switch (key) {

   case 27:        // ESC exit
   exit(0);
   break;
   case 117:       // u amplify all channels
   amp=amp+AMP_STEP;
   break;
   case 100:       // d decrease all channel
   amp=amp-AMP_STEP;
   if(amp <= 0.0)
     amp=AMP_STEP;
   break;
   case 83:        // S Hold
   start_stop=1;
   break;
   case 115:       // s Resume
   start_stop=0;
   break;
   case 110:       // n next channel
   current_channel++;
   if(current_channel >= no_to_plot)
     current_channel = 0;
   break;
   case 43:        // + increase amplitude
   amp_single[current_channel]=amp_single[current_channel]+4.0;
   break;
   case 45:        // - decrease amplitude
   amp_single[current_channel]=amp_single[current_channel]-4.0;
   if(amp_single[current_channel] <= 0.0)
     amp_single[current_channel] = 1.0;
   break;
   case 70:        // F filter all
   if(fl == 0.0)
     fl=FL_PRESET;
   if(fh == 0.0)
     fh=FH_PRESET;
//   FilterRescale();
   for(l=0;l<no_to_plot;l++)
   {
     sw2[l]=50;
   }

   break;
   case 102:       // f no filter
   fl=0.0;
   fh=0.0;
   amp=1.0;
   for(l=0;l<no_to_plot;l++)
   {
     sw2[l]=0;
     teller[l]=0;
     v[l]=0.0;
     sum[l]=0.0;
   }
   for(l=0;l<no_to_plot;l++)
     amp_single[l]=1.0;
   break;
   case 116:
   trgflg[3][ix[3]]=1;
   break;
   case 104:       // help
   printf("**************************************************************\n");
   printf("* List of key-press functions:                               *\n");
   printf("* ----------------------------                               *\n");
   printf("* h  : list this on screen                                   *\n");
   printf("* esc: exit                                                  *\n");
   printf("* u  : increase amplitude on all channels                    *\n");
   printf("* d  : decrease amplitude on all channels                    *\n");
   printf("* S  : freeze graphics                                       *\n");
   printf("* s  : resume graphics                                       *\n");
   printf("* n  : next channel                                          *\n");
   printf("* +  : increase amplitude on current channel                 *\n");
   printf("* -  : decrease amplitude on current channel                 *\n");
   printf("* F  : turn on pre-set filter                                *\n");
   printf("* f  : turn off filtering                                    *\n");
   printf("* 1  : Set color scheme to default                           *\n");
   printf("* 2  : Color scheme 2                                        *\n");
   printf("* 3  : Color scheme 3                                        *\n");
   printf("* 4  : Color scheme 4                                        *\n");
   printf("**************************************************************\n"); 
   break;
   case 49:        // Set default colors
//   Set_Def_Color();
   break;
   case 50:        // Color scheme 2
//   Set_Color_2();
   break;
   case 51:        // Color scheme 3
//   Set_Color_3();
   break;
   case 52:        // Color scheme 4
//   Set_Color_4();
   break;
   default:
      break;
   }
  printf("%4.1f %4.1f %4.1f\n",R,G,B);
}


void processMouse(int button, int state, int x, int y) 
{
  int kanal;
  int space;
  char syscmd[200];
  char arg1[10];
  int rt1;
  
//  sleep
// if a mouse button is pressed  then
  if ((state == GLUT_DOWN)) 
  {
    if (button == GLUT_LEFT_BUTTON) 
	{
      printf("left: %5d,%5d\n",x,y);
  space = WINH/no_to_plot;
  kanal=y/space;
  printf("kanal: %d\n",kanal);
  sprintf(arg1,"-a %d",kanal);
  sprintf(syscmd,"rtnet -a %d -x 1000 -y 200 -l %s -f %s %s&\n",kanal,STREAMS_SERVER,STATIONS_SERVER,ADDR_SERVER);
#ifdef WIN32
  _spawnl(_P_NOWAIT,"c:\\VS\\RTNET\\debug\\rtnet.exe","rtnet.exe",arg1,"-y 200","129.177.55.30:18000",NULL);
#else
  printf("%s\n",syscmd);
  rt1=system(syscmd);
#endif
	}
		else if (button == GLUT_MIDDLE_BUTTON) {
			printf("midl: %5d,%5d\n",x,y);
		}
		else {
			printf("righ: %5d,%5d\n",x,y);
		}
	}
}

void drawScene2(void)
{
  for(;;)
  {
   if(KAN >=0)
   {
     strip(KAN);
// Flush the pipeline, swap the buffers
        glFlush();
        glutSwapBuffers();
        if ( RunMode==1 ) 
        {
          glutPostRedisplay();	// Trigger an automatic redraw for animation
        }        
     KAN=-1;
   }else{
     sleep(1);
   }
  }
}

void drawScene(void)
{
  int q;
  for(q=0;q<no_to_plot;q++)
  {
    strip(q);
    glFlush();	
    glutSwapBuffers();	
    if ( RunMode==1 ) 
      glutPostRedisplay();	// Trigger an automatic redraw for animation
  }
  sleep(2);
}
void strip(int line)
{
  double MSECS;  
  int DDAY,MMTH;
  int DY;
  int YR;
  long   yrn;
  long   mon;
  long   day;
  long   hrn;
  long   min;

  int   iyrn;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;
  
  int   data=0;
  float  sek;
  char dum[50];
  char   timestamp[80];
  int space;
  int x_txt=0;
  int y_txt=0;
  float x_tid=0.0;
  float y_tid=0.0;
  float y_station=0.0;

  float x1,y1,x2;
  float min_mark;
  float add=0.0;
  float maxval=0.0;
  float max=0.0;
  int   xpos;
  int   p,i;
  char  tekst[80];
  int minut=(int)MINUTES;

  space = WINH/no_to_plot;
  if(init_sw == 0)                               // CLEAR VIEWPORT INITIALLY
  {
    x_txt=-WINL/2+4;
    y_txt=WINH/2-15 * no_to_plot;

    for(p=0;p<no_to_plot;p++)
    {
      xpos=WINH-(p+1)*space;
      glViewport(0,xpos,WINL,space);
      glColor3f(BGND_R, BGND_G, BGND_B);
      glRecti(-WINL/2,-WINH/2,WINL/2,WINH/2);
      if(demo_version == 0)
      {
        glColor3f(DETE_R, DETE_G, DETE_B);       // PLOT STATION NAME IN RED INITIALLY
        sprintf(tekst,"%s",toplot[p]);
        bitmap_output(x_txt, y_txt, tekst,GLUT_BITMAP_9_BY_15 );
      }else{
        glColor3f(DETE_R, DETE_G, DETE_B);       // PLOT STATION FULL NAME IN RED INITIALLY
        sprintf(tekst,"%s",toplot[p]);
	strncpy(tekst,allstreams[p],13); tekst[13]='\0';
        bitmap_output(x_txt, y_txt, tekst,GLUT_BITMAP_HELVETICA_18);
      }
      glFlush();
    }
    glFlush();
    init_sw=1;
  }

  xpos=WINH-(line+1)*space;

  x_txt=-WINL/2+4;
  y_txt=WINH/2-15 * no_to_plot;

  y_station=WINH/2-20 * no_to_plot;

  y_tid=space;
  x_tid=(float)WINL/2.0;

  glViewport(0,xpos,WINL,space);

  x1=-WINL/2;
  x2= WINL/2;
  y1= 1.0 - (line+1) * space * 2.0/(float)space;

  glColor3f(BGND_R, BGND_G, BGND_B);             // ERASE VIEWPORT WITH FILLED RECTANGLE
  glRecti(-WINL/2,-WINH/2,WINL/2,WINH/2);


  glBegin( GL_LINES );                           // PLOT THE SIGNAL
  if(trigger[line] == 1)                         // IF IN DETECTION MODE CHANGE COLOR
  {
    glColor3f(DETE_R, DETE_G, DETE_B);
  }else{
    glColor3f(DRAW_R, DRAW_G, DRAW_B);           // IF NOT, USE NORMAL DRAWING COLOR
  }
//  if(auto_scaling == 1)
//  {
    max=0.0;
    for(i=0;i<TOTSMP;i++)
    {
      if(fabs((double)values[line][i]) > max)
        max=fabs((double)(values[line][i]));
    }
//  }


  for(i=0;i<TOTSMP;i++)                          // DRAW EACH SAMPLE
  {
    glVertex2f( xold, yold );
    glVertex2f( xnew, ynew );
    xold=xnew;
    yold=ynew;
    xnew=xnew+incr[line];
//    if(auto_scaling == 1)
//    {
      ynew=values[line][i]/max * ((float)WINH/2-2.0);
//    }else{
//      ynew=values[line][i];
//    }
  }
  glEnd();

  xold=-(WINL/2);                                // SET X BACK TO START OF VIEWPORT
  xnew=-(WINL/2);
  glBegin( GL_LINES );                           // PLOT PICKS IF ANY
  glColor3f(DETE_R, DETE_G, DETE_B);
  for(i=0;i<TOTSMP;i++)
  {
    if(trgflg[line][i]==1)
    {
      
      glVertex2f( xold, WINH/2 );
      glVertex2f( xnew, -WINH/2 );
    }
    xold=xnew;
    yold=ynew;
    xnew=xnew+incr[line];

  }
  glEnd();


  xold=-(WINL/2);                                // SET X BACK TO START OF VIEWPORT
  xnew=-(WINL/2);
  glBegin( GL_LINES );                           // PLOT PICKS , AT 'IXTRG'
  glColor3f(PICK_R, PICK_G, PICK_B);
  for(i=0;i<TOTSMP;i++)
  {
    if(trgmrk[line][i]==1)
    {
      
      glVertex2f( xold, WINH/2-2 );
      glVertex2f( xnew, -WINH/2+2 );
    }
    xold=xnew;
    yold=ynew;
    xnew=xnew+incr[line];

  }
  glEnd();


  glBegin( GL_LINES );                           // PLOT THE AXIS
  glColor3f(AXIS_R, AXIS_G, AXIS_B);
  glVertex2f( -WINL/2, -WINH/2+1 );
  glVertex2f( WINL/2, -WINH/2+1 );
  for(i=0;i<minut;i++)                           // PLOT MINUTE MARKS
  {
    add=i * 60.0 * sr[line] * incr[line];
    min_mark=-WINL/2 + stpix[line]+add;
    glVertex2f( min_mark, -WINH/2+50 );
    glVertex2f( min_mark, -WINH/2 );
  }
  glEnd();
  
  if(demo_version == 0)
  {
    glColor3f(NAME_R, NAME_G, NAME_B);           // PLOT STATION NAME
    if(current_channel == line)                  // CURRENT (FIRST) IN WHITE
      glColor3f(CURN_R, CURN_G, CURN_B);         // THE REST IN GREEN
    sprintf(tekst,"%s",toplot[line]);    
    bitmap_output(x_txt, y_txt, tekst,GLUT_BITMAP_9_BY_15 );
  }else{
    glColor3f(NAME_R, NAME_G, NAME_B);           // PLOT STATION FULL NAME
    if(current_channel == line)                  // CURRENT (FIRST) IN WHITE
      glColor3f(CURN_R, CURN_G, CURN_B);         // THE REST IN GREEN
    sprintf(tekst,"%s",toplot[line]);
    strncpy(tekst,allstreams[line],13); tekst[13]='\0';
    bitmap_output(x_txt, y_txt, tekst,GLUT_BITMAP_9_BY_15 );    
  }

  glColor3f(DATE_R, DATE_G, DATE_B);             // PLOT TIME


  sscanf(rtid[line],"%4d%1c%3d%1c%2d%1c%2d%1c%f6.3",&YR,dum,&DY,dum,&ihrn,dum,&imin,dum,&sek);
  hrn=ihrn;
  min=imin;
//-- convert from doy to date  
  DTE (DY,&DDAY,&MMTH,YR);
  yrn=YR;
  yrn=yrn-2000;
  mon=MMTH;
  day=DDAY;
  iday=day;
  imon=mon;
  iyrn=yrn;
  ihrn=hrn;
  imin=min;
  sprintf(timestamp,"%2d/%2d/%2d %2d:%2d:%6.3f",iday,imon,iyrn,ihrn,imin,sek);
  if(timestamp[0] == ' ') timestamp[0] = '0';
  if(timestamp[3] == ' ') timestamp[3] = '0';
  if(timestamp[6] == ' ') timestamp[6] = '0';
  if(timestamp[9] == ' ') timestamp[9] = '0';
  if(timestamp[12] == ' ') timestamp[12] = '0';
  if(timestamp[15] == ' ') timestamp[15] = '0';
  if(timestamp[18] == ' ') timestamp[18] = '0';
  if(timestamp[19] == ' ') timestamp[19] = '0';
  if(timestamp[20] == ' ') timestamp[20] = '0';
  
  if(timestamp[0] == '0' && timestamp[1] == '0' || timestamp[0] == '-')
  {
    data = 0;
    if(counter[line] < 60)
    {
      sprintf(timestamp,"NO DATA %2d",counter[line]);
    }else{
      sprintf(timestamp,"        ");
    }
  }else{
    data = 1;
  }

  
  sprintf(tekst,"%s",rtid[line]);

  if(demo_version == 0)
  {
    bitmap_output(WINL/2-200, y_txt, tekst,GLUT_BITMAP_8_BY_13 );
    glColor3f(LATE_R, LATE_G, LATE_B);           // PLOT LATENCY

  }else{
    if(data == 0)
      glColor3f(DETE_R, DETE_G, DETE_B);      
    bitmap_output(WINL/2-200, y_txt, timestamp,GLUT_BITMAP_8_BY_13 );    
  }
  xold=-(float)(WINL/2);                         // SET X BACK TO START OF VIEWPORT
  xnew=-(float)(WINL/2);

  if(time_quality[line] == 1)                    // PLOT SQUARE TO MARK GPS STATUS
  {
    glColor3f(DETE_R, DETE_G, DETE_B);           // ONLY MARK IT IF OUT OF SYNC
	glRecti(WINL/2-10,WINH/2-100,WINL/2,WINH/2);
  }else{
    glColor3f(BGND_R, BGND_G, BGND_B);
	glRecti(WINL/2-10,WINH/2-100,WINL/2,WINH/2);
  }

  if((TIMESTOPP[line] - TIMESTART[line]) == 0.0)   // no new data
  {
    counter[line]++;
    if(counter[line] > 60)    
    {
      xpos=WINH-(line+1)*space;
      glViewport(0,xpos,WINL,space);
      glColor3f(DETE_R, DETE_G, DETE_B); 
      sprintf(tekst,"NOT RECEIVING DATA");
      bitmap_output(-100, y_txt, tekst,GLUT_BITMAP_8_BY_13 );
    }
  }else{
    TIMESTART[line] = TIMESTOPP[line];
    counter[line]=0;    
  }




}


void Set_Def_Color()
{
   BGND_R = BGND_D_R;
   BGND_G = BGND_D_G;
   BGND_B = BGND_D_B;

   DRAW_R = DRAW_D_R;
   DRAW_G = DRAW_D_G;
   DRAW_B = DRAW_D_B;

   NAME_R = NAME_D_R;
   NAME_G = NAME_D_G;
   NAME_B = NAME_D_B;

   DATE_R = DATE_D_R;
   DATE_G = DATE_D_G;
   DATE_B = DATE_D_B;

   LATE_R = LATE_D_R;
   LATE_G = LATE_D_G;
   LATE_B = LATE_D_B;

   DETE_R = DETE_D_R;
   DETE_G = DETE_D_G;
   DETE_B = DETE_D_B;

   RATI_R = RATI_D_R;
   RATI_G = RATI_D_G;
   RATI_B = RATI_D_B;

   PICK_R = PICK_D_R; 
   PICK_G = PICK_D_G;
   PICK_B = PICK_D_B;

   CURN_R = CURN_D_R;
   CURN_G = CURN_D_G;
   CURN_B = CURN_D_B;

   AXIS_R = AXIS_D_R;
   AXIS_G = AXIS_D_G;
   AXIS_B = AXIS_D_B;
}

void Set_Color_2()
{
   BGND_R = 1.0;   
   BGND_G = 1.0;   // WHITE
   BGND_B = 1.0;

   DRAW_R = 0.0;
   DRAW_G = 0.0;   // BLACK
   DRAW_B = 0.0;

   NAME_R = 0.5;
   NAME_G = 0.5;   // GRAY
   NAME_B = 0.5;

   DETE_R = 1.0;
   DETE_G = 0.0;   // RED
   DETE_B = 0.0;

   DATE_R = 0.5;
   DATE_G = 0.5;   // GRAY
   DATE_B = 0.5;

   RATI_R = 0.5;
   RATI_G = 0.5;   // GRAY
   RATI_B = 0.5;

   LATE_R = 0.5;
   LATE_G = 0.5;   // GRAY
   LATE_B = 0.5;

   PICK_R = 1.0; 
   PICK_G = 0.0;   // RED
   PICK_B = 0.0;

   CURN_R = 0.0;
   CURN_G = 0.0;   // BLACK
   CURN_B = 0.0;

   AXIS_R = 0.5;
   AXIS_G = 0.5;   // GRAY
   AXIS_B = 0.5;
}
void Set_Color_3()
{
   BGND_R = 0.7;
   BGND_G = 0.9;   // VERY LIGHT BLUE
   BGND_B = 0.9;

   DRAW_R = 0.0;
   DRAW_G = 0.0;   // BLACK
   DRAW_B = 0.0;

   NAME_R = 0.0;
   NAME_G = 0.0;   // BLUE
   NAME_B = 1.0;

   DETE_R = 1.0;
   DETE_G = 0.0;   // RED
   DETE_B = 0.0;

   DATE_R = 0.0;
   DATE_G = 0.0;   // BLUE
   DATE_B = 1.0;

   RATI_R = 0.0;
   RATI_G = 0.0;   // BLUE
   RATI_B = 1.0;

   LATE_R = 0.0;
   LATE_G = 0.0;   // BLUE
   LATE_B = 1.0;

   PICK_R = 1.0; 
   PICK_G = 0.0;   // RED
   PICK_B = 0.0;

   CURN_R = 0.5;
   CURN_G = 0.5;   // RED
   CURN_B = 0.5;

   AXIS_R = 0.5;
   AXIS_G = 0.5;   // GRAY
   AXIS_B = 0.5;
}
void Set_Color_4()
{
   BGND_R = 1.0;
   BGND_G = 0.6;   // OKER
   BGND_B = 0.0;

   DRAW_R = 0.0;
   DRAW_G = 0.0;   // BLACK
   DRAW_B = 0.0;

   NAME_R = 0.0;
   NAME_G = 0.0;   // BLUE
   NAME_B = 1.0;

   DETE_R = 1.0;
   DETE_G = 0.0;   // RED
   DETE_B = 0.0;

   DATE_R = 0.0;
   DATE_G = 0.0;   // BLUE
   DATE_B = 1.0;

   RATI_R = 0.0;
   RATI_G = 0.0;   // BLUE
   RATI_B = 1.0;

   LATE_R = 0.0;
   LATE_G = 0.0;   // BLUE
   LATE_B = 1.0;

   PICK_R = 1.0; 
   PICK_G = 0.0;   // RED
   PICK_B = 0.0;

   CURN_R = 0.5;
   CURN_G = 0.5;   // RED
   CURN_B = 0.5;

   AXIS_R = 0.5;
   AXIS_G = 0.5;   // GRAY
   AXIS_B = 0.5;
}
int main(int argc, char **argv)
{
  FILE *out;
  int  idum;
//  void      *shared_memory_rt = (void *)0;
//  int       shmid_rt; 
  int i;
  int k;
  int q;
  int p;
  int nc;
  int ix;
  
 
  
  char syscmd[100];
  int  ret5;
  
  char *environment;                    // TRANSFER_BASE
  
  char  mempar[500][256];               // copy of configuration file  
  int   no_of_lines_cfg;                // number of lines in configuration file

  char  memsrv[100][100];               // servers specified in configuration file
  int   no_of_servers;                  // number of servers specified in configuration file   
 
  char  memnet[500][256];               //all network streams specified as NETWORK in conf. file
  int   no_of_nets;                     // number of networks specified in configuration file  

  char  memrec[500][256];               //all network streams specified as RECORD in conf. file
  int   no_of_rec;                      // number of networks specified in configuration file   
  
  char  stream_names[500][10];          // name of stream files
  int   no_of_stream_files;             // number of stream files
  
  int   start_net[500];                 // start index of nework
  int   stopp_net[500];                 // stop index of network 

 
  
  int   min_trg_net[500];               // minimum number of triggers per network
  int   total_streams_net;              // total number of streams networks   
  
  char streamsfull[255]; 
  char strpath[255];

  int  str_cnt;
  
  char nw[10];
  char stasjon[10];
  char lok[10];
  char cmp[10];
  char srv[10];
  char stlin[20];
  
  char wnd_title[200];
  
  
  pthread_t trg_mul_thread;             // definition for TRG_MUL thread
  pthread_t buffer_shufle_thread;       // definition for BUFFER_SHUFLE thread
  pthread_t read_packets_thread1;       // definition for READ_PACKETS thread
  pthread_t check_mails_thread1;        // definition for CHECK_MAILS thread
  thdata data1;


/*****************/
/* COLOR SCHEMES */
/*****************/
   BGND_R = BGND_D_R;
   BGND_G = BGND_D_G;
   BGND_B = BGND_D_B;

   DRAW_R = DRAW_D_R;
   DRAW_G = DRAW_D_G;
   DRAW_B = DRAW_D_B;

   NAME_R = NAME_D_R;
   NAME_G = NAME_D_G;
   NAME_B = NAME_D_B;

   DATE_R = DATE_D_R;
   DATE_G = DATE_D_G;
   DATE_B = DATE_D_B;

   LATE_R = LATE_D_R;
   LATE_G = LATE_D_G;
   LATE_B = LATE_D_B;

   DETE_R = DETE_D_R;
   DETE_G = DETE_D_G;
   DETE_B = DETE_D_B;

   RATI_R = RATI_D_R;
   RATI_G = RATI_D_G;
   RATI_B = RATI_D_B;

   PICK_R = PICK_D_R; 
   PICK_G = PICK_D_G;
   PICK_B = PICK_D_B;

   CURN_R = CURN_D_R;
   CURN_G = CURN_D_G;
   CURN_B = CURN_D_B;

   AXIS_R = AXIS_D_R;
   AXIS_G = AXIS_D_G;
   AXIS_B = AXIS_D_B;

  for(i=0;i<nch;i++)
    incr[i] = -1.0;    


//------------------------------------------------------------------------
// set path to RTQUAKE_TOP as default
//------------------------------------------------------------------------
  topdir_rt = (char*)getenv("RTQUAKE_TOP");
  if (topdir_rt)
  {
    printf("RTSLPL: RTQUAKE_TOP:		%s\n", topdir_rt);
  }else{
    printf("RTSLPL: RTQUAKE_TOP not defined\n");
    printf("Include setup_rt.bash or setup_rt.csh in your .bashrc or .csh\n");
    exit(0);      
  }
  
//------------------------------------------------------------------------
// read rtquake.par if exist, otherwise use defaults
//------------------------------------------------------------------------
//  Read_Parameters();  
//-------------------------------------------------------------------------
// Process command line parameters
//-------------------------------------------------------------------------
  if (parameter_proc (argc, argv) < 0)
  {
    printf("RTDET: Parameter processing failed\n\n");
    printf("       Try '-h' for detailed help\n");
    exit(0);
  }  
//------------------------------------------------------------------
// check configuration file
//------------------------------------------------------------------
  printf("*************Check_Config*****************************\n");
  Check_Config(cfgfile);
//------------------------------------------------------------------
// read configuration file into memory
//------------------------------------------------------------------
  printf("*************Read_Config_to_MEM*****************************\n");  
  no_of_lines_cfg = Read_Config_to_MEM(cfgfile,mempar);
  printf("number of lines in parameter file: no_of_lines_cfg %d   MEMPAR\n",no_of_lines_cfg);
  
  for(i=0;i<no_of_lines_cfg;i++)
    printf("%3d %s",i,mempar[i]);
  printf("\n");
 
//-------------------------------------------------------------------------------
// Find all seedlink servers specified under label SERVERS in configuration file
//-------------------------------------------------------------------------------

  printf("*************Find_SL_Servers*****************************\n");  
  no_of_servers = Find_SL_Servers(no_of_lines_cfg,mempar,memsrv);
 
  printf("number of servers specified: no_of_servers %d   MEMSRV\n",no_of_servers);

  for(i=0;i<no_of_servers;i++)
    printf("%3d %s",i,memsrv[i]);
    
//----------------------------------------------------------------
// Read memsrv 
//----------------------------------------------------------------
  printf("***************read_servers************************************\n");
  printf("no_of_servers: %d\n",no_of_servers);
  read_servers(no_of_servers,memsrv);

  printf("no_of_servers: %d\n",no_of_servers);
  for(p=0;p<no_of_servers;p++)
    printf("%s %s\n",streams[p],slserv[p]);
 
  printf("***************************************************************\n");  
    
//----------------------------------------------------------------
// Read streams files specified in configfile
//----------------------------------------------------------------
    for(i=0;i<MAXCHA;i++)
    {
      for(p=0;p<MAXCHA;p++)
	tabell[i][p]=' ';
    }
    ix=0;
    printf("number of streams specified %d, %d-%d\n",no_of_lines_cfg,no_of_servers+3,no_of_lines_cfg-1);
    for(p=0;p<no_of_servers;p++)
    {
      sprintf(strpath,"%s/par/%s/SLPL_%s",topdir_rt,cfgfile,streams[p]);
      out=fopen(strpath,"w");
      for(i=(no_of_servers+3);i<(no_of_lines_cfg-1);i++)
      {
	sscanf(mempar[i],"%s %s %s %s %s",nw,stasjon,lok,cmp,srv);
        if(strstr(srv,streams[p]))
	{
	  
	  sprintf(toplot[ix],"%s",stasjon);
	  sprintf(toplot[ix],"%s %s",nw,stasjon);  
	  q=0;
	  for(k=0;k<8;k++)
	  {
	    stlin[q]=mempar[i][k];
	    q++;
	  }
	  for(k=9;k<11;k++)
	  {
	    stlin[q]=mempar[i][k];
	    q++;
	  }
	  for(k=13;k<16;k++)
	  {
	    stlin[q]=mempar[i][k];
	    q++;
	  }	  
	  stlin[q]='\0';
	  if(stlin[8]=='.') stlin[8]=' ';
	  if(stlin[9]=='.') stlin[9]=' ';
	  printf("%s\n",stlin);
	  tabell[ix][ix]='X';
	  ix++;
	  fprintf(out,"%s\n",stlin);
	}
      }
      fclose(out);
    }
    printf("**************************************************************************\n");
    printf("Read input streams specified in configfile:\n");
  
  for(p=0;p<no_of_servers;p++)
  {
    sprintf(strpath,"%s/par/%s/SLPL_%s",topdir_rt,cfgfile,streams[p]);

      printf("Read streams-file: %s\n",strpath);
    read_inputstreams(strpath,p);
  }

    printf("total number of input-streams  stream_count: %d\n",stream_count);
//  if(printarg > 0)
//  {
    printf("allstreams:\n");
    for(p=0;p<stream_count;p++)
      printf("%3d %s\n",p,allstreams[p]);  
    printf("NO_OF_STREAM_FILES: %d\n",no_of_stream_files);
    no_to_plot=stream_count;

    
    switch(farge)
    {
      case 1:
      Set_Def_Color();
      break;
      case 2:
      Set_Color_2();
      break;
      case 3:
      Set_Color_3();
      break;
      case 4:
      Set_Color_4();
      break;
    }

    
//-----------------------------------------------------------------------
// initialize stopwatch
//-----------------------------------------------------------------------
      C_TIME();
      TNOW = CCC_TIME;
      for(p=0;p<nch;p++)
      {
	TIMESTART[p]=TNOW;
	TIMESTOPP[p]=TNOW;
      }
    
    
  for(p=0;p<no_of_servers;p++)
  {
//----------------------------------------------------------------
// Prepare structure for threads
//----------------------------------------------------------------
    data1.thread_no = p+1;    
    strcpy(data1.ipaddr, slserv[p]);    
    strcpy(data1.streams,streams[p]);    
    strcpy(data1.stations,stations[p]);    
    data1.no_comp = 0;
    data1.no_str = str_cnt;

    pthread_create (&read_packets_thread1, NULL, (void *) &READ_PACKETS, (void *) &data1);
    sleep(1);
  }         
    
    
    
  xold=-(float)(WINL/2);                         // SET X BACK TO START OF VIEWPORT
  xnew=-(float)(WINL/2);


  if(minutter == 0)
  {
    TOTSMP    = TOTALSAMP;
    MINUTES   = TOTALMINU;
  }else{
    switch(minutter)
	{
	  case 1:
	    TOTSMP = 6000;
	    MINUTES= 1.0;
TOTSMP=30000;
	  break;
	  case 2:
	    TOTSMP = 12000;
TOTSMP=60000;
	    MINUTES= 2.0;
	  break;
	  case 3:
	    TOTSMP = 18000;
TOTSMP=90000;
	    MINUTES= 3.0;
	  break;
	  case 4:
	    TOTSMP = 24000;
TOTSMP=120000;
	    MINUTES= 4.0;
	  break;
	  case 5:
	    TOTSMP = 30000;
TOTSMP=150000;
	    MINUTES= 5.0;
	  break;
	  case 10:
	    TOTSMP = 60000;
TOTSMP=300000;
	    MINUTES= 10.0;
	  break;
	  case 15:
	    TOTSMP = 90000;
TOTSMP=450000;
	    MINUTES= 15.0;
	  break;
	  case 30:
            TOTSMP = 180000;
TOTSMP=900000;
	    MINUTES= 30.0;
	  break;
	  case 60:
            TOTSMP = 360000;
	    MINUTES= 60.0;
	  break;
	  default:
            TOTSMP    = TOTALSAMP;
            MINUTES   = TOTALMINU;
	  break;
	}
  }    
    

 
 if(fl < 0.0)
 {
   sprintf(wnd_title,"REAL TIME DATA   No filter");
 }else{
   sprintf(wnd_title,"REAL TIME DATA   Bandpass filter: %6.3f - %6.3f Hz",fl,fh); 
 }
 
//*******************************************************************
// Set up for OpenGL graphics
//*******************************************************************
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
  glutInitWindowSize( WINL, WINH );  
  glutInitWindowPosition( xo, yo );
  glutCreateWindow( wnd_title );

  glColor3f(0.0, 0.0, 0.0);
  glRecti(-WINL/2,-WINH/2,WINL/2,WINH/2);  

  
  // register glut call backs
  glutKeyboardFunc(keyboardDown);
  glutKeyboardUpFunc(keyboardUp);
  glutSpecialFunc(keyboardSpecialDown);
  glutSpecialUpFunc(keyboardSpecialUp);
  glutMouseFunc(mouseClick);
  glutMotionFunc(mouseMotion);

//  glutDisplayFunc(draw);  
  glutIdleFunc(idle);
  glutIgnoreKeyRepeat(true); // ignore keys held down
 
  // create a sub menu 
  int subMenu = glutCreateMenu(menu);
  glutAddMenuEntry("Do nothing", 0);
  glutAddMenuEntry("Really Quit", 'q');
 
  // create main "right click" menu
  glutCreateMenu(menu);
  glutAddSubMenu("Sub Menu", subMenu);
  glutAddMenuEntry("Quit", 'q');
  glutAttachMenu(GLUT_RIGHT_BUTTON);  
  
  
  
//adding here the mouse processing callbacks
//	glutMouseFunc(processMouse);
//	glutMotionFunc(processMouseActiveMotion);
//    glutPassiveMotionFunc(processMousePassiveMotion);
/*
  glutCreateMenu(my_menu);
  glutAddMenuEntry("Increase amplitude all channels", 117);
  glutAddMenuEntry("Decrease amplitude all channels", 100);
  glutAddMenuEntry("Freeze graphics", 83);
  glutAddMenuEntry("Resume graphics", 115);
  glutAddMenuEntry("Set next channel", 110);
  glutAddMenuEntry("Increase amplitude current channel", 43);
  glutAddMenuEntry("Decrease amplitude current channel", 45);
  glutAddMenuEntry("Turn on pre-set filter", 70);
  glutAddMenuEntry("Turn off pre-set filter", 102);
  glutAddMenuEntry("Set default colors", 49);
  glutAddMenuEntry("Color scheme 1", 50);
  glutAddMenuEntry("Color scheme 2", 51);
  glutAddMenuEntry("Color scheme 3", 52);
  glutAddMenuEntry("Quit", 27);
  glutAttachMenu(GLUT_RIGHT_BUTTON);
*/

// createMenu();
  
  
// call this whenever window needs redrawing
  glutDisplayFunc( drawScene );

  glutReshapeFunc(my_reshape);


// Start the main loop.  glutMainLoop never returns.
  glutMainLoop();
 
 
 
 
return 0;
  
}


/***************************************************************************
 * parameter_proc:
 *
 * Process the command line parameters.
 *
 * Returns 0 on success, and -1 on failure
 ***************************************************************************/
static int
parameter_proc (int argcount, char **argvec)
{
  int optind;
  int error = 0;

  char tm[80];  
  
 char *streamfile   = 0;	    /* stream list file for configuring streams */
 char streamsfull[80];
 char *stationfile  = 0;      /* station list file for reading streams */

  char *multiselect = 0;
  char *selectors   = 0;

  if (argcount <= 1)
    error++;

  /* Process all command line arguments */
  for (optind = 1; optind < argcount; optind++)
  {
      if (strcmp (argvec[optind], "-V") == 0)
      {
//	  fprintf(stderr, "%s version: %s\n", PACKAGE, VERSION);
	  exit (0);
      }
      else if (strcmp (argvec[optind], "-h") == 0)
      {
	  help();
	  exit (0);
      }
//      else if (strcmp (argvec[optind], "-c") == 0)
//      {
//          stationfile ="stations.conf";
//	  tu_read_stationlist (stationfile) ;
//	  exit (0);
//      }
      else if (strncmp (argvec[optind], "-v", 2) == 0)
      {
	  verbose += strspn (&argvec[optind][1], "v");
      }
    else if (strcmp (argvec[optind], "-cfg") == 0)         // input config file
    {
      strcpy(cfgfile, argvec[++optind]);

        printf("Config: %s\n",cfgfile);
    }          
//      else if (strcmp (argvec[optind], "-p") == 0)
//      {
//	  ppackets = 1;
//      }
      else if (strcmp (argvec[optind], "-xo") == 0)
      {
        xo = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-yo") == 0)
      {
        yo = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-buf") == 0)
      {
        sindob = atoi(argvec[++optind]);
      }
//      else if (strcmp (argvec[optind], "-nt") == 0)
//      {
//	  slconn->netto = atoi (argvec[++optind]);
//      }
//      else if (strcmp (argvec[optind], "-nd") == 0)
//      {
//	  slconn->netdly = atoi (argvec[++optind]);
//      }
//      else if (strcmp (argvec[optind], "-k") == 0)
//      {
//	 slconn->keepalive = atoi (argvec[++optind]);
//      }
      else if (strcmp (argvec[optind], "-m") == 0)
      {
	  minutter = atoi (argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-fl") == 0)
      {
	  fl = atof (argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-fh") == 0)
      {
	  fh = atof (argvec[++optind]);
      }
//      else if (strcmp (argvec[optind], "-top") == 0)
//      {
//	  topdir_rt = argvec[++optind];
//          printf("top directory: %s\n",topdir_rt);
//      }
      else if (strcmp (argvec[optind], "-col") == 0)
      {
	  farge = atoi (argvec[++optind]);
          printf("farge: %d\n",farge);
      }      
      else if (strcmp (argvec[optind], "-o") == 0)
      {
	  dumpfile = getoptval(argcount, argvec, optind++);
      }
      else if (strcmp (argvec[optind], "-g") == 0)
      {
	  location = getoptval(argcount, argvec, optind++);
      }
      else if (strcmp (argvec[optind], "-x") == 0)
      {
	  xlenght = atoi(argvec[++optind]);
          WINL=xlenght;
      }
      else if (strcmp (argvec[optind], "-y") == 0)
      {
	  yheight = atoi(argvec[++optind]);
          WINH=yheight;
      }

//      else if (strcmp (argvec[optind], "-n") == 0)
//      {
//	  no_to_plot = atoi(argvec[++optind]);
//          antall=1;
//      }
//      else if (strcmp (argvec[optind], "-a") == 0)
//      {
//	  stno = atoi(argvec[++optind]);
//          only_one = 1;
//          printf("stno: %d\n",stno);
//      }

      else if (strcmp (argvec[optind], "-d") == 0)
      {

          demo_version = 1;
      }
//      else if (strcmp (argvec[optind], "-sc") == 0)
//      {
//          auto_scaling = 1;
//      }
      else if (strcmp (argvec[optind], "-l") == 0)
      {
	  streamfile = argvec[++optind];
      }
      else if (strcmp (argvec[optind], "-f") == 0)
      {
	  stationfile = argvec[++optind];
      }
      else if (strcmp (argvec[optind], "-s") == 0)
      {
	  selectors = argvec[++optind];
      }
      else if (strcmp (argvec[optind], "-S") == 0)
      {
	  multiselect = argvec[++optind];
          sprintf(window_title,"%s",multiselect);
      }
      else if (strncmp (argvec[optind], "-", 1 ) == 0)
      {
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
      }
//      else if (!slconn->sladdr)
//      {
//	  slconn->sladdr = argvec[optind];
//	  printf("ADDR: %s\n",argvec[optind]);
//	  sprintf(ADDR_SERVER,"%s",argvec[optind]);
//      }

      else
      {
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
      }
  }

  /* Make sure a server was specified */
//  if ( ! slconn->sladdr )
//    {
//      fprintf(stderr, "No SeedLink server specified\n\n");
//      fprintf(stderr, "Usage: %s [options] [host][:port]\n", PACKAGE);
//      fprintf(stderr, "Try '-h' for detailed help\n");
//      exit (1);
//    }

  /* Initialize the verbosity for the sl_log function */
  sl_loginit (verbose, NULL, NULL, NULL, NULL);


  /* Open dumpfile if requested */
  if (dumpfile)
    {
      if (!strcmp (dumpfile, "-"))
	{
	  /* Re-direct all messages to standard error */
//	  sl_loginit (verbose, &print_stderr, NULL, &print_stderr, NULL);

	  outfile = stdout;
	  setvbuf (stdout, NULL, _IONBF, 0);
	}
      else if ((outfile = fopen (dumpfile, "a+")) != NULL)
	{
	  setvbuf (outfile, NULL, _IONBF, 0);
	}
      else
	{
	  sl_log (2, 0, "cannot open dumpfile: %s\n", dumpfile);
	  exit (1);
	}
    }


  

  if (error)
    {
      help();
      exit (1);
    }

  /* If verbosity is 2 or greater print detailed packet infor */
  if ( verbose >= 2 )
    ppackets = 1;

  /* Load the stream list from a file if specified */
  if ( streamfile )
  {
    printf("STREAMFILE: %s\n",streamfile);
      sprintf(STREAMS_SERVER,"%s",streamfile);
    sprintf(streamsfull,"%s/par/%s",topdir_rt,streamfile);
    streamfile = streamsfull;
    printf("streamfile: %s\n",streamfile);
//    sl_read_streamlist (slconn, streamfile, selectors);
  }else{
    sprintf(streamsfull,"%s/par/streams.conf",topdir_rt);
    streamfile = streamsfull;
    printf("streamfile: %s\n",streamfile);
//    sl_read_streamlist (slconn, streamfile, selectors);
  }

  /* Load the station list from a file if specified */
  if ( stationfile )
  {
//    tu_read_stationlist (stationfile);
  }else{
    stationfile = "stations.conf";
//    tu_read_stationlist (stationfile);
  }
  

  sprintf(STATIONS_SERVER,"%s",stationfile);
  
//  if(only_one == 1)
//  {
//    sprintf(tm,"%s",toplot[stno]);
//    printf("tm: %s\n",tm);
//    sprintf(toplot[0],"%s",tm);
//    no_to_plot = 1;
//  }
  
  /* Parse the 'multiselect' string following '-S' */
//  if ( multiselect )
//    {
//      if ( sl_parse_streamlist (slconn, multiselect, selectors) == -1 )
//	return -1;
//    }
//  else if ( !streamfile )
//    {			 /* No 'streams' array, assuming uni-station mode */
//      sl_setuniparams (slconn, selectors, -1, 0);
//    }
  
  /* Attempt to recover sequence numbers from state file */
//  if (statefile)
//    {
//      if (sl_recoverstate (slconn, statefile) < 0)
//	{
//	  sl_log (2, 0, "state recovery failed\n");
//	}
//    }
  
  return 0;
}				/* End of parameter_proc() */

/***************************************************************************
 * getoptval:
 * Return the value to a command line option; checking that the value is 
 * itself not an option (starting with '-') and is not past the end of
 * the argument list.
 *
 * argcount: total arguments in argvec
 * argvec: argument list
 * argopt: index of option to process, value is expected to be at argopt+1
 *
 * Returns value on success and exits with error message on failure
 ***************************************************************************/
static char *
getoptval (int argcount, char **argvec, int argopt)
{
  if ( argvec == NULL || argvec[argopt] == NULL ) {
    fprintf (stderr, "getoptval(): NULL option requested\n");
    exit (1);
  }
  

  if ( (argopt+1) < argcount && strcmp (argvec[argopt], "-o") == 0 )
    if ( strcmp (argvec[argopt+1], "-") == 0 )
      return argvec[argopt+1];
  
  if ( (argopt+1) < argcount && *argvec[argopt+1] != '-' )
    return argvec[argopt+1];

  fprintf (stderr, "Option %s requires a value\n", argvec[argopt]);
  exit (1);
}  /* End of getoptval() */

/***************************************************************************
 * help:
 * help messages
 ***************************************************************************/
static void
help(void)
{

  fprintf (stderr,
	   " Valid program options:\n"
//	   " -V              report program version\n"
	   " -h              show this help message\n"
//           " -top text       top directory (default: /home/seimo)\n"
//	   " -c              print stations.conf file\n"
//	   " -p              print details of data packets\n"
           " -d              print full station name on each seismogram\n\n"
//           " -sc             auto-scaling each new data buffer\n\n"

//           "\n"
//           " ## Graphics options ##\n"
//           " -g location    location\n"
           " -x   pixels     width window in pixels (default: 1000)\n"
           " -y   pixels     height window in pixels (default: 600)\n"
           " -buf n          0-double 1-single buffering (default: 0)\n"
           " -xo  pixels     position of window x-direction (default: 0)\n"
           " -yo  pixels     position of window y-direction (default: 0)\n"
           " -m   minutes    minutes over screen: 1,2,3,4,5,10,15,30,60 (default: 15)\n"
	   " -col n          color option: 0 (default),1,2,3,4\n"
           "\n"
//           " ## Filter options ##\n"
           " -fl  lowpass    lowpass frequency\n"
           " -fh  highpass   highpass frequency\n"
	   "\n"
	   " -cfg parameter  Specify catalog under /par where parameterfile is stored\n"
           "\n");
//	   " ## Data saving options ##\n"
//	   " -o dumpfile    write all received records to this file\n"
//	   " ## Data stream  selection and station file##\n"
//	   " -l listfile     read a stream list from this file  (default: streams.conf)\n"
//	   " -f stationfile  read a station list from this file (default: stations.conf)\n"
//	   " -n no_to_plot   number of stations to plot\n");
//	   " -a station no   which station to plot (0,1,2,3.......)\n");

  
}				

//------------------------------------------------------------------------------------------
// Read configuration file into memory
//------------------------------------------------------------------------------------------
int Read_Config_to_MEM(char config[],char mempar[500][256])
{
  FILE *par;
  char  filepath[256];
  char  linjer[500];
  int   tel,i;
  
  sprintf(filepath,"%s/par/%s/rtsl_config",topdir_rt,config);
  par = fopen(filepath,"r");
  if(par == NULL)
  {
    printf("************RTDET-Read_Config_to_MEM**********************\n");
    printf("* %s does not exist.\n",filepath);
    printf("* Check your configuration file.                         *\n");
    printf("**********************************************************\n");
    exit(0);
  }
  tel=0;
  while ( fgets ( linjer, sizeof linjer, par ) != NULL ) /* read a line from file */
  {
    if(linjer[0] == ' ' || linjer[0] == 0xa )
      break;
    if(linjer[0] != '#')
    {
      sprintf(mempar[tel],"%s",linjer);
      tel++;
    }      
  }
  fclose(par);
  return(tel);
}
//-------------------------------------------------------------------------------------
// Find all seedlink servers to use specified under label SERVERS in configuration file
//-------------------------------------------------------------------------------------
int Find_SL_Servers(int no_of_lines_cfg,char mempar[500][256],char memsrv[100][100])
{
  char keyword[20];
  int k,l;
  int re;
  int found;
  int tel;
  found = -1;
  sprintf(keyword,"SERVERS");             // Search for label SERVERS
  for(k=0;k<no_of_lines_cfg;k++)
  {
    if(strstr(mempar[k],keyword))
    {
      found = k; 
    }
  }
  if(found == -1)
  {
    printf("**************************RTDET-Find_SL_Servers*************\n");
    printf("* Label SERVERS does not exist in configuration file.      *\n");
    printf("************************************************************\n");
    exit(0);
  }
  tel = 0;
  for(l=0;l<100;l++)
  {
    sprintf(keyword,"S%2d",l);
    if(keyword[1] == ' ') keyword[1] = '0';
    for(k=0;k<no_of_lines_cfg;k++)
    {
      re = strncmp(keyword,mempar[k],3);
      if(re == 0)
      {
	sprintf(memsrv[tel],"%s",mempar[k]);
	tel++;
      }
    }      
  }
  return(tel);
}
void Check_Config(char config[])
{
  FILE *par;
  char  filepath[256];
  char  linjer[500];
  char  du[10];
  char  ord[100];
  char  keyword[100];
  char  chkpar[500][256];
  int   tel,i,found;
  
  sprintf(filepath,"%s/par/%s/rtsl_config",topdir_rt,config);
  par = fopen(filepath,"r");
  if(par == NULL)
  {
    printf("************RTDET-Read_Config_to_MEM**********************\n");
    printf("* %s does not exist.\n",filepath);
    printf("* Check your configuration file.                         *\n");
    printf("**********************************************************\n");
    exit(0);
  }
  tel=0;
  while ( fgets ( linjer, sizeof linjer, par ) != NULL ) /* read a line from file */
  {
//    printf("%3d %s",tel,linjer);
    if(linjer[0] == ' ' || linjer[0] == 0xa)
    {
        printf("******************RTDET Check_Config*****************************\n");
        printf("* Blank line or line beginning with space in configuration file.*\n");
        printf("*****************************************************************\n");
        exit(0);
    }    
    tel++;      
  }
  rewind(par);
  tel=0;
  while ( fgets ( linjer, sizeof linjer, par ) != NULL ) /* read a line from file */
  {
    if(linjer[0] == ' ' || linjer[0] == 0xa)
      break;
    sprintf(chkpar[tel],"%s",linjer);
    tel++;      
  }
//  if(printarg > 0)  
    printf("\nRTDET: number of lines in rt_config: %d\n",tel);  
  fclose(par);
  
  sprintf(keyword,"SERVERS");
  found=0;
  for(i=0;i<tel;i++)
  {
    sscanf(chkpar[i],"%s",ord);
    if(strstr(keyword,ord))
    {
      found=1; 
    }
  }
  if(found == 0)
  {
    printf("******************RTDET Check_Config*****************************\n");
    printf("* Keyword SERVERS missing in configuration file.                *\n");
    printf("*****************************************************************\n");
    exit(0);    
  }

  found=0;
  for(i=0;i<tel;i++)
  {
    sprintf(keyword,"NW");    
    sscanf(chkpar[i],"%s",ord);
    if(strstr(keyword,ord))
    {
      found=1;
    }
  }
  if(found == 0)
  {
        printf("******************RTDET Check_Config******************************\n");
        printf("* Header line after keyword NW missing in configuration file.    *\n");
        printf("******************************************************************\n");
        exit(0); 
      }  


  
  fclose(par);
  
}
/*----------------------------------------------------------------*/
/* Read memsrv                                                    */
/*----------------------------------------------------------------*/
void read_servers(int no_of_servers, char memsrv[100][100])
{
  int i;
  
  for(i=0;i<no_of_servers;i++)
    sscanf(memsrv[i],"%s %s",streams[i],slserv[i]);       
}
/*----------------------------------------------------------------*/
/* Read streams file                                              */
/*----------------------------------------------------------------*/
int read_inputstreams( const char * streamfile,int p)
{
  FILE *streamfp;
  char linje[100];
  int count = 0;
  int s;

/* Open the streams file */
  if ((streamfp = fopen (streamfile, "rb")) == NULL)
  {
    printf("RTDET: read_inputstreams Can't open input stream file: %s\n",streamfile);
    printf("RTDET: read_inputstreams Check if file exists, or is wrong.\n");
    exit(0);
  }
  while ( (fgets (linje, sizeof(linje), streamfp)) !=  NULL)
  {
    for(s=0;s<20;s++)
    {
      if(linje[s] == 0xa)
        linje[s] = '\0';
    }
    sprintf(allstreams[stream_count],"%s %s",linje,slserv[p]);

    

//    printf("allstreams: %3d %s\n",stream_count,allstreams[stream_count]);
    stream_count++;
    count++;
  }
  kanaler_hver_stream[p]=count;
  if ( fclose (streamfp) )
  {
    return -1;
  }
}  

/**************************************************************************/
/*         Read MINISEED packets from SEEDLINK server Thread              */
/**************************************************************************/
void READ_PACKETS(void *ptr)
{
  float   ftime[nch];

//  float   scale_factor[nch];
//  int     sseismo[MAXCHA][3000];
  int     ns[MAXCHA];
  
  int     ch;
  int     seqnum;
  int     ptype;
  int     fnd=0;
  int     tr;
  int     i,j,k,m;
  int     ret1;
  int     now;
  int     antsmp;
  int     forskjell;
  int     xmax=0;
  int     marker1=0;
  int     marker2=0;
  
  
  int     lthread_no;
  char    lipaddr[100];
  char    lstreams[100];
  char    lstations[100];
  int     lno_comp;
  int     lno_str;

  float   fseismo[1000];
  
  char totalstreams[255];
  char *streamfile   = 0;	    /* stream list file for configuring streams */  
  char addr[256];
  char *selectors   = 0;  
  
  thdata *data;            
  data = (thdata *) ptr;                         // type cast to a pointer to thdata
  
  SLCD * slconn;	                         // connection parameters each SL server 

  SLpacket * slpack;

  lthread_no = data->thread_no;
  sprintf(lipaddr,"%s",data->ipaddr);
  sprintf(lstreams,"%s",data->streams);
  sprintf(lstations,"%s",data->stations);
  lno_comp = data->no_comp;
  lno_str = data->no_str;

// Allocate and initialize a new connection description SEEDLINK
  
  slconn = sl_newslcd();
   
// connect to seedlink server this address
   
  sprintf(addr,"%s",lipaddr);

  slconn->sladdr = addr;
   
// full path to stream file   
    
  sprintf(totalstreams,"%s/par/%s/SLPL_%s",topdir_rt,cfgfile,lstreams);
  
  streamfile = totalstreams;
  
//  for(i=0;i<MAXCHA;i++)
//    new[i]=(int)time(NULL);

  printf("LNO_STR: %d\n",lno_str);
  printf("****************************************************************************\n");  
  printf("Thread: %2d seedlink server: %s streamfile: %s\n",lthread_no,lipaddr,streamfile);
// connect input streams to specified seedlink server 
  sl_read_streamlist (slconn, streamfile, selectors); 
  printf("****************************************************************************\n");
// Never-ending loop reading defined inputstreams for detection 
  for(;;)
  {
    tr=lthread_no;
    if( sl_collect (slconn, &slpack))              // Connect to seedlink server
    {
      pthread_mutex_lock(&shufle_mutex);           // ******LOCK******
      ptype  = sl_packettype (slpack);             // get packet type
      seqnum = sl_sequence (slpack);               // get sequence number

      fnd=packet_handler ((char *) &slpack->msrecord, ptype, seqnum, SLRECSIZE,slconn,stream_count,ns,sr);      
      if(fnd != -1)                                // PACKET FOUND ?
      {
//        printf("  thread: %2d stream_count: %d chan:  %2d ns: %d  %s fl: %3.1f fh: %3.1f \n",tr,stream_count,fnd,ns[fnd],toplot[fnd],fl,fh);
        ch=fnd;                                    // YES, SAVE STATION NUMBER
        KAN=ch; 
        fnd=-1;                                    // RESET 'fnd'
        firstbuf[ch]++;
  C_TIME();
  TNOW = CCC_TIME;
  TIMESTOPP[ch] = TNOW;
/*        
        for(;;)
	{
	  if(strip_flag[ch] == 0)    // strip busy ?
	  {                          // no
	    packs_flag[ch] = 1;      // raise packet flag
	    break;
	  }else{
	    sleep(1);
	  }
	}
*/
        for(k=0;k<ns[ch];k++)
	  fseismo[k] = sseismo[ch][k]-avg[ch];
	

	if(fl > 0.0 && fh > 0.0)
	{
          for(k=0;k<ns[ch];k++)                  // ADD AMPLITUDE TO CONSERVE ENERGI
            fseismo[k] = fseismo[k] * 1.0;
	  antsmp=ns[ch];
          appl(ch,fseismo,antsmp);                              // FILTER ONE BUFFER 
	  if(firstbuf[ch] == 1)
	  {
	    for(k=0;k<50;k++)
	      fseismo[k]=0;
	  }
	}                                         // end of if filter
	
        xmax=(int)((float)WINL / incr[ch]);      // MAX X-VALUE      
        for(k=0;k<ns[ch];k++)
        {
//         if(auto_scaling == 0)
//          {
//           values[ch][ix[ch]]=fseismo[k] * scale_factor[ch] * amp * amp_single[ch];
//          }else{
            values[ch][ix[ch]]=fseismo[k];
//          }
                         
          ix[ch]++;
          if(ix[ch] >= xmax)
          {
            for(m=0;m<(TOTSMP);m++)              // SHIFT ALL SAMPLES 'NS' LEFT
            {
              values[ch][m]=values[ch][m+ns[ch]];      
              trgflg[ch][m]=trgflg[ch][m+ns[ch]];
              trgmrk[ch][m]=trgmrk[ch][m+ns[ch]];
            }
            if(marker1 != 0 && marker2 != 0)     // IF MARKERS ON, PLOT THEM
            { 
              trgflg[ch][marker1-ns[ch]]=1;
              trgmrk[ch][marker2-ns[ch]]=1;
            }
            ix[ch] = ix[ch] - ns[ch];
            stpix[ch] = (60.0 - ftime[ch]) * incr[ch] * sr[ch];            
          }
        }     // k->ns
         packs_flag[ch] = 0;   // lower packs flag              
      }       // fnd
      pthread_mutex_unlock(&shufle_mutex);         // *****UNLOCK******          
    }
  }
}
/***************************************************************************
 * packet_handler():
 * Process a received packet based on packet type.
 ***************************************************************************/
static int
packet_handler (char *msrecord, int packet_type, int seqnum, int packet_size,SLCD * slconn,int stream_count,int ns[],int sr[])
{
  static SLMSrecord * msr = NULL;
  int trace;
  int i;
  double dtime;			/* Epoch time */
  double secfrac;		/* Fractional part of epoch time */
  time_t itime;			/* Integer part of epoch time */
  char timestamp[20];
  int nsects;
  struct tm *timep;

  /* The following is dependent on the packet type values in libslink.h */
  char *type[]  = { "Data", "Detection", "Calibration", "Timing",
		    "Message", "General", "Request", "Info",
                    "Info (terminated)", "KeepAlive" };

  /* Build a current local time string */

  dtime   = sl_dtime ();
  secfrac = (double) ((double)dtime - (int)dtime);
  itime   = (time_t) dtime;
  timep   = localtime (&itime);
  sprintf (timestamp,  "%04d.%03d.%02d:%02d:%02d.%01.0f",
	    timep->tm_year + 1900, timep->tm_yday + 1, timep->tm_hour,
	    timep->tm_min, timep->tm_sec, secfrac);

  /* Process waveform data */
  if ( packet_type == SLDATA )
    {
      sl_log (0, 1, "%s, seq %d, Received %s blockette:\n",
	      timestamp, seqnum, type[packet_type]);

      sl_msr_parse (slconn->log, msrecord, &msr, 1, 0);

      if ( verbose || ppackets )
	sl_msr_print (slconn->log, msr, ppackets);
    }
  else if ( packet_type == SLKEEP )
    {
      sl_log (0, 2, "Keep alive packet received\n");
    }
  else
    {
      sl_log (0, 1, "%s, seq %d, Received %s blockette\n",
	      timestamp, seqnum, type[packet_type]);
    }

  /* Write packet to dumpfile if defined */
  if ( dumpfile )
    {
      if (fwrite (msrecord, packet_size, 1, outfile) <= 0)
	sl_log (2, 0, "fwrite(): error writing data to %s\n", dumpfile);
//      memcpy(buf,msrecord,seed_size);
	sl_msr_parse (slconn->log, msrecord, &msr, 1, 1);
//        trace=unpack_samples (msr);
        return(1);
    }
/* Plot selected data */
if( location )
{
//  printf("%s, seq %d, Received %s blockette:\n",timestamp, seqnum, type[packet_type]);
//  printf("smp:%s\n",timestamp);

  sl_msr_parse (slconn->log, msrecord, &msr, 1, 1);
  if(msr->unpackerr != MSD_UNKNOWNFORMAT)
  {
    trace=unpack_samples (msr,seqnum,stream_count,ns,sr);
    
    for(i=0;i<MAXCHA;i++)
    {
      if(tabell[trace][i] == 'X')
        sprintf(tid[i],"%s",timestamp);
    }    
    

    return(trace);
  }else{
	printf("Trouble unpacking buffer\n");
	return(0);
  }
}
return(0);

}				/* End of packet_handler() */

/***************************************************************************
 * print_samples:
 * Print samples in the supplied MSrecord with a simple format.
 ***************************************************************************/
int
unpack_samples (SLMSrecord *msr, int seqnum,int lno_str,int ns[],int sr[])
{
  char tempo[20];
  char search[20];
  char tmp[80];
  char dd[80];

  int iryrn;
  int irday;
  int irhrn;
  int irmin;

  int j,pp,kan;
  int retur=-1;
  int cnt,p,l,ret;
  float   eqavst;  
  
float sn1[5*3+1],sd1[5*3+1];
int nsects;  
int orden;  
  
  
  for(j=0;j<20;j++)
  {
    search[j]='\0';
    current_station[j]='\0';
  }
  sprintf(tempo,"%s",msr->fsdh.station);
  strncpy(search,tempo,10);
  for(j=0;j<5;j++)
    current_station[j]=search[j];

  for(l=0;l<stream_count;l++)
  {
//    printf("%s  %s\n",search,allstreams[l]);
    for(pp=0;pp<10;pp++)
      dd[pp]=allstreams[l][pp+3];
    dd[pp]='\0';
    ret=strcmp(search,dd);
    if(ret == 0)                                 // component found
    {
      retur=l;
      if ( msr->datasamples != NULL )            //EXTRACT DATA FROM MINISEED BUFFER
      {
        for(kan=0;kan<MAXCHA;kan++)
        {  
          if(tabell[retur][kan] == 'X')
	  {
            if(msr->fsdh.samprate_fact > 0 && msr->fsdh.samprate_mult < 0)
              msr->fsdh.samprate_fact = (-1 * msr->fsdh.samprate_fact)/msr->fsdh.samprate_mult;	    
            ns[kan]   = msr->numsamples;
            ryrn[kan] = msr->fsdh.start_time.year;
            rday[kan] = msr->fsdh.start_time.day;
            rhrn[kan] = msr->fsdh.start_time.hour;
            rmin[kan] = msr->fsdh.start_time.min;
            risec[kan]= msr->fsdh.start_time.sec;
            rsecs[kan]= msr->fsdh.start_time.fract; 
            sr[kan]   = msr->fsdh.samprate_fact;
	    
//            if(incr[kan] < 0.0)                   // increment this channel not computed ?
              incr[kan]=(float)WINL/(60.0 * MINUTES * (float)msr->fsdh.samprate_fact); 
	    
            iryrn=ryrn[kan];
            irday=rday[kan];
            irhrn=rhrn[kan];
            irmin=rmin[kan];

            sprintf(tmp,"%4d %3d %2d:%2d:%2d.%4d",iryrn,irday,irhrn,irmin,risec[kan],rsecs[kan]);
            if(tmp[21]==' ')tmp[21]='0';
            if(tmp[20]==' ')tmp[20]='0';
            if(tmp[19]==' ')tmp[19]='0';
            if(tmp[18]==' ')tmp[18]='0';
            if(tmp[15]==' ')tmp[15]='0';

            sprintf(rtid[kan],"%s",tmp);

	    if(msr->fsdh.dq_flags == 0)
	    {
	      time_quality[kan]=0;
	    }else{
	      time_quality[kan]=1;
	    }
   
            for(pp=0;pp<22;pp++)
              if(tmp[pp]==' ')tmp[pp]='0';   

/* COMPUTE NEW FILTER COEF. EACH BUFFER. THEY MAY HAVE DIFFERENT SAMPLERATE */
            eqavst=1.0/(float)msr->fsdh.samprate_fact;
            orden=4;
            if(fl > 0.0 && fh > 0.0)
            {
//	      printf("design: fl: %3.1f fh: %3.1f eqavst: %8.3f\n",fl,fh,eqavst);
              nsects=design(orden,"BP","BU",30.0,0.3,fl,fh,eqavst, sn1, sd1);
              for(j=0;j<(nsects*3+1);j++)
              {
                snc[kan][j]=sn1[j];
                sdc[kan][j]=sd1[j];
//      printf("%d %f %f\n",j,snc[kan][j],sdc[kan][j]);
              }
              cset[kan]=nsects;
            }
            
            for ( cnt = 0; cnt < ns[kan]; cnt++ )      // EXTRACT DATA SAMPLES
              sseismo[kan][cnt]=*(msr->datasamples + cnt);
            if(sw2[l] < NBSCALE)                     // RE-SCALE ?
            {
              for(p=0;p<ns[l];p++)
              {
                sum[l]=sum[l]+sseismo[l][p];
                teller[l]++;
              }
              avg[l]=sum[l]/teller[l];               // DC

              for(p=0;p<ns[l];p++)                   // AVERAGE OF SIGNAL-DC
                v[l]=v[l]+(abs)(sseismo[l][p]-avg[l]);
              promedio[l]=(float)v[l]/(float)teller[l];

              factor[l] = YSCALE / (100.0 * promedio[l]);
	      if(sw2[l]<(NBSCALE-3))
	        scale_factor[l]=factor[l];

              sw2[l]++;
            }  // sw2.........    
	    
	    
	    
//          for(p=0;p<ns[l];p++)
//          {
//            sum[l]=sum[l]+(int)sseismo[p];
//            teller[kan]++;
//          }
//          avg[kan]=sum[kan]/teller[kan];               // DC    
	    
	    
	  }
	}
        return(retur);
      }    // if(msr->data.........
    }      // if(ret......
  }        // for(no_to_plot........ 
//  		if(l==14)
//			printf("unpack2 FAC:\n");
  return(retur);
}  /* End of print_samples() */
/*  Subroutine to apply an iir filter to a data sequence.                   */
/*    The filter is assumed to be stored as second order sections.          */
/*    Filtering is in-place.                                                */
/*    Zero-phase (forward and reverse) is an option.                        */

void appl(int fnd,float fseismo[],int ne)
{
    /* System generated locals */
int      i1;
int      i2;

    /* Local variables */
int      jptr;
int      i;
int      j;
float    b0;
float    b1;
float    b2;
float    a1;
float    a2;
float    x1;
float    x2;
float    y1;
float    y2;
float    output;
//tpek=peker;


jptr = 1;
i1 = cset[fnd];

  for (j = 1; j <= i1; ++j)
  {
    x1 = save_x1[fnd][j];
    x2 = save_x2[fnd][j];
    y1 = save_y1[fnd][j];
    y2 = save_y2[fnd][j];
    b0 = snc[fnd][jptr];
    b1 = snc[fnd][jptr + 1];
    b2 = snc[fnd][jptr + 2];
    a1 = sdc[fnd][jptr + 1];
    a2 = sdc[fnd][jptr + 2];
    i2 = ns[fnd];
    i2 = ne;

    for (i = 0; i < i2; ++i)
    {
      output = b0 * fseismo[i] + b1 * x1 + b2 * x2;
      output -= a1 * y1 + a2 * y2;
      y2 = y1;
      y1 = output;
      x2 = x1;
      x1 = fseismo[i];
      fseismo[i] = output;
    }

    jptr += 3;

    save_y2[fnd][j]=y2;
    save_y1[fnd][j]=y1;
    save_x2[fnd][j]=x2;
    save_x1[fnd][j]=x1;

  }

}

/*  Subroutine to design IIR digital filters from analog prototypes. */
/*  Input Arguments: */
/*  ---------------- */
/*    IORD                Filter order (10 MAXIMUM) */
/*    TYPE                Character*2 variable containing filter type */
/*                          LOWPASS (LP) */
/*                          HIGHPASS (HP) */
/*                          BANDPASS (BP) */
/*                          BANDREJECT (BR) */
/*   APROTO              Character*2 variable designating analog prototype*/
/*                          Butterworth (BU) */
/*                          Bessel (BE) */
/*                          Chebyshev Type I (C1) */
/*                          Chebyshev Type II (C2) */
/*    A                   Chebyshev stopband attenuation factor */
/*    TRBNDW              Chebyshev transition bandwidth (fraction of */
/*                          lowpass prototype passband width) */
/*    FL                  Low-frequency cutoff */
/*    FH                  High-frequency cutoff */
/*    TS                  Sampling interval (in seconds) */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                  Array containing numerator coefficients of */
/*                        second-order sections packed head-to-tail. */
/*    SD                  Array containing denominator coefficients */
/*                        of second-order sections packed head-to-tail. */

int design( iord, type,aproto,  a,trbndw,  fl,  fh,  ts,sn, sd)
int iord;
char *type;
char *aproto;
float a;
float trbndw;
float fl;
float fh;
float ts;
float sn[];
float sd[];
{
    /* System generated locals */
    float r__1;
    int nsects;
    /* Local variables */
    complex p[10], z[10];
    char stype[3*10];
    float omegar, ripple;
    float fhw, eps, flw, dcvalue;
    int nse;
    /*  Analog prototype selection */

    if (strncmp(aproto, "BU", 2) == 0)
      nse=buroots(p, stype, &dcvalue, iord);
    

    /*  Analog mapping selection */

    if (strncmp(type, "BP", 2) == 0) 
    {
//      printf("BP\n");
      r__1 = fl * ts / (float)2.;
      flw = warp(&r__1, &c_b12);
      r__1 = fh * ts / (float)2.;
      fhw = warp(&r__1, &c_b12);
      nsects=lptbp(p, z, stype, &dcvalue, &flw, &fhw,nse,sn,sd);
    }
    /*  Bilinear analog to digital transformation */
    bilin2(&sn[1], &sd[1],nsects);

    return(nsects);
}

/* BUROOTS -- SUBROUTINE TO COMPUTE BUTTERWORTH POLES FOR */
/*   NORMALIZED LOWPASS FILTER */
/* LAST MODIFIED:  SEPTEMBER 7, 1990 */
/*  OUTPUT ARGUMENTS: */
/*  ----------------- */
/*      P              COMPLEX ARRAY CONTAINING POLES */
/*                       CONTAINS ONLY ONE FROM EACH */
/*                       COMPLEX CONJUGATE PAIR, AND */
/*                       ALL REAL POLES */
/*      RTYPE          CHARACTER ARRAY INDICATING 2ND ORDER SECTION */
/*                       TYPE: */
/*                         (SP)  SINGLE REAL POLE */
/*                         (CP)  COMPLEX CONJUGATE POLE PAIR */
/*                         (CPZ) COMPLEX CONJUGATE POLE-ZERO PAIRS */
/*      DCVALUE        MAGNITUDE OF FILTER AT ZERO FREQUENCY */
/*  INPUT ARGUMENTS: */
/*  ---------------- */
/*      IORD           DESIRED FILTER ORDER */
int buroots(p,rtype, dcvalue, iord)
complex *p;
char *rtype;
float *dcvalue;
int iord;

{
  int nsects;
//  printf("using BUROOTS\n");
    /* System generated locals */
    int i__1, i__2;
    double d__1, d__2;
    complex q__1;

    /* Local variables */
    int half, k;
    float angle, pi;

    /* Parameter adjustments */
    rtype -= 3;
    --p;

    /* Function Body */
    pi = (float)3.14159265;

    half = iord / 2;

    /* TEST FOR ODD ORDER, AND ADD POLE AT -1 */

    nsects = 0;
    if (half << 1 < iord) {
    p[1].r = (float)-1., p[1].i = (float)0.;
    strncpy(rtype + 3, "SP", 2);
    nsects = 1;
    }
    i__1 = half;
    for (k = 1; k <= i__1; ++k) {
    angle = pi * ((float) ((k << 1) - 1)/(float) (iord << 1)+(float).5);
    ++(nsects);
    i__2 = nsects;
    d__1 = cos(angle);
    d__2 = sin(angle);
    q__1.r = d__1, q__1.i = d__2;
    p[i__2].r = q__1.r, p[i__2].i = q__1.i;
        strncpy(rtype + nsects * 3, "CP", 2);
    }
    *dcvalue = (float)1.;
//    printf("buroot nsects: %2d\n",nsects);
    return(nsects);
}



/* Subroutine to convert an prototype lowpass filter to a bandpass filter via
*/
/*    the analog polynomial transformation.  The lowpass filter is */
/*   described in terms of its poles and zeros (as input to this routine).*/
/*    The output consists of the parameters for second order sections. */
/*  Input Arguments: */
/*  ---------------- */
/*    P                       Array containing poles */
/*    Z                       Array containing zeros */
/*    RTYPE                   Character array containing type information */
/*                              (SP) single real pole  or */
/*                              (CP) complex conjugate pole pair  or */
/*                              (CPZ) complex conjugate pole/zero pairs */
/*    DCVALUE                 Zero frequency value of filter */
/*    FL                      Low-frequency cutoff */
/*    FH                      High-frequency cutoff */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                      Numerator polynomials for second order */
/*                              sections. */
/*    SD                      Denominator polynomials for second order */
/*                              sections. */
/*                              This subroutine doubles the number of */
/*                              sections. */

static int lptbp(p, z, rtype, dcvalue, fl, fh,nsects,sn,sd)
complex *p, *z;
char *rtype;
float *dcvalue;
float *fl, *fh;
int nsects;
float sn[];
float sd[];
{
//  printf("using LPTBP nsects: %d\n",nsects);  
    /* System generated locals */
    int i__1, i__2, i__3, i__4, i__5, i__6, i__7;
    double d__1;
    complex q__1, q__2, q__3, q__4, q__5, q__6, q__7, q__8, q__9, q__10;

    /* Local variables */
    int iptr;
    float a, b;
    complex h;
    int i, n;
    complex s;
    float scale;
    complex ctemp, p1, p2;
    float twopi;
    complex z1, z2;
    float pi;

    /* Parameter adjustments */
    rtype -= 3;
    --z;
    --p;

    /* Function Body */
    pi = (float)3.14159265;
    twopi = pi * (float)2.;
    a = twopi * twopi * *fl * *fh;
    b = twopi * (*fh - *fl);

    n = nsects;
    nsects = 0;
    iptr = 1;
    i__1 = n;
    for (i = 1; i <= i__1; ++i) {
if (strncmp(rtype + i * 3, "CP", 2) == 0) {
//      printf("CP\n");
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
            q__1 = csqrt1(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p1.r = q__1.r, p1.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p2.r = q__1.r, p2.i = q__1.i;
        sn[iptr] = (float)0.;
        sn[iptr + 1] = b;
        sn[iptr + 2] = (float)0.;
            q__2 = conjg(p1);
        q__1.r = p1.r * q__2.r - p1.i * q__2.i, q__1.i = p1.r * q__2.i +
            p1.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p1.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        sn[iptr] = (float)0.;
        sn[iptr + 1] = b;
        sn[iptr + 2] = (float)0.;
            q__2 = conjg(p2);
        q__1.r = p2.r * q__2.r - p2.i * q__2.i, q__1.i = p2.r * q__2.i +
            p2.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p2.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        nsects += 2;
    }
    }
//    printf("nsects: %d\n",nsects);
/* Scaling - use fact that the bandpass filter amplitude at sqrt( omega_l **/
/*            equals the amplitude of the lowpass prototype at d.c. */
    d__1 = sqrt(a);
    q__1.r = (float)0., q__1.i = d__1;
    s.r = q__1.r, s.i = q__1.i;
    h.r = (float)1., h.i = (float)0.;

    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    i__2 = iptr + 2;
    q__6.r = sn[i__2] * s.r, q__6.i = sn[i__2] * s.i;
    i__3 = iptr + 1;
    q__5.r = q__6.r + sn[i__3], q__5.i = q__6.i;
    q__4.r = q__5.r * s.r - q__5.i * s.i, q__4.i = q__5.r * s.i + q__5.i *
         s.r;
    i__4 = iptr;
    q__3.r = q__4.r + sn[i__4], q__3.i = q__4.i;
    q__2.r = h.r * q__3.r - h.i * q__3.i, q__2.i = h.r * q__3.i + h.i *
        q__3.r;
    i__5 = iptr + 2;
    q__10.r = sd[i__5] * s.r, q__10.i = sd[i__5] * s.i;
    i__6 = iptr + 1;
    q__9.r = q__10.r + sd[i__6], q__9.i = q__10.i;
    q__8.r = q__9.r * s.r - q__9.i * s.i, q__8.i = q__9.r * s.i + q__9.i *
         s.r;
    i__7 = iptr;
    q__7.r = q__8.r + sd[i__7], q__7.i = q__8.i;
        q__1 = cdiv(q__2, q__7);
    h.r = q__1.r, h.i = q__1.i;
    iptr += 3;
    }
    q__2.r = *dcvalue, q__2.i = (float)0.;
    d__1 = h.r;
    q__5 = conjg(h);
    q__4.r = d__1 * q__5.r, q__4.i = d__1 * q__5.i;
    q__3 = csqrt1(q__4);
    q__1 = cdiv(q__2, q__3);
    scale = q__1.r;
    sn[1] *= scale;
    sn[2] *= scale;
    sn[3] *= scale;
    
//    printf("lptbp nsects: %2d\n",nsects);
    
    return(nsects);
}



/* Transforms an analog filter to a digital filter via the bilinear transforma
ti*/
/*   Assumes both are stored as second order sections.  The transformation is
*/
/*    done in-place. */
/*  Input Arguments: */
/*  ---------------- */
/*   SN                   Array containing numerator polynomial coefficients f
or*/
/*                           second order sections.  Packed head-to-tail. */
/*   SD                   Array containing denominator polynomial coefficients
 f*/
/*                           second order sections.  Packed head-to-tail. */

static int bilin2(sn, sd,nsects)
float *sn, *sd;
int nsects;
{
//   printf("using BILIN2 nsects %d\n",nsects); 
    /* System generated locals */
    int i__1;

    /* Local variables */
    int iptr, i;
    float scale, a0, a1, a2;

    /* Parameter adjustments */
    --sd;
    --sn;

    /* Function Body */
    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    a0 = sd[iptr];
    a1 = sd[iptr + 1];
    a2 = sd[iptr + 2];
    scale = a2 + a1 + a0;
    sd[iptr] = (float)1.;
    sd[iptr + 1] = (a0 - a2) * (float)2. / scale;
    sd[iptr + 2] = (a2 - a1 + a0) / scale;
    a0 = sn[iptr];
    a1 = sn[iptr + 1];
    a2 = sn[iptr + 2];
    sn[iptr] = (a2 + a1 + a0) / scale;
    sn[iptr + 1] = (a0 - a2) * (float)2. / scale;
    sn[iptr + 2] = (a2 - a1 + a0) / scale;
    iptr += 3;
    }
    return TRUE;
}

/* WARP -- FUNCTION, APPLIES TANGENT FREQUENCY WARPING TO COMPENSATE */
/*         FOR BILINEAR ANALOG -> DIGITAL TRANSFORMATION */
/* ARGUMENTS: */
/* ---------- */
/*      F       ORIGINAL DESIGN FREQUENCY SPECIFICATION (HERTZ) */
/*      TS      SAMPLING INTERVAL (SECONDS) */
/*  LAST MODIFIED:  SEPTEMBER 20, 1990 */

static double warp(f, ts)
float *f, *ts;
{
//   printf("using WARP\n"); 
    /* System generated locals */
    float ret_val;

    /* Local variables */
    float angle, twopi;

    twopi = (float)6.2831853;
    angle = twopi * *f * *ts / (float)2.;
    ret_val = tan(angle) * (float)2. / *ts;
    ret_val /= twopi;
    return ret_val;
}



static complex cmul(a,b)
complex a,b;
{
    complex c;
    c.r = a.r * b.r - a.i * b.i;
    c.i = a.i * b.r + a.r * b.i;
    return c;
}

static complex cpowi(a,n)
complex a;
int n;
{
    int i;
    complex c;
    c.i = 0.;
    c.r = 1.;
    for (i = 1; i <= n; ++i) {
    c = cmul(c, a);
    }
    return c;

}
static complex csqrt1(z)
complex z;
{   complex c;
    float x,y,w,r;
    if ((z.r == 0.0) && (z.i == 0.0)) {
        c.r=0.0;
        c.i=0.0;
        return c;
    } else {
        x=fabs(z.r);
        y=fabs(z.i);
        if (x >= y) {
            r=y/x;
            w=sqrt(x)*sqrt(0.5*(1.0+sqrt(1.0+r*r)));
        } else {
            r=x/y;
            w=sqrt(y)*sqrt(0.5*(r+sqrt(1.0+r*r)));
        }
        if (z.r >= 0.0) {
            c.r=w;
            c.i=z.i/(2.0*w);
        } else {
            c.i=(z.i >= 0) ? w : -w;
            c.r=z.i/(2.0*c.i);
        }
        return c;
    }
}

static complex conjg(z)
complex z;
{   complex c;
    c.r=z.r;
    c.i = -z.i;
    return c;
}

static complex cdiv(a,b)
complex a,b;
{   complex c;
    float r,den;
    if (fabs(b.r) >= fabs(b.i)) {
        r=b.i/b.r;
        den=b.r+r*b.i;
        c.r=(a.r+r*a.i)/den;
        c.i=(a.i-r*a.r)/den;
    } else {
        r=b.r/b.i;
        den=b.i+r*b.r;
        c.r=(a.r*r+a.i)/den;
        c.i=(a.i*r-a.r)/den;
    }
    return c;
}


void TIMSEC (YR,MTH,DAY,HR,MIN,SECS,MSECS)                         
int YR;
int MTH;
int DAY;
int HR;
int MIN;
float SECS;
double *MSECS;                         /* total seconds to be returned      */
{
int DYR;                               /* flag for leap year                */
int IYR;                               /* number of leap-years since 1900   */
int YDY;                               /* number of days in current year    */

if(YR <= 50) YR=YR+100;                /* check for 2000 or more in 2 digits*/

if(YR >= 1900) YR=YR - 1900;
DYR = 0;
if((YR % 4) == 0) DYR = 1;
IYR = YR/4 - DYR;
//                -- Seconds to beginning of     
*MSECS = (float)(IYR*366) + (float)((YR-IYR)*365);
//                -- current year                
*MSECS = *MSECS*86400.0;
//                -- January                     
if (MTH == 1) YDY = DAY;
//                -- February                    
if (MTH == 2) YDY = DAY + 31;
//                -- ....                        
if (MTH == 3) YDY = DAY + DYR + 59;       
if (MTH == 4) YDY = DAY + DYR + 90;                                     
if (MTH == 5) YDY = DAY + DYR + 120;                                    
if (MTH == 6) YDY = DAY + DYR + 151;                                    
if (MTH == 7) YDY = DAY + DYR + 181;                                    
if (MTH == 8) YDY = DAY + DYR + 212;                                    
if (MTH == 9) YDY = DAY + DYR + 243;                                    
if (MTH ==10) YDY = DAY + DYR + 273;                                    
if (MTH ==11) YDY = DAY + DYR + 304;                                    
if (MTH ==12) YDY = DAY + DYR + 334;                                    
*MSECS = *MSECS + (float)(YDY*86400 + HR*3600 + MIN*60) + SECS;
}
void C_TIME()
{
  char dummy[256];
  long   yrn;
  long   mon;
  long   day;
  long   hrn;
  long   min;
  long   doy;
  int   iyrn;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;
  int   isec;
  int   i,j;
  int   BUFSECS;
  float  sek;
  char dum[50];

  time_t now = time(NULL);
  struct tm *now_s = localtime(&now);
  sprintf(dummy,"%d-%02d-%02d_%02d:%02d:%02d", 1900+now_s->tm_year, ++now_s ->tm_mon,now_s->tm_mday, now_s->tm_hour, now_s->tm_min,now_s->tm_sec);
//printf("dummy: %s\n",dummy);
  sscanf(dummy,"%4d%1c%2d%1c%2d%1c%2d%1c%2d%1c%2d",&iyrn,dum,&imon,dum,&iday,dum,&ihrn,dum,&imin,dum,&isec);
//  printf("iyrn: %d imon: %d iday: %d ihrn: %d imin: %d isec: %d\n",iyrn,imon,iday,ihrn,imin,isec);
  yrn=iyrn;
  mon=imon;
  day=iday;
  hrn=ihrn;
  min=imin;
  mon=imon;
  sek=isec;
//  printf("yrn: %d\n",yrn);
//  printf("mon: %d\n",mon);
//  printf("day: %d\n",day);
//  printf("hrn: %d\n",hrn);
//  printf("min: %d\n",min);
//  printf("sek: %f\n",sek);
  TIMSEC(iyrn,imon,iday,ihrn,imin,sek,&CCC_TIME);
//  printf("CCC_TIME: %12.1f\n",CCC_TIME);
}
