/***************************************************************************
 *   Copyright (C) 2008 by seismo   *
 *   seismo@localhost   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/shm.h>
#include <sh_mem_rt.h>
#include <GL/glut.h>                   // LINUX
#define PACKAGE "rtsnr"
#define nch 600

int     WINH      = 300;               // DEFAULT WINDOW HEIGHT IN PIXELS
int     WINL      = 1000;              // DEFAULT WINDOW LENGTH IN PIXELS
int     xo        = 0;                 // coordinates for position on screen
int     yo        = 0;                 // coordinates for position on screen
int     delay     = 4;                 // seconds between update of screen
int     factor    = 10;                // factor to scale plot
int     klon      = 0;                 // instance of program

int     no_to_plot;
int     ystart;
int     xstart;
int     yst;
int     xst;
int     ixx;
int     xtime_old;
char    box1[50];
int     start_stop = 0;
int     no_stations = 0;
char    toplot[nch][80];

char    station_name[nch][80];
char    time_string[nch][80];





int     teller;
int     xold;
int     xnew;
int     yold;
int     ynew;
int     step;
int     yyy[200][2000];
float   R=0.0;
float   G=0.0;
float   B=0.0;
int     RunMode = 1;		// Used as a boolean (1 or 0) for "on" and "off"
rtmod *spt;                        // pointer shared memory 


static int parameter_proc (int argcount, char **argvec);
static char *getoptval (int argcount, char **argvec, int argopt);
static void usage (void);
static void DTE();
static void SECTIM();
static void TIMSEC();
static void draw_square();
static void strip();


void 
my_reshape(int w, int h)
{
   GLdouble size;
   GLdouble aspect;

   /* Use the whole window. */
   glViewport(0, 0, w, h);

   /* We are going to do some 2-D orthographic drawing. */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   size = (GLdouble)((w >= h) ? w : h) / 2.0;
   if (w <= h) {
      aspect = (GLdouble)h/(GLdouble)w;
      glOrtho(-size, size, -size*aspect, size*aspect, -100000.0, 100000.0);
   }
   else {
      aspect = (GLdouble)w/(GLdouble)h;
      glOrtho(-size*aspect, size*aspect, -size, size, -100000.0, 100000.0);
   }

   /* Make the world and window coordinates coincide so that 1.0 in */
   /* model space equals one pixel in window space.                 */
   glScaled(aspect, aspect, 1.0);

   /* Now determine where to draw things. */
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

}
void bitmap_output(int x, int y, char *string, void *font)
{
  int len, i;

  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) {
    glutBitmapCharacter(font, string[i]);
  }
}
void drawScene(void)
{
// Flush the pipeline, swap the buffers
  glFlush();
  glutSwapBuffers();
  if ( RunMode==1 ) 
  {
    glutPostRedisplay();	// Trigger an automatic redraw for animation
  }
  strip();
  sleep(delay);
}
void 
my_handle_key(unsigned char key, int x, int y)
{
  int l;
  printf("%d\n",key);
   switch (key) {

   case 27:        // ESC exit
   exit(1);
   break;
   break;
   case 9:        // TAB flip to barchart
//   flipp = 1;
   break;
   case 13:       // ENTER flip to trend diagram
//   flipp=0;
   break;
   case 62:
   factor=factor+1;
   break;
   case 60:
   factor=factor-1;
   break;
   case 83:        // S Hold
   start_stop=1;
   break;
   case 115:       // s Resume
   start_stop=0;
   break;



   case 104:       // help
   printf("**************************************************************\n");
   printf("* List of key-press functions:                               *\n");
   printf("* ----------------------------                               *\n");
   printf("* h  : list this on screen                                   *\n");
   printf("* esc: exit                                                  *\n");
   printf("* u  : increase amplitude on all channels                    *\n");
   printf("* d  : decrease amplitude on all channels                    *\n");
   printf("* S  : freeze graphics                                       *\n");
   printf("* s  : resume graphics                                       *\n");
   printf("* n  : next channel                                          *\n");
   printf("* +  : increase amplitude on current channel                 *\n");
   printf("* -  : decrease amplitude on current channel                 *\n");
   printf("* F  : turn on pre-set filter                                *\n");
   printf("* f  : turn off filtering                                    *\n");
   printf("* 1  : Set color scheme to default                           *\n");
   printf("* 2  : Color scheme 2                                        *\n");
   printf("* 3  : Color scheme 3                                        *\n");
   printf("* 4  : Color scheme 4                                        *\n");
   printf("**************************************************************\n"); 
   break;

   default:
      break;
   }
  printf("%4.1f %4.1f %4.1f\n",R,G,B);
}
void draw_square(int x1,int y1,int x2,int y2)
{
  glBegin(GL_LINES);        // draw box # 1
  glVertex2f(x1-(WINL/2), y1-(WINH/2));
  glVertex2f(x2-(WINL/2), y1-(WINH/2));

  glVertex2f(x2-(WINL/2), y1-(WINH/2));
  glVertex2f(x2-(WINL/2), y2-(WINH/2));

  glVertex2f(x2-(WINL/2), y2-(WINH/2));
  glVertex2f(x1-(WINL/2), y2-(WINH/2));

  glVertex2f(x1-(WINL/2), y2-(WINH/2));
  glVertex2f(x1-(WINL/2), y1-(WINH/2));
  glEnd();
}
void strip()
{
  int     yrn;                   // Date and time for time-stamp and time corr.
  int     mon;                   // -----------------"-------------------------
  int     day;                   // -----------------"-------------------------
  int     hrn;                   // -----------------"-------------------------
  int     min;                   // -----------------"-------------------------
  int     doy;                   // -----------------"-------------------------
  float    sek;                   // -----------------"-------------------------
  double   MSEC;
  int   p;
  int   g;
  int   l;
  int   j;
  int   k1,l1,m1;
  float scale;
  float R;
  float G;
  float B;
  int i;
  int   last;
  int   sek_int;
  int   last_min;
  int   mod_sek;
  int   mod_min;
  int   xval;
  float xlast;
  float fseks;
  float fstep;
  float seks5;
  float step_min;
  char tekst1[80];
  char tekst2[80];
  char tekst3[80];
  char seks[10];
  char dum[20];
  
  char tmp[80];
  char sta[10];
  glColor3f(0.0, 0.0, 0.0);
  glRecti(-WINL/2,-WINH/2,WINL/2,WINH/2);
//********** Plot gray scale lines with scale numbers *****************
  glColor3f(0.3,0.3,0.3);              // set color to gray
  for(p=0;p<30;p=p+2)
  {
    glBegin( GL_LINES );               // Plot scale-lines
    glVertex2f( -WINL/2, (p * factor)-(WINH/2+0) );
    glVertex2f( WINL/2, (p * factor)-(WINH/2+0) );
    glEnd();
    sprintf(tekst1,"%2d",p);
    bitmap_output(WINL/2-20,(p * factor)-(WINH/2+0) , tekst1,GLUT_BITMAP_9_BY_15 );
  }

  for(p=0;p<no_stations;p++)
    yyy[p][teller]=spt->csta[klon][p]/spt->clta[klon][p] * factor -(WINH/2+0);

  teller++;
  if((teller * step) > (WINL-100))
  {
    teller--;
    for(p=0;p<no_stations;p++)
    {
      for(i=0;i<teller;i++)
        yyy[p][i]=yyy[p][i+1];
    }
  }

  for(i=0;i<no_stations;i++)
  {
    switch(i)
    {
      case 0:
      case 16:
      case 32:
      R=1.0;       // white
      G=1.0;
      B=1.0;
      break;
      case 1:
      case 17:
      case 33:
      R=1.0;       // yellow
      G=1.0;
      B=0.0;


      break;
      case 2:
      case 18:
      case 34:
      R=0.0;       // blue
      G=0.0;
      B=1.0;
      break;
      case 3:
      case 19:
      case 35:
      R=0.498;     // chartreuse
      G=1.0;
      B=0.0;

      break;
      case 4:
      case 20:
      case 36:
      R=0.647;     // brown
      G=0.164;
      B=0.164;
      break;
      case 5:
      case 21:
      case 37:
      R=1.0;       // red
      G=0.0;
      B=0.0;
      break;
      case 6:
      case 22:
      case 38:
      R=0.662;     // dark gray
      G=0.662;
      B=0.662;
      break;
      case 7:
      case 23:
      case 39:
      R=0.54;      // blue-violet
      G=0.168;
      B=0.886;
      break;
      case 8:
      case 24:
      case 40:
      R=0.0;       // dark green
      G=0.392;
      B=0.0;
      break;
      case 9:
      case 25:
      case 41:
      R=0.333;     // dark olive
      G=0.419;
      B=0.184;
      break;
      case 10:
      case 26:
      case 42:
      R=1.0;       // dark orange
      G=0.549;
      B=0.0;
      break;
      case 11:
      case 27:
      case 43:
      R=0.545;     // dark magenta
      G=0.0;
      B=0.545;
      break;
      case 12:
      case 28:
      case 44:
      R=0.294;     // indigo
      G=0.0;
      B=0.509;
      break;
      case 13:
      case 29:
      case 45:
      R=0.0;       // agua
      G=1.0;
      B=1.0;
      break;
      case 14:
      case 30:
      case 46:
      R=0.0;       // navy
      G=0.0;
      B=0.501;
      break;
      case 15:
      case 31:
      case 47:
      R=0.372;     // cadet blue
      G=0.619;
      B=0.627;
      break;
    }
    xold=xstart;
    yold=yyy[i][0];
    for(j=0;j<(teller-1);j++)
    {
      xnew=xold+step;
      ynew=yyy[i][j+1];
      glColor3f(R,G,B);
      glBegin( GL_LINES);
      glVertex2f(xold,yold);
      glVertex2f(xnew,ynew);
      glEnd();
      xold=xnew;
      yold=ynew;
    }

    for(g=0;g<5;g++)
      sta[g]=station_name[i][g+3];
    sta[g]='\0';
    sprintf(tekst1,"%s",spt->stasjon[klon][i]);
    sprintf(tekst1,"%s",spt->trig_stations[klon][i]);   
    bitmap_output(xold, yold, tekst1,GLUT_BITMAP_9_BY_15 );
    if(i==0)
    {
      R=0.0;
      G=1.0;
      B=0.0;
      glColor3f(R,G,B);
      sprintf(tekst2,"%s",spt->rtid[klon][i]);
      bitmap_output(-100, WINH/2-16, tekst2,GLUT_BITMAP_9_BY_15 );
      sscanf(tekst2,"%4d%1c%3d%1c%2d%1c%2d%1s%f",
&yrn,dum,&doy,dum,&hrn,dum,&min,dum,&sek);

// Make time scaling                   // min  = 14   sek     = 34.4700
      mod_min = min % 5;               // mod_min = 14 % 5 = 4
//      printf("mod_min: %d\n",mod_min);
      seks5= mod_min * 60 + sek;       // seks5   = 4 * 60 + 34.4700 = 240 + 34.4700 = 274.4700
//-- convert from doy to date  
      DTE (doy,&day,&mon,&yrn);
      TIMSEC(yrn,mon,day,hrn,min,sek,&MSEC);
      MSEC = MSEC - seks5;
      MSEC = MSEC + 0.001;
      fstep = seks5/3.0;              // fstep   = 274.4700/3.0 = 91.49
      last_min = (int)fstep;          // fstep   = 91
      xval = xold - last_min;
//      printf("%4d %3d %2d:%2d:%6.3f %2d %8.3f %8.3f %3d %4d\n",yrn,doy,hrn,min,sek,mod_min,seks5,fstep,last_min,xval);
      SECTIM(MSEC,&yrn,&doy,&mon,&day,&hrn,&min,&sek); 
//      printf("%4d %3d %2d:%2d:%6.3f\n",yrn,doy,hrn,min,sek);
      sprintf(tekst3,"%2d:%2d",hrn,min);
      if(tekst3[3] == ' ') tekst3[3] = '0';
      if(tekst3[3] == '0' && tekst3[4] == '0')
      {
        R=0.2;
        G=0.2;
        B=1.0;
      }
      bitmap_output(xval-23, WINH/2-37, tekst3,GLUT_BITMAP_9_BY_15 );
      R=0.3;
      G=0.3;
      B=0.3;
      glColor3f(R,G,B);                // set color to gray
      glBegin( GL_LINES );             // Plot scale-lines
      glVertex2f( xval, WINH/2-50 );
      glVertex2f( xval, -WINH/2 );
      glEnd();

      for(l1 = 1; l1 < 12;l1++)
      {
        MSEC = MSEC - (5.0 * 60);
        SECTIM(MSEC,&yrn,&doy,&mon,&day,&hrn,&min,&sek);
        sprintf(tekst3,"%2d:%2d",hrn,min);
        if(tekst3[3] == ' ') tekst3[3] = '0';

        xval = xval -100;
        R=0.0;
        G=1.0;
        B=0.0;
        if(tekst3[3] == '0' && tekst3[4] == '0')
        {
          R=0.2;
          G=0.2;
          B=1.0;
        }
        bitmap_output(xval-23, WINH/2-37, tekst3,GLUT_BITMAP_9_BY_15 );
        R=0.3;
        G=0.3;
        B=0.3;
        glBegin( GL_LINES );           // Plot scale-lines
        glVertex2f( xval, WINH/2-50 );
        glVertex2f( xval, -WINH/2 );
        glEnd();
      }


    }

  }


  glFlush();
}





int main(int argc, char **argv)
{
  void          *shared_memory_rt = (void *)0;
  int           shmid_rt;
  int p;
  char par[10];
  char title[80];
  ixx=0;
  step=1;


//-------------------------------------------------------------------------
// open shared memory region                                                
//--------------------------------------------------------------------------
//  printf("Size shared module %d\n",(int)sizeof(rtmod));
  shmid_rt = shmget((key_t)5678, sizeof(rtmod), 0666 | IPC_CREAT);
  if(shmid_rt == -1)
  {
    fprintf(stderr, "shmget failed  2\n");
    exit(EXIT_FAILURE);
  }
  shared_memory_rt = shmat(shmid_rt, (void *)0, 0);
  if(shared_memory_rt == (void *)-1)
  {
    fprintf(stderr, "shmat failed\n");
    exit(EXIT_FAILURE);
  }
//-------------------------------------------------------------------------
// Compute pointer to shared memory region                                 
//-------------------------------------------------------------------------
  spt=(rtmod *)shared_memory_rt;
//-------------------------------------------------------------------------
// Process command line parameters
//-------------------------------------------------------------------------
  if (parameter_proc (argc, argv) < 0)
  {
    fprintf(stderr, "Parameter processing failed\n\n");
    fprintf(stderr, "Try '-h' for detailed help\n");
    return -1;
  }



  no_stations = spt->val20[klon];
  
  printf("Stations: %d\n",no_stations);
  xstart = -WINL/2+5;
  ystart = WINH/2-50;
  teller = 0;
  for(p=0;p<no_stations;p++)
    yyy[p][teller]=1;
 
  ixx=0;
  teller++;
//  printf("ystart: %d WINL: %d WINH: %d\n",ystart,WINL,WINH);
//*******************************************************************
// Set up for OpenGL graphics
//*******************************************************************
  glutInit(&argc,argv);

// We're going to animate it, so double buffer 
//  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
// Window position (from top corner), and size (width% and hieght)
  glutInitWindowPosition( xo, yo );

// Set window size in pixels
  glutInitWindowSize( WINL, WINH );

// Create window with title given in parameters
  sprintf(title,"STA/LTA MONITORING    Parameter-set: %d",klon+1);
  glutCreateWindow( title );

  glColor3f(0.0, 0.0, 0.0);
  glRecti(-WINL/2,-WINH/2,WINL/2,WINH/2);

// Detects a key-press. ESC exits program
   glutKeyboardFunc(my_handle_key);


// call this whenever window needs redrawing
  glutDisplayFunc( drawScene );

  glutReshapeFunc(my_reshape);


// Start the main loop.  glutMainLoop never returns.
  glutMainLoop(  );

  return 0;

}
void TIMSEC (YR,MTH,DAY,HR,MIN,SECS,MSECS)                         
int YR;
int MTH;
int DAY;
int HR;
int MIN;
float SECS;
double *MSECS;                         /* total seconds to be returned      */
{
int DYR;                               /* flag for leap year                */
int IYR;                               /* number of leap-years since 1900   */
int YDY;                               /* number of days in current year    */

if(YR <= 50) YR=YR+100;                /* check for 2000 or more in 2 digits*/

if(YR >= 1900) YR=YR - 1900;
DYR = 0;
if((YR % 4) == 0) DYR = 1;
IYR = YR/4 - DYR;
//                -- Seconds to beginning of     
*MSECS = (float)(IYR*366) + (float)((YR-IYR)*365);
//                -- current year                
*MSECS = *MSECS*86400.0;
//                -- January                     
if (MTH == 1) YDY = DAY;
//                -- February                    
if (MTH == 2) YDY = DAY + 31;
//                -- ....                        
if (MTH == 3) YDY = DAY + DYR + 59;       
if (MTH == 4) YDY = DAY + DYR + 90;                                     
if (MTH == 5) YDY = DAY + DYR + 120;                                    
if (MTH == 6) YDY = DAY + DYR + 151;                                    
if (MTH == 7) YDY = DAY + DYR + 181;                                    
if (MTH == 8) YDY = DAY + DYR + 212;                                    
if (MTH == 9) YDY = DAY + DYR + 243;                                    
if (MTH ==10) YDY = DAY + DYR + 273;                                    
if (MTH ==11) YDY = DAY + DYR + 304;                                    
if (MTH ==12) YDY = DAY + DYR + 334;                                    
*MSECS = *MSECS + (float)(YDY*86400 + HR*3600 + MIN*60) + SECS;
}

void SECTIM (MSECS,YR,DOY,MTH,DAY,HR,MIN,SEC)                      
double MSECS;
int *YR;
int *DOY;
int *MTH;
int *DAY;
int *HR;
int *MIN;
float *SEC;
{
int DDAY,MMTH;
//             -- Temporary seconds         
double SSEC;
//             -- Seconds per day           
double SECDAY;
//             -- Seconds per year          
double SECYR;
//              -- Leap-year indicators      
float  IND, SIN;
//              -- Counter                   
int    I;
SECDAY=86400.0;
SECYR =31536000.0;
//*-------------------------------------------------------------------------      
//*  Find year:                                                                   
//*                                                                               
SSEC = 0.0;
for(I=1;I<201;I++)
{
    IND = 0.0;
//               -- Leap year                 
    if ((I%4) == 0) IND = 1.0;
//               -- Add years                 
    SSEC = SSEC + SECYR + IND*SECDAY;
//               -- Year found                
    if (SSEC > MSECS) goto found;              
        SIN = IND;
}
found:                                                              
*YR = I - 1;
//*                                                                               
//*  Find day-of-year and date:                                                   
//*                                                                               
//c-- Reset remaining seconds   
SSEC = MSECS - (SSEC - SECYR - IND*SECDAY);

for(I=1;I<367;I++)
{
    SSEC = SSEC - SECDAY;
    if (SSEC < 0) goto incr;                                              
}
incr:

I = I - 1;
//           -- 366 days of year          
if (SIN > 0.0) I = I + 1;
//           --                           
if (I == 0)
{                           
//           -- Justifying if change      
    *YR = *YR - 1;
//           -- of year                   
    I  = 365;                                  
    if ((*YR%4) == 0) I = 366;
}


*DOY = I;
//-- convert from doy to date  
DTE (I,&DDAY,&MMTH,*YR);
*DAY=DDAY;
*MTH=MMTH;


if(*YR >= 100) *YR=*YR-100;            /* test for year 2000 or more        */





//*                                                                               
//*  Find hour:                                                                   
//*                                                                               
SSEC = SSEC + SECDAY;

for(I=1;I<25;I++)
{
    SSEC = SSEC - 60.0*60.0;
    if (SSEC < 0) goto seks;                                              
}
seks:
*HR = I - 1;
//*                                                                               
//*  Find minutes and remaining seconds:                                          
//*                                                                               
SSEC = SSEC + 60.0*60.0;
for(I=1;I<61;I++)
{
    SSEC = SSEC - 60.0;
    if (SSEC < 0) goto otte;
}
otte:                                              
   *MIN = I - 1;
   *SEC = SSEC + 60.0;
if(*YR < 50)
{
    *YR=*YR+2000;
}else{
    *YR=*YR+1900;
}
}
//*=========================================================================      
//*                                                                               
//* Routine to convert from day-of-year to date                                   
//*                                                         Leif Kvamme 12-1-85   
void DTE (DOY,DAY,MON,YR)                                          
int DOY;
int *DAY;
int *MON;
int YR;
{
int MTH[14],J,M,N;
for(J=1;J<8;J=J+2)
    MTH[J] = 31;
for(J=8;J<13;J=J+2)
    MTH[J] = 31;
MTH[2] = 28;
MTH[4] = 30;
MTH[6] = 30;
MTH[9] = 30;
MTH[11]= 30;
if ((YR%4) == 0) MTH[2] = 29;
M = 0;                                                                    
for(J=1;J<13;J++)
{
    M = M + MTH[J];
    N = DOY - M;                                                              
    if (N <= 0)
    {                                                       
        *MON = J;
        *DAY = N + MTH[J];                                                     
        goto four;                                                               
    }
}
four:                                                                   
J=0;
}
/***************************************************************************
 * parameter_proc:
 *
 * Process the command line parameters.
 *
 * Returns 0 on success, and -1 on failure
 ***************************************************************************/
static int
parameter_proc (int argcount, char **argvec)
{
  int optind;
  int error = 0;
//  int i;
  char tm[80];  
  
 char *streamfile   = 0;	    /* stream list file for configuring streams */
 char *stationfile  = 0;      /* station list file for reading streams */
 char *recordfile   = 0;        // station list for recording

  char *multiselect = 0;
  char *selectors   = 0;

//  if (argcount <= 1)
//    error++;

  /* Process all command line arguments */
  for (optind = 1; optind < argcount; optind++)
  {
    if (strcmp (argvec[optind], "-h") == 0)
    {
      usage();
      exit (0);
    }
    else if (strcmp (argvec[optind], "-par") == 0)
    {
      klon = atoi (argvec[++optind]);
      printf("klon= %d\n",klon);
    }
    else if (strcmp (argvec[optind], "-x") == 0)
    {
      WINL = atoi (argvec[++optind]);
      printf("WINL= %d\n",WINL);
    }
    else if (strcmp (argvec[optind], "-y") == 0)
    {
      WINH = atoi (argvec[++optind]);
      printf("WINH= %d\n",WINH);
    }
    else if (strcmp (argvec[optind], "-xo") == 0)
    {
      xo = atoi(argvec[++optind]);
    }
    else if (strcmp (argvec[optind], "-yo") == 0)
    {
      yo = atoi(argvec[++optind]);
    }
    else if (strcmp (argvec[optind], "-dly") == 0)
    {
      delay = atoi (argvec[++optind]);
      printf("delay= %d\n",delay);
    }
    else if (strcmp (argvec[optind], "-fac") == 0)
    {
      factor = atoi(argvec[++optind]);
      printf("factor: %d\n",factor);
    }
    else if (strncmp (argvec[optind], "-", 1 ) == 0)
    {
      fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
      exit (1);
    }
    else
    {
      fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
      exit (1);
    }
  }

/* If errors then report the usage message and quit */
  if (error)
    {
      usage ();
      exit (1);
    }


  return 0;
}				/* End of parameter_proc() */

/***************************************************************************
 * getoptval:
 * Return the value to a command line option; checking that the value is 
 * itself not an option (starting with '-') and is not past the end of
 * the argument list.
 *
 * argcount: total arguments in argvec
 * argvec: argument list
 * argopt: index of option to process, value is expected to be at argopt+1
 *
 * Returns value on success and exits with error message on failure
 ***************************************************************************/
static char *
getoptval (int argcount, char **argvec, int argopt)
{
  if ( argvec == NULL || argvec[argopt] == NULL ) {
    fprintf (stderr, "getoptval(): NULL option requested\n");
    exit (1);
  }
  
  /* Special case of '-o -' usage */
  if ( (argopt+1) < argcount && strcmp (argvec[argopt], "-o") == 0 )
    if ( strcmp (argvec[argopt+1], "-") == 0 )
      return argvec[argopt+1];
  
  if ( (argopt+1) < argcount && *argvec[argopt+1] != '-' )
    return argvec[argopt+1];

  fprintf (stderr, "Option %s requires a value\n", argvec[argopt]);
  exit (1);
}  /* End of getoptval() */

/***************************************************************************
 * usage:
 * Print the usage message and exit.
 ***************************************************************************/
static void
usage (void)
{


  fprintf (stderr, "\nCommand: %s [options]\n\n", PACKAGE);
  fprintf (stderr,
           "Options:\n"
	   " -h             show this usage message\n"
           "\n"
           " -par n         instance  parameter set. (default: 0)\n"
//           " -x   n         window size in pixels horizontal (default: 1000)\n"
//           " -y   n         window size in pixels vertical (default: 300)\n"
           " -xo  pixels    position of window x-direction (default: 0)\n"
           " -yo  pixels    position of window y-direction (default: 0)\n"
//           " -dly n         seconds delays between update of screen (default: 3)\n"
//           " -fac n         scale factor vertical (default: 10)\n"
           "\n");


}				/* End of usage() */


